# by 2boom
from Screens.Screen import Screen
from Screens.Console import Console
from Components.MenuList import MenuList
from Components.ActionMap import ActionMap
from Plugins.Plugin import PluginDescriptor

class InstFromTMP(Screen):
	skin = """
		<screen position="center,150" size="550,212" title="Install ipk, tar.gz from /tmp" >
			<widget name="menu" position="20,10" size="510,192" scrollbarMode="showOnDemand" itemHeight="48"/>
		</screen>"""

	def __init__(self, session, args = 0):
		self.session = session
		
		list = []
		list.append((" Install tar.gz\n install local *.tar.gz from /tmp", "com_one"))
		list.append((" Install ipk\n install local *.ipk from /tmp", "com_two"))
		list.append((" Andvanced Install ipk\n Install local *.ipk with -force-overwrite", "com_tree"))
		list.append((_(" Exit\n Return in plugin menu"), "exit"))
		
		Screen.__init__(self, session)
		self["menu"] = MenuList(list)
		self["mactionmap"] = ActionMap(["SetupActions"],
		{
			"ok": self.go,
			"cancel": self.cancel
		}, -1)

	def go(self):
		returnValue = self["menu"].l.getCurrentSelection()[1]
		print "\n[InstFromTMP] returnValue: " + returnValue + "\n"
		
		if returnValue is not None:
			if returnValue is "com_one":
				self.prombt("tar -C/ -xzpvf /tmp/*.tar.gz")
				
			elif returnValue is "com_two":
				self.prombt("opkg install /tmp/*.ipk")
					
			elif returnValue is "com_tree":
				self.prombt("opkg install -force-overwrite /tmp/*.ipk")
		
			else:
				print "\n[InstFromTMP] cancel\n"
				self.close(None)

	def prombt(self, com):
		self.session.open(Console,_("start shell com: %s") % (com), ["%s" % com])
		
	def cancel(self):
		print "\n[InstFromTMP] cancel\n"
		self.close(None)

def main(session, **kwargs):
	print "\n[InstFromTMP] start\n"	
	session.open(InstFromTMP)

def Plugins(**kwargs):
	return PluginDescriptor(
			name="Install from /tmp",
			description="install *.ipk, *.tar.gz",
			where = PluginDescriptor.WHERE_PLUGINMENU,
			icon="plinst.png",
			fnc=main)

