# -*- coding: UTF-8 -*-
###############################################################################
# TMBD details plugin for enigma2
#
# Coded by Nikolasi and Dima73 (c) 2013
# Version: 5.0-rc10 (25.07.2013 21:00)
# Support: http://dream.altmaster.net
#
# This module is free software; you can redistribute it and/or modify it under
# the terms of the GNU Lesser General Public License as published by the Free
# Software Foundation; either version 2 of the License, or (at your option) any
# later version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more
# details.
#
# You should have received a copy of the GNU Lesser General Public License along
# with this program; if not, write to the Free Software Foundation, Inc., 59
# Temple Place, Suite 330, Boston, MA 0.1.2-1307 USA
###############################################################################

from Plugins.Plugin import PluginDescriptor
from twisted.web.client import downloadPage
from threading import Thread
from enigma import ePicLoad, loadPNG, eServiceReference, eTimer, eServiceCenter, eListboxPythonMultiContent, getDesktop, ePoint, eSize, iPlayableService, gFont, RT_WRAP, RT_VALIGN_TOP, RT_HALIGN_CENTER, RT_VALIGN_CENTER, RT_HALIGN_LEFT, RT_HALIGN_RIGHT
from Screens.Screen import Screen
from Screens.EpgSelection import EPGSelection
from Screens.InfoBarGenerics import InfoBarSeek, InfoBarCueSheetSupport
from Screens.ChannelSelection import SimpleChannelSelection
from Screens.MovieSelection import MovieSelection, SelectionEventInfo
#from Screens import MovieSelection as myMovieSelection
from Screens.MessageBox import MessageBox
from Screens.ChoiceBox import ChoiceBox
from Screens.ChannelSelection import ChannelContextMenu, OFF, MODE_TV
from Screens.ChannelSelection import service_types_tv
from Components.ChoiceList import ChoiceEntryComponent
from Tools.BoundFunction import boundFunction
from Components.ActionMap import ActionMap, HelpableActionMap
from Components.ConfigList import ConfigList, ConfigListScreen
from Components.PluginComponent import plugins
from Components.Pixmap import Pixmap
from Components.Label import Label
from Components.ScrollLabel import ScrollLabel
from Components.Button import Button
from Components.AVSwitch import AVSwitch
from Components.MenuList import MenuList
from Components.MovieList import MovieList
from Components.Language import language
from Components.Input import Input
from Components.ServiceEventTracker import InfoBarBase
from Screens.Console import Console
from Screens.InputBox import InputBox
from Components.ProgressBar import ProgressBar
from Components.Sources.StaticText import StaticText
from Components.EpgList import EPGList, EPG_TYPE_SINGLE, EPG_TYPE_MULTI
from Components.Sources.ServiceEvent import ServiceEvent
from Components.Sources.Event import Event
from Components.config import config, ConfigSubsection, ConfigYesNo, ConfigText, getConfigListEntry, ConfigSelection, ConfigInteger
from Tools.Directories import fileExists, resolveFilename, SCOPE_PLUGINS, SCOPE_SKIN_IMAGE, SCOPE_CURRENT_SKIN
from os import environ as os_environ
from os import environ, listdir
from Screens.VirtualKeyBoard import VirtualKeyBoard
from ServiceReference import ServiceReference
import re
import os, sys
import gettext, random
import tmdb, urllib
import array, struct, fcntl
from socket import socket, AF_INET, SOCK_STREAM, SOCK_DGRAM, SHUT_RDWR, gaierror, error
from event import Event, ShortEventDescriptor, ExtendedEventDescriptor
from time import strftime, localtime, mktime
from meta import MetaParser, getctime, fileSize
from os import system as os_system, path as os_path
from Components.MultiContent import MultiContentEntryText, MultiContentEntryPixmapAlphaTest
from httplib import HTTPConnection, CannotSendRequest, BadStatusLine, HTTPException
import kinopoisk, urllib2
from urllib import quote
from urllib2 import Request, URLError, HTTPError, urlopen as urlopen2, quote as urllib2_quote, unquote as urllib2_unquote
import xml.etree.cElementTree
try:
    import ftplib
except:
    pass
import hashlib
IMAGE_PATH2 = resolveFilename(SCOPE_CURRENT_SKIN, 'skin.xml')
control = 0
control2 = 0
dircontrol = False
mp3ntrol = False
login = "aaleks2_tmdb"
passwd = "tmdb_777"

def skinInit():
    global width, control
    fails = resolveFilename(SCOPE_SKIN_IMAGE, IMAGE_PATH2)
    dom_skins = [ ]
    if fileExists(fails):
        try: 
           dom_skins.append((xml.etree.cElementTree.parse(fails).getroot()))
           for skin in dom_skins:
              for c in skin.findall('screen'):
                  id = c.attrib.get('name')
                  if id == 'KinoRu':
                      for res in c.findall('widget'):
                          get_attr = res.attrib.get
                          xres = get_attr('name')
                          if xres == 'menu':
                              size = get_attr('size')
                              if size:
                                  width, height = [int(x) for x in size.split(",")]
                                  control = 1
                                  break
        except:
              pass
        
esize = 0
esize2 = 0

def localeInit():
	lang = language.getLanguage()[:2] # getLanguage returns e.g. "fi_FI" for "language_country"
	os_environ["LANGUAGE"] = lang # Enigma doesn't set this (or LC_ALL, LC_MESSAGES, LANG). gettext needs it!
	gettext.bindtextdomain("TMBD", resolveFilename(SCOPE_PLUGINS, "Extensions/TMBD/locale"))

def _(txt):
	t = gettext.dgettext("TMBD", txt)
	if t == txt:
		#print("[TMBD] fallback to default translation for", txt)
		t = gettext.gettext(txt)
	return t

localeInit()
language.addCallback(localeInit)

def getID3Tags(root,filename):
        from mutagen.flac import FLAC
        from mutagen.mp3 import MP3
        from mutagen.id3 import ID3, USLT
        from mutagen.easyid3 import EasyID3
        from mutagen.easymp4 import EasyMP4
        from mutagen.oggvorbis import OggVorbis
        from os import path as os_path
        from datetime import timedelta as datetime_timedelta
        from time import time        
	audio = None
	isFlac = False
	isAudio = True
	title = ""
	genre = ""
	artist = ""
	album = ""
	tracknr = -1
	track = None
	date = None
	length = ""
	bitrate = None
	if filename.lower().endswith(".mp3"):
		try: audio = MP3(os_path.join(root,filename), ID3 = EasyID3)
		except: audio = None
	elif filename.lower().endswith(".flac"):
		try: 
			audio = FLAC(os_path.join(root,filename))
			isFlac = True
		except: audio = None
	elif filename.lower().endswith(".m4a"):
		try: audio = EasyMP4(os_path.join(root,filename))
		except: audio = None
	elif filename.lower().endswith(".ogg"):
		try: audio = OggVorbis(os_path.join(root,filename))
		except: audio = None
	else:
		isAudio = False
	if audio:
		title = getEncodedString(audio.get('title', [filename])[0])
		try:
			# list index out of range workaround
			genre = getEncodedString(audio.get('genre', ['n/a'])[0])
		except:
			genre = "n/a"
		artist = getEncodedString(audio.get('artist', ['n/a'])[0])
		album = getEncodedString(audio.get('album', ['n/a'])[0])
		try:
			tracknr = int(audio.get('tracknumber', ['-1'])[0].split("/")[0])
		except:
			tracknr = -1
		track = getEncodedString(audio.get('tracknumber', ['n/a'])[0])
		date = getEncodedString(audio.get('date', ['n/a'])[0])
		try:
			length = str(datetime_timedelta(seconds=int(audio.info.length))).encode("utf-8", 'ignore')
		except:
			length = -1
		if not isFlac:
			bitrate = audio.info.bitrate / 1000
		else:
			bitrate = None
	else:
		if isAudio:
			title = os_path.splitext(os_path.basename(filename))[0]
			genre = "n/a"
			artist = "n/a"
			album = "n/a"
			tracknr = -1
			track = None
			date = None
			length = ""
			bitrate = None

	return audio, isAudio, title, genre ,artist, album, tracknr, track, date, length, bitrate

def getEncodedString(value):
	returnValue = ""
	try:
		returnValue = value.encode("utf-8", 'ignore')
	except UnicodeDecodeError:
		try:
			returnValue = value.encode("iso8859-1", 'ignore')
		except UnicodeDecodeError:
			try:
				returnValue = value.decode("cp1252").encode("utf-8")
			except UnicodeDecodeError:
				returnValue = "n/a"
	return returnValue    

def decodeName(string):
    m = hashlib.md5()
    m.update(string)
    name = m.hexdigest()
    return name

def controlFtp():
    message = _('Sorry, ftp connection is not available')
    try:
        ftp = ftplib.FTP('81.222.215.241')
        ftp.login(login, decodeName(passwd))
        ftp.quit()
        message = ''
    except:
        pass
    return message

def MenuBild(name, idicon, starss):
        global width, control
        if control == 1:
             width2 = width
        else:
            width2 = 760 
        esize = width2 - 94
        esize2 = width2 - 91
	res = [(name, idicon, starss)]
	myicon = ""
	picon = ePicLoad()
	ramka = resolveFilename(SCOPE_PLUGINS, "Extensions/TMBD/ramka.png")
	starss2 = resolveFilename(SCOPE_PLUGINS, "Extensions/TMBD/starsbar/0.png")
	myicon2 = resolveFilename(SCOPE_PLUGINS, "Extensions/TMBD/no_poster2.jpg")
	url = "http://st.kinopoisk.ru/images/sm_film/%s.jpg" % (idicon)
	myicon = checkIcon(str(url))
        piconWidth = 62
        piconHeight = 92
        picon.setPara((piconWidth, piconHeight, 1, 1, False, 1, '#ffffffff'))
	if myicon is None:
            picon.startDecode(myicon2, 0, 0, False)
        else:
            picon.startDecode(myicon, 0, 0, False)
	pixmap = picon.getData()
	if config.plugins.tmbd.kinoprofilfull.value == "0":
	    if config.plugins.tmbd.kinoprofilramka.value:
	            res.append(MultiContentEntryPixmapAlphaTest(pos=(0, 4), size=(62, 92), png=loadPNG(ramka)))
	    res.append(MultiContentEntryPixmapAlphaTest(pos=(3, 6), size=(56, 86), png=pixmap))         
	    res.append(MultiContentEntryText(pos=(70, 5), size=(560, 73), font=1, text=name))
	    if fileExists(starss):
	            res.append(MultiContentEntryPixmapAlphaTest(pos=(70, 77), size=(210, 21), png=loadPNG(starss)))
	    else:
                    res.append(MultiContentEntryPixmapAlphaTest(pos=(70, 77), size=(210, 21), png=loadPNG(starss)))
        else:
	    if config.plugins.tmbd.kinoprofilramka.value:	    
	            res.append(MultiContentEntryPixmapAlphaTest(pos=(esize, 4), size=(62, 92), png=loadPNG(ramka)))
	    res.append(MultiContentEntryPixmapAlphaTest(pos=(esize2, 6), size=(56, 86), png=pixmap))	            
	    res.append(MultiContentEntryText(pos=(2, 5), size=(width2 - 97, 73), font=1, text=name))
	    if fileExists(starss):
	            res.append(MultiContentEntryPixmapAlphaTest(pos=(2, 77), size=(210, 21), png=loadPNG(starss)))
	    else:
                    res.append(MultiContentEntryPixmapAlphaTest(pos=(2, 77), size=(210, 21), png=loadPNG(starss)))                
	return res

def checkIcon(filename):
                pluginpath = config.plugins.tmbd.kinoprofilparts.value
                if not fileExists(pluginpath):
                    os.system("mkdir %s" % pluginpath)
		parts = filename.split("/")
		totsp = (len(parts) -1)
		localfile = pluginpath + "/" + parts[totsp]
		if fileExists(localfile):
			pass
		else:
			url = filename
                        user_agent = 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_7_3) AppleWebKit/534.53.11 (KHTML, like Gecko) Version/5.1.3 Safari/534.53.10'
			req = urllib2.Request(url, headers = {'User-agent': user_agent, 'Accept': 'text/html'})
			try:
			     handler = urllib2.urlopen(req)
			except (URLError, HTTPException) as err:
				print 'The server couldn\'t fulfill the request.'
				handler = None
			if handler != None:
				content = handler.read()
				fileout = open(localfile, "wb")
				fileout.write(content)
    				handler.close()
				fileout.close()
		        else:
                                localfile = resolveFilename(SCOPE_PLUGINS, "Extensions/TMBD/no_poster2.jpg") 
                                return 				
		return localfile

def MenuBildTMBD(name, idicon):
	res = [(name, idicon)]
	myicon = ""
	picon = ePicLoad()
	ramka = resolveFilename(SCOPE_PLUGINS, "Extensions/TMBD/ramka.png")
	myicon2 = resolveFilename(SCOPE_PLUGINS, "Extensions/TMBD/no_poster2.jpg")
	if idicon != "None":
	    myicon = checkIcon(str(idicon))
	else:
            myicon = resolveFilename(SCOPE_PLUGINS, "Extensions/TMBD/no_poster2.jpg")
        piconWidth = 62
        piconHeight = 92
        picon.setPara((piconWidth, piconHeight, 1, 1, False, 1, '#ffffffff'))
	if myicon is None:
            picon.startDecode(myicon2, 0, 0, False)
        else:
            picon.startDecode(myicon, 0, 0, False)
	pixmap = picon.getData()
	if config.plugins.tmbd.kinoprofilramka.value:
	            res.append(MultiContentEntryPixmapAlphaTest(pos=(0, 4), size=(62, 92), png=loadPNG(ramka)))
	res.append(MultiContentEntryPixmapAlphaTest(pos=(3, 6), size=(56, 86), png=pixmap))         
	res.append(MultiContentEntryText(pos=(70, 5), size=(560, 73), font=1, text=name))
	return res	    

TMDB_LANGUAGE_CODES = {
  'en': 'eng',
  'ru': 'rus',
  'fr': 'fra',
  'bg': 'bul',  
  'it': 'ita',
  'po': 'pol',
  'lv': 'lav',
  'de': 'ger',
  'da': 'dan',
  'nl': 'dut',
  'fi': 'fin',
  'el': 'gre',
  'he': 'heb',
  'hu': 'hun',
  'no': 'nor',
  'pt': 'por',
  'ro': 'ron',
  'sk': 'slo',
  'sl': 'slv',
  'es': 'est',
  'sv': 'swe',
  'tr': 'tur',
  'uk': 'ukr',
  'cz': 'cze'
}


SIOCGIFCONF = 0x8912
BYTES = 4096

TMBDInfoBarKeys = [
	["none",_("NONE"),["KEY_RESERVED"]],
	["Red",_("RED"),["KEY_RED"]],
	["Green",_("GREEN"),["KEY_GREEN"]],
	["Yellow",_("YELLOW"),["KEY_YELLOW"]],
	["Radio",_("RADIO"),["KEY_RADIO"]],
	["Text",_("TEXT"),["KEY_TEXT"]],
	["Tv",_("TV"),["KEY_TV"]],
	["Help",_("HELP"),["KEY_HELP"]],
]


def GetLanguageCode():
	lang = config.plugins.tmbd.locale.value
	return TMDB_LANGUAGE_CODES.get(lang, 'rus')

config.plugins.tmbd = ConfigSubsection()
config.plugins.tmbd.locale = ConfigText(default="ru")
config.plugins.tmbd.skins = ConfigSelection(default = "0", choices = [
                        ("0", _("Small poster")), ("1", _("Large poster"))])
config.plugins.tmbd.eit = ConfigSelection(default = "0", choices = [
                        ("0", _("eit")), ("1", _("txt"))])
config.plugins.tmbd.kinoprofil = ConfigSelection(default = "1", choices = [
                        ("0", _("Full view")), ("1", _("Simple view"))])
config.plugins.tmbd.kinoprofilfull = ConfigSelection(default = "0", choices = [
                        ("0", _("Poster left")), ("1", _("Poster right"))])
config.plugins.tmbd.movieselectionparts = ConfigSelection(default = "none", choices = [
       ("none", _("default")), ("/media/usb/MovieDescription", _("usb/MovieDescription")), ("/media/hdd/MovieDescription", _("hdd/MovieDescription"))])
config.plugins.tmbd.kinoprofilparts = ConfigSelection(default = "/media/hdd/Iconkinopoisk", choices = [
       ("/media/hdd/Iconkinopoisk", _("hdd")), ("/tmp/Iconkinopoisk", _("tmp")), ("/media/usb/Iconkinopoisk", _("usb")), ("/usr/share/enigma2/Iconkinopoisk", _("/usr/share/enigma2"))])
config.plugins.tmbd.kinoprofilramka = ConfigYesNo(default=True)
config.plugins.tmbd.kinoprofilposter = ConfigSelection(default = "0", choices = [
                         ("0", _("Standart")), ("1", _("Big poster"))])
config.plugins.tmbd.kinoprofilcolor = ConfigSelection(default = "13823", choices = [
                        ("2237106", _("Blue")), ("13823", _("Blue2")), ("16715021", _("Red")), ("8388608", _("DarkRed")), ("16763955", _("Yellow")), ("39424", _("Green"))])
config.plugins.tmbd.enabled = ConfigYesNo(default=True)
config.plugins.tmbd.virtual_text = ConfigSelection(default = "0", choices = [
                         ("0", _("< empty >")), ("1", _("< text >"))])
config.plugins.tmbd.menu = ConfigYesNo(default=True)
config.plugins.tmbd.movieInfo = ConfigYesNo(default=False)
config.plugins.tmbd.menu_profile = ConfigSelection(default = "0", choices = [
                        ("0", _("only current profile")), ("1", _("List: themoviedb.org / kinopoisk.ru")), ("2", _("List: kinopoisk.ru / themoviedb.org"))])
config.plugins.tmbd.add_tmbd_to_epg = ConfigYesNo(default=False)
config.plugins.tmbd.add_tmbd_to_multi = ConfigYesNo(default=False)
config.plugins.tmbd.add_tmbd_to_graph = ConfigYesNo(default=False)
config.plugins.tmbd.add_ext_menu = ConfigYesNo(default=False)
config.plugins.tmbd.ext_menu_event = ConfigSelection(default = "0", choices = [
                        ("0", _("only current event")), ("1", _("choice now/next event"))])
config.plugins.tmbd.no_event = ConfigYesNo(default=False)
config.plugins.tmbd.test_connect = ConfigYesNo(default=False)
config.plugins.tmbd.exit_key = ConfigSelection(default = "0", choices = [
                        ("0", _("close")), ("1", _("ask user"))])
config.plugins.tmbd.profile = ConfigSelection(default = "0", choices = [
                        ("0", _("themoviedb.org")), ("1", _("kinopoisk.ru (only russian language)"))])
config.plugins.tmbd.position_x = ConfigInteger(default=100)
config.plugins.tmbd.position_y = ConfigInteger(default=100)
config.plugins.tmbd.new_movieselect = ConfigYesNo(default=True)
config.plugins.tmbd.size = ConfigSelection(choices=["285x398", "185x278", "130x200", "104x150"], default="104x150")
config.plugins.tmbd.hotkey = ConfigSelection([(x[0],x[1]) for x in TMBDInfoBarKeys], "none")
config.plugins.tmbd.movielist_profile = ConfigSelection(default = "1", choices = [
                        ("0", _("only current profile")), ("1", _("List: themoviedb.org / kinopoisk.ru")), ("2", _("List: kinopoisk.ru / themoviedb.org"))])
config.plugins.tmbd.add_tmbd_to_nstreamvod = ConfigYesNo(default=False)
config.plugins.tmbd.add_vcs_to_nstreamvod = ConfigYesNo(default=False)


SKIN = """
	<screen position="0,0" size="130,200" zPosition="10" flags="wfNoBorder" backgroundColor="#ff000000" >
		<widget name="background" position="0,0" size="130,200" zPosition="1" backgroundColor="#00000000" />
		<widget name="preview" position="0,0" size="130,200" zPosition="2" alphatest="blend"/>
	</screen>"""


eventname = ""
baseGraphMultiEPG__init__ = None

def GraphMultiEPGInit():
	global baseGraphMultiEPG__init__
	try:
		from Plugins.Extensions.GraphMultiEPG.GraphMultiEpg import GraphMultiEPG
	except ImportError:
		return
	if baseGraphMultiEPG__init__ is None:
		baseGraphMultiEPG__init__ = GraphMultiEPG.__init__
	GraphMultiEPG.__init__ = GraphMultiEPG__init__

def GraphMultiEPG__init__(self, session, services, zapFunc=None, bouquetChangeCB=None, bouquetname=""):
	try:
		baseGraphMultiEPG__init__(self, session, services, zapFunc, bouquetChangeCB, bouquetname)
	except:
		baseGraphMultiEPG__init__(self, session, services, zapFunc, bouquetChangeCB)
	if config.plugins.tmbd.add_tmbd_to_graph.value:
		def showTMBD():
			from Plugins.Extensions.TMBD.plugin import TMBD
			from Plugins.Extensions.TMBD.plugin import KinoRu
			cur = self["list"].getCurrent()
			if cur[0] is not None:
				name2 = cur[0].getEventName()
				name3 = name2.split("(")[0].strip()
				eventname = name3.replace('"', '').replace('Х/Ф', '').replace('М/Ф', '').replace('Х/ф', '').replace('.', '')
				eventname = eventname.replace('(18+)', '').replace('18+', '').replace('(16+)', '').replace('16+', '').replace('(12+)', '').replace('12+', '').replace('(7+)', '').replace('7+', '').replace('(6+)', '').replace('6+', '').replace('(0+)', '').replace('0+', '')				
				if config.plugins.tmbd.profile.value == "0":
					self.session.open(TMBD, eventname, False)
				else:
					self.session.open(KinoRu, eventname, False)
		#self["actions"] = ActionMap(["InfobarEPGActions"], # key GUDE(only ETxx00)
		#self["tmbd_actions"] = ActionMap(["EPGSelectActions"],
		self["tmbd_actions"] = HelpableActionMap(self, "EPGSelectActions",
				{
					"info": (showTMBD, _("Lookup in TMBD")),
				}, -1)

basenStreamVOD__init__ = None
def nStreamVODInit():
	global basenStreamVOD__init__
	try:
		from Plugins.Extensions.nStreamVOD.plugin import nPlaylist
	except ImportError:
		pass
	else:
		if basenStreamVOD__init__ is None:
			basenStreamVOD__init__ = nPlaylist.__init__
			nPlaylist.__init__ = nPlaylist__init__
			nPlaylist.AnswernStreamVOD = AnswernStreamVOD

def nPlaylist__init__(self, session):
	try:
		basenStreamVOD__init__(self, session)
		if config.plugins.tmbd.add_tmbd_to_nstreamvod.value:
			def SelectionInfo():
				from Screens.ChoiceBox import ChoiceBox
				if config.plugins.tmbd.add_vcs_to_nstreamvod.value:
					list = [
						(_("search in TMBD"), "tmbd"),
						(_("standart info"), "info"),
						(_("open plugin VCS"), "vcs"),
					]
				else:
					list = [
						(_("search in TMBD"), "tmbd"),
						(_("standart info"), "info"),
					]
				self.session.openWithCallback(self.AnswernStreamVOD,ChoiceBox,title= _("Select action:"), list = list)
			self["tmbd_actions"] = HelpableActionMap(self, "EPGSelectActions",
					{
						"info": SelectionInfo,
					}, -1)
	except:
		pass

def AnswernStreamVOD(self, ret):
	ret = ret and ret[1]
	if ret:
		if ret == "tmbd":
			try:
				selected_channel = self.channel_list[self.mlist.getSelectionIndex()]
			except:
				selected_channel = None
			if selected_channel is not None:
				try:
					event = selected_channel[1]
				except:
					event = None
				if event is not None and event != "":
					try:
						from Plugins.Extensions.TMBD.plugin import TMBD
						from Plugins.Extensions.TMBD.plugin import KinoRu
						eventname = event.replace('"', '').replace('Х/Ф', '').replace('М/Ф', '').replace('Х/ф', '').replace('.', '')
						if config.plugins.tmbd.profile.value == "0":
							self.session.open(TMBD, eventname, False)
						else:
							self.session.open(KinoRu, eventname, False)
					except:
						pass
		elif ret == "info":
			try:
				self.show_more_info()
			except:
				pass
		elif ret == "vcs":
			try:
				from Plugins.Extensions.VCS.plugin import show_choisebox
				show_choisebox(self.session)
			except:
				pass
		else:
			pass

def_CoolTVGuide_iypxwy = None
	
def new_CoolTVGuide_iypxwy(self, vtrlrx):
        vtrlrx = vtrlrx and vtrlrx[1]
        yrvtmo = self['list'].getCurrent()
        event = yrvtmo[0]
        if not event:
            return
        usxnxv = event and event.getEventName() or ''
        if vtrlrx == 'TMBD':
            from Plugins.Extensions.TMBD.plugin import KinoRu
            eventname = usxnxv.replace('"', '').replace('Х/Ф', '').replace('М/Ф', '').replace('Х/ф', '').replace('.', '')
            self.session.open(KinoRu, eventname, False)

def_CoolTVGuide_pyluqz = None
def new_CoolTVGuide_pyluqz(self):
        ktmwiw = []
        ktmwiw.append((_('TMBD'), 'TMBD'))
        self.session.openWithCallback(self.iypxwy, ChoiceBox, title=_('   CoolInfoBox'), list=ktmwiw)

def_CoolEasyGuide_tutpnw = None
def new_CoolEasyGuide_tutpnw(self, vuvtxt):
        vuvtxt = vuvtxt and vuvtxt[1]
        ktyllm = self['list'].mnqrol()
        event = ktyllm[0]
        if not event:
            return
        name = event and event.getEventName() or ''
        if vuvtxt == 'TMBD':
            from Plugins.Extensions.TMBD.plugin import KinoRu
            eventname = name.replace('"', '').replace('Х/Ф', '').replace('М/Ф', '').replace('Х/ф', '').replace('.', '')
            self.session.open(KinoRu, eventname, False)

def_CoolEasyGuide_suxwuy = None
def new_CoolEasyGuide_suxwuy(self):
        qjzmti = []
        qjzmti.append((_('TMBD'), 'TMBD'))
        self.session.openWithCallback(self.tutpnw, ChoiceBox, title=_('   CoolInfoBox'), list=qjzmti)        

def_CoolChannelGuide_vnqvmy = None
def new_CoolChannelGuide_vnqvmy(self, rulklq):
        rulklq = rulklq and rulklq[1]
        qxwivw = self['list'].nmsxmo()
        event = qxwivw[0]
        if not event:
            return
        name = event and event.getEventName() or ''
        if rulklq == 'TMBD':
            from Plugins.Extensions.TMBD.plugin import KinoRu
            eventname = name.replace('"', '').replace('Х/Ф', '').replace('М/Ф', '').replace('Х/ф', '').replace('.', '')
            self.session.open(KinoRu, eventname, False)

def_CoolChannelGuide_zunyxk = None
def new_CoolChannelGuide_zunyxk(self):
        xxkiut = []
        xxkiut.append((_('TMBD'), 'TMBD'))
        self.session.openWithCallback(self.vnqvmy, ChoiceBox, title=_('   CoolInfoBox'), list=xxkiut)

def_CoolSingleGuide_wzwsvn = None
def new_CoolSingleGuide_wzwsvn(self, vtnjux):
        vtnjux = vtnjux and vtnjux[1]
        ztszrj = self['list'].kmroqw()
        event = ztszrj[0]
        if not event:
            return
        name = event and event.getEventName() or ''
        if vtnjux == 'TMBD':
            from Plugins.Extensions.TMBD.plugin import KinoRu
            eventname = name.replace('"', '').replace('Х/Ф', '').replace('М/Ф', '').replace('Х/ф', '').replace('.', '')
            self.session.open(KinoRu, eventname, False)

def_CoolSingleGuide_pwxiku = None
def new_CoolSingleGuide_pwxiku(self):
        xwzzuk = []
        xwzzuk.append((_('TMBD'), 'TMBD'))
        self.session.openWithCallback(self.wzwsvn, ChoiceBox, title=_('   CoolInfoBox'), list=xwzzuk)

def_CoolInfoGuide_yqlnqm = None
def new_CoolInfoGuide_yqlnqm(self, wyzyjx):
        wyzyjx = wyzyjx and wyzyjx[1]
        kzqlzx = self['CoolEvent'].nvwksm()
        event = kzqlzx[0]
        if not event:
            return
        name = event and event.getEventName() or ''
        if wyzyjx == 'TMBD':
            from Plugins.Extensions.TMBD.plugin import KinoRu
            eventname = name.replace('"', '').replace('Х/Ф', '').replace('М/Ф', '').replace('Х/ф', '').replace('.', '')
            self.session.open(KinoRu, eventname, False)

def_CoolInfoGuide_jzuswv = None
def new_CoolInfoGuide_jzuswv(self):
        usuuur = []
        usuuur.append((_('TMBD'), 'TMBD'))
        self.session.openWithCallback(self.yqlnqm, ChoiceBox, title=_('   CoolInfoBox'), list=usuuur)        
        
baseEPGSelection__init__ = None
def EPGSelectionInit():
	global baseEPGSelection__init__
	if baseEPGSelection__init__ is None:
		baseEPGSelection__init__ = EPGSelection.__init__
	EPGSelection.__init__ = EPGSelection__init__


def EPGSelection__init__(self, session, service, zapFunc=None, eventid=None, bouquetChangeCB=None, serviceChangeCB=None):
	baseEPGSelection__init__(self, session, service, zapFunc, eventid, bouquetChangeCB, serviceChangeCB)
	if self.type == EPG_TYPE_SINGLE and config.plugins.tmbd.add_tmbd_to_epg.value:
		def redPressed():
			from Plugins.Extensions.TMBD.plugin import TMBD
			from Plugins.Extensions.TMBD.plugin import KinoRu
			cur = self["list"].getCurrent()
			if cur[0] is not None:
				name2 = cur[0].getEventName()
				name3 = name2.split("(")[0].strip()
				eventname = name3.replace('"', '').replace('Х/Ф', '').replace('М/Ф', '').replace('Х/ф', '').replace('.', '')
				eventname = eventname.replace('(18+)', '').replace('18+', '').replace('(16+)', '').replace('16+', '').replace('(12+)', '').replace('12+', '').replace('(7+)', '').replace('7+', '').replace('(6+)', '').replace('6+', '').replace('(0+)', '').replace('0+', '')				
				if config.plugins.tmbd.profile.value == "0":
					self.session.open(TMBD, eventname, False)
				else:
					self.session.open(KinoRu, eventname, False)

		self["tmbdActions"] = ActionMap(["EPGSelectActions"],
				{
					"info": redPressed,
				})
		#self["key_red"].setText(_("Lookup in TMBD"))


	elif self.type == EPG_TYPE_MULTI and config.plugins.tmbd.add_tmbd_to_multi.value:
		def infoKeyPressed():
			from Plugins.Extensions.TMBD.plugin import TMBD
			from Plugins.Extensions.TMBD.plugin import KinoRu
			cur = self["list"].getCurrent()
			if cur[0] is not None:
				name2 = cur[0].getEventName()
				name3 = name2.split("(")[0].strip()
				eventname = name3.replace('"', '').replace('Х/Ф', '').replace('М/Ф', '').replace('Х/ф', '').replace('.', '')
				eventname = eventname.replace('(18+)', '').replace('18+', '').replace('(16+)', '').replace('16+', '').replace('(12+)', '').replace('12+', '').replace('(7+)', '').replace('7+', '').replace('(6+)', '').replace('6+', '').replace('(0+)', '').replace('0+', '')
				if config.plugins.tmbd.profile.value == "0":
					self.session.open(TMBD, eventname, False)
				else:
					self.session.open(KinoRu, eventname, False)
						
		self["Tmbdactions"] = ActionMap(["EPGSelectActions"],
				{
					"info": infoKeyPressed,
				})

baseChannelContextMenu__init__ = None
def TMBDChannelContextMenuInit():
	global baseChannelContextMenu__init__
	if baseChannelContextMenu__init__ is None:
		baseChannelContextMenu__init__ = ChannelContextMenu.__init__
	ChannelContextMenu.__init__ = TMBDChannelContextMenu__init__
	ChannelContextMenu.showServiceInformations2 = showServiceInformations2
	ChannelContextMenu.profileContextMenuCallback = profileContextMenuCallback
	ChannelContextMenu.profileMenuCallback = profileMenuCallback

def TMBDChannelContextMenu__init__(self, session, csel):
	baseChannelContextMenu__init__(self, session, csel)
	if csel.mode == MODE_TV:
		current = csel.getCurrentSelection()
		current_root = csel.getRoot()
		current_sel_path = current.getPath()
		current_sel_flags = current.flags
		inBouquetRootList = current_root and current_root.getPath().find('FROM BOUQUET "bouquets.') != -1 #FIXME HACK
		inBouquet = csel.getMutableList() is not None
		isPlayable = not (current_sel_flags & (eServiceReference.isMarker|eServiceReference.isDirectory))
		if isPlayable:
			if config.plugins.tmbd.menu.value:
				if config.plugins.tmbd.menu_profile.value == "0":
					callFunction = self.showServiceInformations2 
					self["menu"].list.insert(0, ChoiceEntryComponent(text = (_("TMBD Details"), boundFunction(callFunction,1))))
				else:
					callFunction = self.profileContextMenuCallback 
					self["menu"].list.insert(0, ChoiceEntryComponent(text = (_("TMBD Details"), boundFunction(callFunction,1))))
			else:
				pass

def showServiceInformations2(self, eventName="", profile = False):
		global eventname
		s = self.csel.servicelist.getCurrent()  
		info = s and eServiceCenter.getInstance().info(s)
		event = info and info.getEvent(s)
		if event != None:
			try:
				epg_name = event.getEventName() or ''
				eventName = epg_name.replace('"', '').replace('Х/Ф', '').replace('М/Ф', '').replace('Х/ф', '').replace('.', '')
				eventName = eventName.replace('(18+)', '').replace('18+', '').replace('(16+)', '').replace('16+', '').replace('(12+)', '').replace('12+', '').replace('(7+)', '').replace('7+', '').replace('(6+)', '').replace('6+', '').replace('(0+)', '').replace('0+', '')
				eventname = eventName
				if config.plugins.tmbd.menu_profile.value == "0":
					if config.plugins.tmbd.profile.value == "0":
						self.session.open(TMBD, eventName)
					else:
						self.session.open(KinoRu, eventName)
				else:
					if profile:
						self.session.open(KinoRu, eventName)
					else:
						self.session.open(TMBD, eventName)
			except ImportError as ie:
				pass

def profileContextMenuCallback(self, add):
	if config.plugins.tmbd.menu_profile.value == "1":
		options = [
				(_("themoviedb.org"), boundFunction(self.showServiceInformations2, profile = False)),
				(_("kinopoisk.ru"), boundFunction(self.showServiceInformations2, profile = True)),
			]
	elif config.plugins.tmbd.menu_profile.value == "2":
		options = [
				(_("kinopoisk.ru"), boundFunction(self.showServiceInformations2, profile = True)),
				(_("themoviedb.org"), boundFunction(self.showServiceInformations2, profile = False)),
			]
	self.session.openWithCallback(self.profileMenuCallback, ChoiceBox, title= _("Choice profile in search:"), list = options)

def profileMenuCallback(self, ret):
	ret and ret[1]()

class ItemList(MenuList):
    def __init__(self, items, enableWrapAround = True):
        MenuList.__init__(self, items, enableWrapAround, eListboxPythonMultiContent)
        self.l.setFont(0, gFont('Regular', 20))
        self.l.setFont(1, gFont('Regular', 21))
        self.l.setFont(2, gFont('Regular', 22))

class TMBDChannelSelection(SimpleChannelSelection):
	def __init__(self, session):
		SimpleChannelSelection.__init__(self, session, _("Channel Selection"))
		self.skinName = "SimpleChannelSelection"

		self["ChannelSelectEPGActions"] = ActionMap(["ChannelSelectEPGActions"],
			{
				"showEPGList": self.channelSelected
			}
		)

	def channelSelected(self):
		ref = self.getCurrentSelection()
		if (ref.flags & 7) == 7:
			self.enterPath(ref)
		elif not (ref.flags & eServiceReference.isMarker):
			self.session.openWithCallback(
				self.epgClosed,
				TMBDEPGSelection,
				ref,
				openPlugin = False
			)

	def epgClosed(self, ret = None):
		if ret:
			self.close(ret)

class TMBDEPGSelection(EPGSelection):
	def __init__(self, session, ref, openPlugin = True):
		EPGSelection.__init__(self, session, ref)
		self.skinName = "EPGSelection"
		self["key_red"].setText(_("Lookup in TMBD"))
		self.openPlugin = openPlugin


	def zapTo(self):
                global eventname
                eventname = ""
                name2 = ""
                name3 = ""                
		cur = self["list"].getCurrent()
		evt = cur[0]
		if evt != None:
			sref = cur[1]
			name2 = evt.getEventName()
			name3 = name2.split("(")[0].strip()
			eventname = name3.replace('"', '').replace('Х/Ф', '').replace('М/Ф', '').replace('Х/ф', '').replace('.', '')
			eventname = eventname.replace('0+', '').replace('(0+)', '').replace('6+', '').replace('(6+)', '').replace('7+', '').replace('(7+)', '').replace('12+', '').replace('(12+)', '').replace('16+', '').replace('(16+)', '').replace('18+', '').replace('(18+)', '')
		
	#def zapTo(self):
	#	self.eventSelected()
		if self.openPlugin:
			if config.plugins.tmbd.profile.value == "0":
				self.session.open(TMBD, eventname)
			else:
				self.session.open(KinoRu, eventname)
		else:
			self.close(eventname)
			

testOK = None
HDSkn = False
movie2 = ""
class TMBD(Screen):

	skin_hd1 = """
		<screen name="TMBD" position="90,90" size="1100,570" title="TMBD Details Plugin">
		<eLabel backgroundColor="#00bbbbbb" position="0,0" size="1100,2" />
		<widget font="Regular;22" name="title" position="20,20" size="760,28" transparent="1" valign="center" />
		<widget alphatest="blend" name="starsbg" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/TMBD/starsbar_empty.png" position="790,10" size="210,21" zPosition="2" />
		<widget name="stars" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/TMBD/starsbar_filled.png" position="790,10"  size="210,21" transparent="1" zPosition="3" />
		<widget font="Regular;20" halign="left" name="ratinglabel" foregroundColor="#00f0b400" position="790,34" size="210,23" transparent="1" />
		<widget font="Regular;20" name="voteslabel" halign="left" position="790,57" size="290,23" foregroundColor="#00f0b400" transparent="1" />
		<widget alphatest="blend" name="poster" position="30,60" size="285,398" />
		<widget name="menu" position="325,100" scrollbarMode="showOnDemand" size="750,130" zPosition="3"  selectionPixmap="/usr/lib/enigma2/python/Plugins/Extensions/TMBD/ig/button1080x25.png" />
		<widget name="detailslabel" position="325,59" size="570,35" font="Regular;19" transparent="1" />  
		<widget font="Regular;20" name="castlabel" position="320,245" size="760,240" transparent="1" />
		<widget font="Regular;20" name="extralabel" position="320,77" size="760,180" transparent="1" />
		<widget font="Regular;18" name="statusbar" position="10,490" size="1080,20" transparent="1" />
		<eLabel backgroundColor="#00bbbbbb" position="0,518" size="1100,2" />
		<ePixmap alphatest="on" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/TMBD/ig/red25.png" position=" 20,532" size="250,38" zPosition="1" />
		<ePixmap alphatest="on" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/TMBD/ig/green25.png" position="290,532" size="250,38" zPosition="1" />
		<ePixmap alphatest="on" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/TMBD/ig/yellow25.png" position="560,532" size="250,38" zPosition="1" />
		<ePixmap alphatest="on" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/TMBD/ig/blue25.png" position="830,532" size="250,38" zPosition="1" />
		<ePixmap pixmap="skin_default/buttons/key_menu.png" position="1048,5" zPosition="1" size="35,25" alphatest="on" />
		<ePixmap pixmap="skin_default/buttons/key_info.png" position="1048,35" zPosition="1" size="35,25" alphatest="on" />
		<widget backgroundColor="#9f1313" font="Regular;20" foregroundColor="#00ff2525" halign="center" name="key_red" position=" 20,536" size="250,38" transparent="1" valign="center" zPosition="2" />
		<widget backgroundColor="#1f771f" font="Regular;20" foregroundColor="#00389416" halign="center" name="key_green" position="290,536" size="250,38" transparent="1" valign="center" zPosition="2" />
		<widget backgroundColor="#a08500" font="Regular;20" foregroundColor="#00bab329" halign="center" name="key_yellow" position="560,536" size="250,38" transparent="1" valign="center" zPosition="2" />
		<widget backgroundColor="#18188b" font="Regular;20" foregroundColor="#006565ff" halign="center" name="key_blue" position="830,536" size="250,38" transparent="1" valign="center" zPosition="2" />
	</screen>"""

	skin_hd = """
		<screen name="TMBD" position="90,90" size="1100,570" title="TMBD Details Plugin">
		<eLabel backgroundColor="#00bbbbbb" position="0,0" size="1100,2" />
		<widget font="Regular;22" name="title" position="20,20" size="760,28" transparent="1" valign="center" />
		<widget alphatest="blend" name="starsbg" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/TMBD/starsbar_empty.png" position="790,10" size="210,21" zPosition="2" />
		<widget name="stars" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/TMBD/starsbar_filled.png" position="790,10" size="210,21" transparent="1" zPosition="3" />
		<widget font="Regular;20" foregroundColor="#00f0b400" halign="left" name="ratinglabel" position="790,34" size="210,23" transparent="1" />
		<widget font="Regular;20" halign="left" name="voteslabel" position="790,57" size="290,23" foregroundColor="#00f0b400" transparent="1" />
		<widget alphatest="blend" name="poster" position="30,60" size="110,180" />
		<widget name="menu" position="170,100" scrollbarMode="showOnDemand" size="920,130" zPosition="3" selectionPixmap="/usr/lib/enigma2/python/Plugins/Extensions/TMBD/ig/button1080x25.png" />
		<widget name="detailslabel" position="325,59" size="570,35" font="Regular;19" transparent="1" />
		<widget font="Regular;20" name="castlabel" position="20,245" size="1060,240" transparent="1" />
		<widget font="Regular;20" name="extralabel" position="164,77" size="920,180" transparent="1" />
		<widget font="Regular;18" foregroundColor="#00cccccc" name="statusbar" position="10,490" size="1080,20" transparent="1" />
		<eLabel backgroundColor="#00bbbbbb" position="0,518" size="1100,2" />
		<ePixmap alphatest="on" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/TMBD/ig/red25.png" position=" 20,532" size="250,38" zPosition="1" />
		<ePixmap alphatest="on" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/TMBD/ig/green25.png" position="290,532" size="250,38" zPosition="1" />
		<ePixmap alphatest="on" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/TMBD/ig/yellow25.png" position="560,532" size="250,38" zPosition="1" />
		<ePixmap alphatest="on" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/TMBD/ig/blue25.png" position="830,532" size="250,38" zPosition="1" />
		<ePixmap pixmap="skin_default/buttons/key_menu.png" position="1048,5" zPosition="1" size="35,25" alphatest="on" />
		<ePixmap pixmap="skin_default/buttons/key_info.png" position="1048,35" zPosition="1" size="35,25" alphatest="on" />
		<widget backgroundColor="#9f1313" font="Regular;20" foregroundColor="#00ff2525" halign="center" name="key_red" position=" 20,536" size="250,38" transparent="1" valign="center" zPosition="2" />
		<widget backgroundColor="#1f771f" font="Regular;20" foregroundColor="#00389416" halign="center" name="key_green" position="290,536" size="250,38" transparent="1" valign="center" zPosition="2" />
		<widget backgroundColor="#a08500" font="Regular;20" foregroundColor="#00bab329" halign="center" name="key_yellow" position="560,536" size="250,38" transparent="1" valign="center" zPosition="2" />
		<widget backgroundColor="#18188b" font="Regular;20" foregroundColor="#006565ff" halign="center" name="key_blue" position="830,536" size="250,38" transparent="1" valign="center" zPosition="2" />
	</screen>"""
		
	skin_sd = """
		<screen name="TMBD" position="center,center" size="600,420" title="TMBD Details Plugin" >
		<ePixmap pixmap="skin_default/buttons/red.png" position="0,0" zPosition="0" size="140,40" transparent="1" alphatest="on" />
		<ePixmap pixmap="skin_default/buttons/green.png" position="140,0" zPosition="0" size="140,40" transparent="1" alphatest="on" />
		<ePixmap pixmap="skin_default/buttons/yellow.png" position="280,0" zPosition="0" size="140,40" transparent="1" alphatest="on" />
		<ePixmap pixmap="skin_default/buttons/blue.png" position="420,0" zPosition="0" size="140,40" transparent="1" alphatest="on" />
		<ePixmap pixmap="skin_default/buttons/key_menu.png" position="565,5" zPosition="0" size="35,25" alphatest="on" />
		<ePixmap pixmap="skin_default/buttons/key_info.png" position="565,33" zPosition="1" size="35,25" alphatest="on" />
		<widget name="key_red" position="0,0" zPosition="1" size="140,40" font="Regular;18" valign="center" halign="center" backgroundColor="#9f1313" transparent="1" />
		<widget name="key_green" position="140,0" zPosition="1" size="140,40" font="Regular;18" valign="center" halign="center" backgroundColor="#1f771f" transparent="1" />
		<widget name="key_yellow" position="280,0" zPosition="1" size="140,40" font="Regular;18" valign="center" halign="center" backgroundColor="#a08500" transparent="1" />
		<widget name="key_blue" position="420,0" zPosition="1" size="140,40" font="Regular;18" valign="center" halign="center" backgroundColor="#18188b" transparent="1" />
		<widget name="title" position="10,40" size="330,45" valign="center" font="Regular;20" transparent="1"/>
		<widget name="extralabel" position="105,90" size="485,140" font="Regular;18" />
		<widget name="castlabel" position="10,235" size="580,155" font="Regular;18"  zPosition="3"/>
		<widget name="ratinglabel" position="340,62" size="250,20" halign="center" font="Regular;18" foregroundColor="#f0b400"/>
		<widget name="statusbar" position="10,404" size="580,16" font="Regular;16" foregroundColor="#cccccc" />
		<widget font="Regular;16" halign="center" name="voteslabel" foregroundColor="#00f0b400" position="380,404" size="210,16" transparent="1" />
		<widget name="poster" position="4,90" size="96,140" alphatest="on" />
		<widget name="menu" position="105,90" size="485,140" zPosition="2" scrollbarMode="showOnDemand" />
		<widget name="starsbg" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/TMBD/starsbar_empty.png" position="340,40" zPosition="0" size="210,21" transparent="1" alphatest="on" />
		<widget name="stars" position="340,40" size="210,21" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/TMBD/starsbar_filled.png" transparent="1" />

	</screen>"""

	def __chooseSkin(self):
		try:
			screenWidth = getDesktop(0).size().width()
		except:
			screenWidth = 720
		print "Screen width=%d" % (screenWidth)

		if (screenWidth == 1280):
			if config.plugins.tmbd.skins.value == "0":
				return TMBD.skin_hd
		if config.plugins.tmbd.skins.value == "1":
			return TMBD.skin_hd1
		else:
			return TMBD.skin_sd
	
	def __init__(self, session, eventName, callbackNeeded=False, movielist = False):
		Screen.__init__(self, session)
		self.skin=self.__chooseSkin()
		self.eventName = eventName
		self.curResult = False
		self.noExit = False
		self.onShow.append(self.selectionChanged)
		self.movielist = movielist
		self.callbackNeeded = callbackNeeded
		self.callbackData = ""
		self.callbackGenre = ""
		self["poster"] = Pixmap()
		self.picload = ePicLoad()
		self.picload.PictureData.get().append(self.paintPosterPixmapCB)
		self["stars"] = ProgressBar()
		self["starsbg"] = Pixmap()
		self["stars"].hide()
		self["starsbg"].hide()
		self.ratingstars = -1
		self.working = False
		self["title"] = Label("")
		self["title"].setText(_("The Internet Movie Database"))
		self["detailslabel"] = ScrollLabel("")
		self["castlabel"] = ScrollLabel("")
		self["extralabel"] = ScrollLabel("")
		self["statusbar"] = Label("")
		self["ratinglabel"] = Label("")
		self["voteslabel"] = Label("")
		self.resultlist = []
		self["menu"] = MenuList(self.resultlist)
		self["menu"].hide()
		self["menu"].onSelectionChanged.append(self.selectionChanged)
		self["key_red"] = Button(_("Exit"))
		self["key_green"] = Button("")
		self["key_yellow"] = Button("")
		self["key_blue"] = Button(_("Manual input"))
		self.Page = 0
		self.working = False
		self.refreshTimer = eTimer()
		self.refreshTimer.callback.append(self.TMBDPoster)
		
		self["actions"] = ActionMap(["OkCancelActions", "ColorActions", "MovieSelectionActions", "DirectionActions"],
		{
			"ok": self.showExtras,
			"cancel": self.exit2,
			"down": self.pageDown,
			"up": self.pageUp,
			"left": self.scrollLabelPageUp,
			"right": self.scrollLabelPageDown,
			"red": self.exit,
			"green": self.searchYttrailer2,
			"yellow": self.showExtras,
			"blue": self.openVirtualKeyBoard,
			"contextMenu": self.contextMenuPressed,
			"showEventInfo": self.aboutAutor
		}, -1)
		
		self.setTitle(_("Profile: themoviedb.org"))
		self.removCovers()
		self.tmdb3 = tmdb.init_tmdb3()
		if self.tmdb3 is None:
			self["statusbar"].setText(_("Unknown error!"))
			return
		self.testThread = None
		self.testTime = 2.0		# 1 seconds
		self.testHost = "www.themoviedb.org"
		self.testPort = 80		# www port
		if config.plugins.tmbd.test_connect.value:
			self.TestConnection()
		else:
			self.getTMBD()

		
	def TestConnection(self):
		self.testThread = Thread(target=self.test)
		self.testThread.start()
		
	def get_iface_list(self):
		names = array.array('B', '\0' * BYTES)
		sck = socket(AF_INET, SOCK_DGRAM)
		bytelen = struct.unpack('iL', fcntl.ioctl(sck.fileno(), SIOCGIFCONF, struct.pack('iL', BYTES, names.buffer_info()[0])))[0]
		sck.close()
		namestr = names.tostring()
		return [namestr[i:i+32].split('\0', 1)[0] for i in range(0, bytelen, 32)]
	
	def test(self):
		global testOK
		link = "down"
		for iface in self.get_iface_list():
			if "lo" in iface: continue
			if os_path.exists("/sys/class/net/%s/operstate"%(iface)):
				fd = open("/sys/class/net/%s/operstate"%(iface), "r")
				link = fd.read().strip()
				fd.close()
			if link != "down": break
		if link != "down":
			s = socket(AF_INET, SOCK_STREAM)
			s.settimeout(self.testTime)
			try:
				testOK = not bool(s.connect_ex((self.testHost, self.testPort)))
			except:
				testOK = None
			if not testOK:
				print 'Conection failed'
				self.resetLabels()
				self["statusbar"].setText(_("No connect to www.themoviedb.org"))
				self["title"].setText("")
				return
			else:
				s.shutdown(SHUT_RDWR)
				self.getTMBD()
			s.close()
		else:
			testOK = None
			self.resetLabels()
			self["statusbar"].setText(_("Not found network connection..."))
			self["title"].setText("")
			return

				
	def exit(self):
		self.close()
		
	def exit2(self):
		if config.plugins.tmbd.exit_key.value == "1":
			self.session.openWithCallback(self.exitConfirmed, MessageBox, _("Close plugin?"), MessageBox.TYPE_YESNO)
		else:
			self.exit()
		
	def exitConfirmed(self, answer):
		if answer:
			self.close()
		
	def aboutAutor(self):
		self.session.open(MessageBox, _("TMBD Details Plugin\nDeveloper: Nikolasi,vlamo,Dima73\n(c)2012"), MessageBox.TYPE_INFO)
		
	def removCovers(self):
		if os.path.exists('/tmp/preview.jpg'):
			try:
				os.remove('/tmp/preview.jpg')
			except:
				pass

	def resetLabels(self):
		self["detailslabel"].setText("")
		self["ratinglabel"].setText("")
		self["title"].setText(_("Search in themoviedb.org ,please wait ..."))
		self["castlabel"].setText("")
		self["extralabel"].setText("")
		self["voteslabel"].setText("")
		self["key_green"].setText("")
		self.ratingstars = -1

	def pageUp(self):
		if self.Page == 0:
			self["menu"].instance.moveSelection(self["menu"].instance.moveUp)
			self["castlabel"].pageUp()
		if self.Page == 1:
			self["extralabel"].pageUp()

	def pageDown(self):
		if self.Page == 0:
			self["menu"].instance.moveSelection(self["menu"].instance.moveDown)
			self["castlabel"].pageUp()
		if self.Page == 1:
			self["extralabel"].pageDown()
	
	def scrollLabelPageUp(self):
		self["castlabel"].pageUp()

	def scrollLabelPageDown(self):
		self["castlabel"].pageDown()

	def showMenu(self):
		global eventname, total
		self.noExit = False
		if self.curResult:
			self["menu"].show()
			self["ratinglabel"].show()
			self["castlabel"].show()
			self["poster"].show()
			self["extralabel"].hide()
			self["title"].setText(_("Search results for: %s") % (eventname))
			if total > 1:
				self["detailslabel"].setText(_("Please select the matching entry:"))
			self["detailslabel"].show()
			self["key_blue"].setText(_("Manual input"))
			if self.movielist:
				self["key_green"].setText(_("Save info / poster"))
			else:
				self["key_green"].setText(_("Search Trailer"))
			self["key_yellow"].setText(_("Show movie details"))
			if self.ratingstars > 0:
				self["starsbg"].show()
				self["stars"].show()
				self["stars"].setValue(self.ratingstars)
			self.working = True

	def showExtras(self):
		if self.curResult:
			if not self.noExit:
				self.Page = 1
				self.noExit = True
				self["menu"].hide()
				self["extralabel"].show()
				self["detailslabel"].hide()
				self["key_yellow"].setText("")
				self.showExtras2()
			else:
				self.Page = 0
				self.noExit = False
				self.showMenu()

	def selectionChanged(self):
		self["poster"].hide()
		self["stars"].hide()
		self["starsbg"].hide()
		self["ratinglabel"].hide()
		self["castlabel"].hide()
		current = self["menu"].l.getCurrentSelection()
		if current and self.curResult:
			try:
				movie = current[1]
				jpg_file = "/tmp/preview.jpg"
				try:
					image = movie.poster
					cover_url = None
					if image is not None:
						cover_url = image.geturl()
					if cover_url:
						urllib.urlretrieve(cover_url, jpg_file)
				except:
					pass
				self.refreshTimer.start(100, True)
				Casttext = ""
				try:
					name = movie.title.encode('utf-8', 'ignore')
				except:
					name = ''
				if name != '':
					try:
						Casttext = "%s / " % name
					except:
						pass
				try:
					released = movie.releasedate.year
				except:
					released = ''
				if released != '':
					try:
						released_text = _("Appeared: ") + '%s ' % released
						Casttext += released_text
					except:
						pass
				try:
					runtime = movie.runtime
				except:
					runtime = ''
				if runtime != '':
					try:
						runtime_text = "%s\n\n" % self.textNo(str(runtime))
						Casttext += runtime_text
					except:
						pass
				try:
					description = movie.overview
				except:
					description = ''
				if description != '':
					try:
						description_text = description.encode('utf-8', 'ignore')
						Casttext += description_text
					except:
						pass
				if Casttext != '':
					self["castlabel"].setText(Casttext)
					self["castlabel"].show()
				Ratingtext = _("no user rating yet")
				try:
					rating = str(movie.userrating)
				except:
					rating = ''
				if rating != '' and rating != "0.0":
					try:
						Ratingtext = _("User Rating") + ": " + rating + " / 10"
						self.ratingstars = int(10*round(float(rating.replace(',','.')),1))
						if self.ratingstars > 0:
							self["stars"].setValue(self.ratingstars)
							self["stars"].show()
							self["starsbg"].show()
					except:
						pass
				self["ratinglabel"].show()
				self["ratinglabel"].setText(Ratingtext)
				Votestext = ""
				try:
					votes = str(movie.votes)
				except:
					votes = ''
				if votes != '' and votes != "0":
					try:
						Votestext = _("Votes") + ": " + votes + _(" times")
					except:
						pass
				self["voteslabel"].setText(Votestext)
			except:
				pass

	def showExtras2(self):
		if self.curResult:
			current = self["menu"].l.getCurrentSelection()
			if current:
				movie = current[1]
				self["key_yellow"].setText(_("Show search results"))
				try:
					namedetals = current[0]
					self["title"].setText(_("Details for: %s") % (namedetals))
				except:
					pass
				Extratext = ""
				try:
					genres = [ x.name.encode('utf-8', 'ignore') for x in movie.genres ]
				except:
					genres =[]
				if len(genres) > 0:
					try:
						genre = ', '.join(genres)
						Extratext += "%s: %s\n" % (_("Genre"), genre)
					except:
						pass
				try:
					crew = [ x.name.encode('utf-8', 'ignore') for x in movie.crew if x.job == 'Director' ]
				except:
					crew =[]
				if len(crew) > 0:
					try:
						directors = ', '.join(crew)
						Extratext += "%s: %s\n" % (_("Director"), directors)
					except:
						pass
				try:
					crew1 = [ x.name.encode('utf-8', 'ignore') for x in movie.crew if x.job == 'Producer' ]
				except:
					crew1 =[]
				if len(crew1) > 0:
					try:
						producers = ', '.join(crew1)
						Extratext += "%s: %s\n" % (_("Producers"), producers)
					except:
						pass
				try:
					cast = [ x.name.encode('utf-8', 'ignore') for x in movie.cast ]
				except:
					cast =[]
				if len(cast) > 0:
					try:
						actors = ', '.join(cast)
						Extratext += "%s: %s\n" % (_("Actors"), actors)
					except:
						pass
				Extratext2 = ""
				try:
					studios = [ x.name.encode('utf-8', 'ignore') for x in movie.studios ]
				except:
					studios =[]
				if len(studios) > 0:
					try:
						studio = ', '.join(studios)
						Extratext2 = "%s: %s\n" % (_("Studios"), studio)
					except:
						pass
				try:
					cert = movie.releases
					if cert:
						certification = tmdb.decodeCertification(movie.releases)
					else:
						certification = ''
				except:
					certification = ''
				if certification != '' and certification != None:
					try:
						Extratext2 += "%s: %s\n" % (_("Certification"), certification)
					except:
						pass
				try:
					countries = [ x.name for x in movie.countries ]
				except:
					countries = []
				if len(countries) > 0:
					try:
						country = ''
						for name in countries:
							country += '%s, '% str(name)
						if country != '':
							country = country[:-2]
							Extratext2 += "%s: %s\n" % (_("Country"), country)
					except:
						pass
				self["extralabel"].setText("%s%s" % (Extratext2, Extratext))

	def removmenu(self):
		list = [
			(_("Current poster and info"), self.removcurrent),
			(_("Only current poster"), self.removcurrentposter),
			(_("Only current info"), self.removcurrentinfo),
			(_("All posters for movie"), self.removresult),
		]
		self.session.openWithCallback(
			self.menuCallback,
			ChoiceBox,
			list = list,
			title= _("What exactly do you want to delete?"),
		)	

	def contextMenuPressed(self):
		if self.movielist:
			list = [
				(_("Text editing"), self.openKeyBoard),
				(_("Select from Favourites"), self.openChannelSelection),
				(_("Search Trailer"), self.searchYttrailer3),
				(_("Remove poster / info"), self.removmenu),
				(_("Settings"), self.Menu2),
                                (_("Installing components"), self.components),
			]
		else:
			list = [
				(_("Text editing"), self.openKeyBoard),
				(_("Select from Favourites"), self.openChannelSelection),
				(_("Settings"), self.Menu2),
                                (_("Installing components"), self.components),                                
			]
		self.session.openWithCallback(
			self.menuCallback,
			ChoiceBox,
			list = list,
			title= _("Select action:"),
		)

	def components(self):
		if fileExists("/usr/lib/enigma2/python/Plugins/Extensions/TMBD/Components"):
                    os.system("cp -f /usr/lib/enigma2/python/Plugins/Extensions/TMBD/Components/MovieInfo.py /usr/lib/enigma2/python/Components/Converter/MovieInfo.py")
                    os.system("cp -f /usr/lib/enigma2/python/Plugins/Extensions/TMBD/Components/RatingTmbd.py /usr/lib/enigma2/python/Components/Renderer/RatingTmbd.py")
                    os.system("cp -f /usr/lib/enigma2/python/Plugins/Extensions/TMBD/Components/CoverTmbd.py /usr/lib/enigma2/python/Components/Renderer/CoverTmbd.py")
                    os.system("cp -f /usr/lib/enigma2/python/Plugins/Extensions/TMBD/Components/CoverTmbdBig.py /usr/lib/enigma2/python/Components/Renderer/CoverTmbdBig.py")
                else:
                    pass

	def Menu2(self):
		self.session.openWithCallback(self.workingFinished, TMBDSettings)                
                
	def saveresult(self):
		global name
		list = [
			(_("Yes"), self.savePosterInfo),
			(_("Yes,but write new meta-file"), self.writeMeta),
			(_("No"), self.exitChoice),
		]
		self.session.openWithCallback(
			self.menuCallback,
			ChoiceBox,
			title= _("Save poster and info for:\n %s ?") % (name),
			list = list,
		)

	def exitChoice(self):
		self.close()

	def savePosterInfo(self):
		global name
		import os
		import shutil
		if self.curResult:
			self.savedescrip()
		if not fileExists("/media/hdd/covers"):
			try:
				os.makedirs("/media/hdd/covers")
			except OSError:
				pass
		if fileExists("/media/hdd/covers"):
			try:
				if fileExists("/tmp/preview.jpg"):
					shutil.copy2("/tmp/preview.jpg", "/media/hdd/covers/" + name + ".jpg")
					self.session.open(MessageBox, _("Poster is saved!"), MessageBox.TYPE_INFO, timeout=2)
			except OSError:
				pass


	def writeMeta(self):
		if self.curResult:
			global movie2, eventname
			Extratext2 = ""
			namedetals2 = ""
			if len(movie2):
					TSFILE = movie2
			else:
				return
			current = self["menu"].l.getCurrentSelection()
			if current:
				movie = current[1]
				try:
					namedetals = current[0].decode('utf-8', 'replace').encode('utf-8', 'ignore')
				except:
					return
				if not movie2.endswith(".ts"):
					if namedetals2 != "":
						Extratext2 = "%s /" % ( namedetals2)
				try:
					genres = [ x.name.encode('utf-8', 'ignore') for x in movie.genres ]
				except:
					genres =[]
				if len(genres) > 0:
					try:
						genre = ', '.join(genres)
						Extratext2 += " %s /" % ( genre)
					except:
						pass
				try:
					countries = [ x.name for x in movie.countries ]
				except:
					countries = []
				if len(countries) > 0:
					try:
						country = ''
						for name in countries:
							country += '%s, '% str(name)
						if country != '':
							country = country[:-2]
							Extratext2 += " %s /" % (country)
					except:
						pass
				try:
					cast = [ x.name.encode('utf-8', 'ignore') for x in movie.cast ]
				except:
					cast =[]
				if len(cast) > 0:
					try:
						actors = ', '.join(cast)
						Extratext2 += " %s" % (actors)
					except:
						pass
				metaParser = MetaParser();
				metaParser.name = namedetals2
				metaParser.description = Extratext2;
				if os.path.exists(TSFILE + '.meta') and movie2.endswith(".ts"):
					readmetafile = open("%s.meta"%(movie2), "r")
					linecnt = 0
					line = readmetafile.readline()
					if line:
						line = line.strip()
						if linecnt == 0:
							metaParser.ref = eServiceReference(line)
					else:
						metaParser.ref = eServiceReference('1:0:0:0:0:0:0:0:0:0:')
					readmetafile.close()
				else:
					metaParser.ref = eServiceReference('1:0:0:0:0:0:0:0:0:0:')
				metaParser.time_create = getctime(TSFILE);
				metaParser.tags = '';
				metaParser.length = 0;
				metaParser.filesize = fileSize(TSFILE);
				metaParser.service_data = '';
				metaParser.data_ok = 1;
				metaParser.updateMeta(TSFILE);
				self.session.open(MessageBox, _("Write to new meta-file for:\n") + "%s" % (TSFILE), MessageBox.TYPE_INFO, timeout=3)
				self.timer = eTimer()
				self.timer.callback.append(self.savePosterInfo)
				self.timer.start(1500, True)

	def textNo2(self, text):
		try:
			if text == None or text == "0":
				return (_('0 min.'))
			else:
				return text + _(" min.")
		except:
			return ''

	def savedescrip(self):
		global name, movie2, dircontrol, number
		descrip = ""
		Extratext = ""
		namedetals = ""
		EITFILE2 = ""
		EITFILE3 = ""		
		filename = ""
		if config.plugins.tmbd.eit.value == "0":
		     if dircontrol:
                         if config.plugins.tmbd.movieselectionparts.value == "none":
                               EITFILE = number + '.eit'
                         else:
                               filename = os.path.split(number)[1]
                               EITFILE = config.plugins.tmbd.movieselectionparts.value + "/" + filename + '.eit'
                     else:        
		            if len(movie2):
                                if config.plugins.tmbd.movieselectionparts.value == "none":
			                EITFILE = movie2[:-2] + 'eit'
                                else:
                                        filename = os.path.split(movie2)[1]
                                        EITFILE = config.plugins.tmbd.movieselectionparts.value + "/" + filename[:-2] + 'eit'			                
		            else:
			            return
		else:
		     if dircontrol:
                         if config.plugins.tmbd.movieselectionparts.value == "none":
                               EITFILE = number + '.txt'
                               EITFILE2 = number + '.eit'
                         else:
                               filename = os.path.split(number)[1]
                               EITFILE = config.plugins.tmbd.movieselectionparts.value + "/" + filename + '.txt'
                               EITFILE2 = config.plugins.tmbd.movieselectionparts.value + "/" + filename + '.eit'
                     else:        
		            if len(movie2):
                                if config.plugins.tmbd.movieselectionparts.value == "none":
			               EITFILE = movie2[:-2] + 'txt'
			               EITFILE2 = movie2[:-2] + 'eit'
                                else:
                                        filename = os.path.split(movie2)[1]
                                        EITFILE = config.plugins.tmbd.movieselectionparts.value + "/" + filename[:-2] + 'txt'
                                        EITFILE2 = config.plugins.tmbd.movieselectionparts.value + "/" + filename[:-2] + 'eit'
                                        EITFILE3 = movie2[:-2] + 'eit'
		            else:
			            return
		current = self["menu"].l.getCurrentSelection()
		if current:
			movie = current[1]
			try:
				namedetals = current[0].decode('utf-8', 'replace').encode('utf-8', 'ignore')
			except:
				return
			try:
				countries = [ x.name for x in movie.countries ]
			except:
				countries = []
			if len(countries) > 0:
				try:
					country = ''
					for name in countries:
						country += '%s, '% str(name)
					if country != '':
						country = country[:-2]
						Extratext = "%s %s\n" % (_("Country:"), country)
				except:
					pass
			try:
				genres = [ x.name.encode('utf-8', 'ignore') for x in movie.genres ]
			except:
				genres =[]
			if len(genres) > 0:
				try:
					genre = ', '.join(genres)
					Extratext += "%s %s\n" % (_("Genre:"), genre)
				except:
					pass
			try:
				description = movie.overview
			except:
				description = ''
			if description != '':
				try:
					description_text = description.encode('utf-8', 'ignore')
					descrip = " %s\n" % description_text
				except:
					pass
			try:
				runtime = movie.runtime
			except:
				runtime = ''
			if runtime != '':
				try:
					runtime_text = "%s" % self.textNo2(str(runtime))
					if runtime_text != '':
						descrip += " %s" % (runtime_text)
				except:
					pass
			try:
				rating = str(movie.userrating)
				votes = str(movie.votes)
			except:
				rating = ''
				votes = ''
			if rating != '' and rating != "0.0":
				try:
					descrip += _(" User Rating: ") + rating + "/10" + _(" (%s times)\n") % (votes)
				except:
					pass
			try:
				cast = [ x.name.encode('utf-8', 'ignore') for x in movie.cast ]
			except:
				cast =[]
			if len(cast) > 0:
				try:
					actors = ', '.join(cast)
					descrip += " %s %s\n" % (_("Actors:"), actors)
				except:
					pass
			Extratext = Extratext.replace('\xc2\xab', '"').replace('\xc2\xbb', '"').replace('\xe2\x80\xa6', '...').replace('\xe2\x80\x94', '-');
			Extratext = self.Cutext(Extratext)
			descrip = descrip.replace('\xc2\xab', '"').replace('\xc2\xbb', '"').replace('\xe2\x80\xa6', '...').replace('\xe2\x80\x94', '-');
			namedetals = namedetals.replace('\xc2\xab', '"').replace('\xc2\xbb', '"').replace('\xe2\x80\xa6', '...').replace('\xe2\x80\x94', '-');
                        if config.plugins.tmbd.eit.value == "0":
			        sed = ShortEventDescriptor([]);
			        sed.setIso639LanguageCode(GetLanguageCode());
			        sed.setEventName(namedetals);
			        sed.setText(Extratext);
			        eed = ExtendedEventDescriptor([]);
			        eed.setIso639LanguageCode(GetLanguageCode());
			        eed.setText(descrip);
			        newEvent = Event();
			        newEvent.setShortEventDescriptor(sed);
			        newEvent.setExtendedEventDescriptor(eed);
			        ret = newEvent.saveToFile(EITFILE);
			        self.session.open(MessageBox, _("Write event to new eit-file:\n") + "%s\n" % (EITFILE) + _("%d bytes") % (ret), MessageBox.TYPE_INFO, timeout=3)
                        else:
		              if fileExists(EITFILE2):
                                   os.remove(EITFILE2)
		              elif fileExists(EITFILE3):
                                   os.remove(EITFILE3)                                    
                              fetchurl = "%s%s" % (Extratext, descrip)
                              temp_file = open(EITFILE, "w")
                              temp_file.write(fetchurl)
                              temp_file.close()
                              filesize = int(os.stat(EITFILE).st_size)
                              self.session.open(MessageBox, _("Write event to new txt-file:\n") + "%s\n" % (EITFILE) + _("%d bytes") % (filesize), MessageBox.TYPE_INFO, timeout=3)


	def Cutext(self, text):
		if text > 0:
			return text[:179]
		else:
			return text

	def removcurrent(self):
		global name
		self.session.openWithCallback(self.removcurrentConfirmed, MessageBox, _("Remove current poster and info for:\n%s ?") % (name), MessageBox.TYPE_YESNO)

	def removcurrentposter(self):
		global movie2, name
		if len(movie2):
			dir_cover = '/media/hdd/covers/'
			if movie2.endswith(".ts"):
				if os.path.exists(movie2 + '.meta'):
					try:
						readmetafile = open("%s.meta"%(movie2), "r")
						name_cur = readmetafile.readline()[0:-1]
						name_cover = name_cur + '.jpg'
					except:
						name_cover = ""
					readmetafile.close()
				else:
					name_cover = name + '.jpg'
			else:
					name_cover = name + '.jpg'
			remove_jpg = dir_cover + name_cover
			if os.path.exists(remove_jpg):
				try:
					os.remove(remove_jpg)
					self.session.open(MessageBox, _("%s poster removed!") % (remove_jpg), MessageBox.TYPE_INFO, timeout=3)
				except:
					pass
		else:
			return

	def removcurrentinfo(self):
		global movie2, name
		if len(movie2):
			remove_eit = movie2[:-2] + 'eit'
			if os.path.exists(remove_eit):
				try:
					os.remove(remove_eit)
					self.session.open(MessageBox, _("%s eit-file removed!") % (remove_eit), MessageBox.TYPE_INFO, timeout=3)
				except:
					pass
			remove_meta = movie2 + '.meta'
			if os.path.exists(remove_meta):
				try:
					os.remove(remove_meta)
					self.session.open(MessageBox, _("%s meta-file removed!") % (remove_meta), MessageBox.TYPE_INFO, timeout=3)
				except:
					pass
		else:
			return

	def removcurrentConfirmed(self, confirmed):
		if not confirmed:
			return
		else:
			global movie2, name
			if len(movie2):
				dir_cover = '/media/hdd/covers/'
				remove_eit = movie2[:-2] + 'eit'
				if os.path.exists(remove_eit):
					try:
						os.remove(remove_eit)
						self.session.open(MessageBox, _("%s eit-file removed!") % (remove_eit), MessageBox.TYPE_INFO, timeout=3)
					except:
						pass
				if movie2.endswith(".ts"):
					if os.path.exists(movie2 + '.meta'):
						try:
							readmetafile = open("%s.meta"%(movie2), "r")
							name_cur = readmetafile.readline()[0:-1]
							name_cover = name_cur + '.jpg'
						except:
							name_cover = ""
						readmetafile.close()
					else:
						name_cover = name + '.jpg'
				else:
					name_cover = name + '.jpg'
				remove_jpg = dir_cover + name_cover
				if os.path.exists(remove_jpg):
					try:
						os.remove(remove_jpg)
						self.session.open(MessageBox, _("%s poster removed!") % (remove_jpg), MessageBox.TYPE_INFO, timeout=3)
					except:
						pass
				remove_meta = movie2 + '.meta'
				if os.path.exists(remove_meta):
					try:
						os.remove(remove_meta)
						self.session.open(MessageBox, _("%s meta-file removed!") % (remove_meta), MessageBox.TYPE_INFO, timeout=3)
					except:
						pass
			else:
				return

	def removresult(self):
		self.session.openWithCallback(self.removresultConfirmed, MessageBox, _("Remove all posters?"), MessageBox.TYPE_YESNO)

	def removresultConfirmed(self, confirmed):
		import os
		import shutil
		if not confirmed:
			return
		else:
			if fileExists("/media/hdd/covers"):
				try:
					shutil.rmtree("/media/hdd/covers")
					self.session.open(MessageBox, _("All posters removed!"), MessageBox.TYPE_INFO, timeout=3)
				except OSError:
					pass

	def menuCallback(self, ret = None):
		ret and ret[1]()

	def searchYttrailer3(self):
		if fileExists(resolveFilename(SCOPE_PLUGINS, "Extensions/YTTrailer/plugin.pyc")) or fileExists(resolveFilename(SCOPE_PLUGINS, "Extensions/YTTrailer/plugin.pyo")):
			self.searchYttrailer()
		else:
			if fileExists(resolveFilename(SCOPE_PLUGINS, "Extensions/TMBD/enigma2-plugin-extensions-yttrailer_2.0_all.ipk")):
				self.session.openWithCallback(self.yesNo, MessageBox, _("YTTrailer is not installed.\nInstall YTTrailer now?"), MessageBox.TYPE_YESNO, default = False)
			else:
				self.session.openWithCallback(self.workingFinished, MessageBox, ("YTTrailer is not installed. Please install YTTrailer."), MessageBox.TYPE_INFO, timeout=5)		

	def searchYttrailer2(self):
		if self.movielist and self.curResult:
			self.saveresult()
		else:
			if fileExists(resolveFilename(SCOPE_PLUGINS, "Extensions/YTTrailer/plugin.pyc")) or fileExists(resolveFilename(SCOPE_PLUGINS, "Extensions/YTTrailer/plugin.pyo")):
				self.searchYttrailer()
			else:
				if fileExists(resolveFilename(SCOPE_PLUGINS, "Extensions/TMBD/enigma2-plugin-extensions-yttrailer_2.0_all.ipk")):
					self.session.openWithCallback(self.yesNo, MessageBox, _("YTTrailer is not installed.\nInstall YTTrailer now?"), MessageBox.TYPE_YESNO, default = False)
				else:
					self.session.openWithCallback(self.workingFinished, MessageBox, ("YTTrailer is not installed. Please install YTTrailer."), MessageBox.TYPE_INFO, timeout=5)

	def yesNo(self, answer):
		if answer is True:
			self.yesInstall()

	def yesInstall(self):
		if fileExists(resolveFilename(SCOPE_PLUGINS, "Extensions/TMBD/enigma2-plugin-extensions-yttrailer_2.0_all.ipk")):
			cmd = "opkg install -force-overwrite -force-downgrade /usr/lib/enigma2/python/Plugins/Extensions/TMBD/enigma2-plugin-extensions-yttrailer_2.0_all.ipk"
			self.session.open(Console, _("Install YTTrailer..."), [cmd])

	def searchYttrailer(self):
		try:
			from Plugins.Extensions.YTTrailer.plugin import YTTrailerList, baseEPGSelection__init__
		except ImportError as ie:
			pass
		if baseEPGSelection__init__ is None:
			return
		if self.curResult:
			current = self["menu"].l.getCurrentSelection()
			if current:
				namedetals = self['menu'].l.getCurrentSelection()[0]
				namedetals = namedetals[:-7]
				self.session.open(YTTrailerList, namedetals)

	def workingFinished(self, callback=None):
		self.working = False

	def openKeyBoard(self):
		global eventname
		self.session.openWithCallback(
			self.gotSearchString,
			InputBox,
			title = _("Edit text to search for"), text=eventname, visible_width = 40, maxSize=False, type=Input.TEXT)

	def openVirtualKeyBoard(self):
		if config.plugins.tmbd.virtual_text.value == "0":
			self.session.openWithCallback(
				self.gotSearchString,
				VirtualKeyBoard,
				title = _("Enter text to search for")
			)
		else:
			global eventname
			self.session.openWithCallback(
				self.gotSearchString,
				VirtualKeyBoard,
				title = _("Edit text to search for"),
				text=eventname
			)

	def openChannelSelection(self):
		self.session.openWithCallback(
			self.gotSearchString,
			TMBDChannelSelection
		)

	def gotSearchString(self, ret = None):
		if self.tmdb3 is None:
			return
		if ret:
			global total
			self.eventName = ret
			self.Page = 0
			self.resultlist = []
			self["menu"].hide()
			self["ratinglabel"].hide()
			self["castlabel"].hide()
			self["detailslabel"].hide()
			self["poster"].hide()
			self["stars"].hide()
			self["starsbg"].hide()
			self.removCovers()
			total = ""
			self["detailslabel"].setText("")
			self["statusbar"].setText("")
			self.noExit = False
			self.curResult = False
			self["key_yellow"].setText("")
			self["key_green"].setText("")
			if config.plugins.tmbd.test_connect.value:
				self.TestConnection()
			else:
				self.getTMBD()

	def getTMBD(self):
		global eventname, total
		total = ""
		results = ""
		self.resetLabels()
		if self.tmdb3 is None:
			return
		if not self.eventName:
			s = self.session.nav.getCurrentService()
			info = s and s.info()
			event = info and info.getEvent(0) # 0 = now, 1 = next
			if event:
				self.eventName = event.getEventName()
		if self.eventName:
			title = self.eventName.split("(")[0].strip()
			try:
				results = self.tmdb3.searchMovie(title)
			except:
				results = []
			if len(results) == 0:
				self["statusbar"].setText(_("Nothing found for: %s") % (self.eventName))
				self["title"].setText("")
				eventname = self.eventName
				self.curResult = False
				return False
			self.resultlist = []
			for searchResult in results:
				try:
					name = searchResult.title.encode('utf-8', 'ignore')
					self.resultlist.append((name, searchResult))
					total = len(results)
					if len(results) > 0:
						self["statusbar"].setText(_("Total results: %s") % (total))
					eventname = self.eventName
					self.curResult = True
				except:
					self.resultlist = []
			self.showMenu()
			self["menu"].setList(self.resultlist)
		else:
			self["title"].setText(_("Enter or choose event for search ..."))


	def TMBDPoster(self):
		if not self.curResult:
			self.removCovers()
		if fileExists("/tmp/preview.jpg"):
			jpg_file = "/tmp/preview.jpg"
		else:
			jpg_file = resolveFilename(SCOPE_PLUGINS, "Extensions/TMBD/picon_default.png")
		sc = AVSwitch().getFramebufferScale()
		self.picload.setPara((self["poster"].instance.size().width(), self["poster"].instance.size().height(), sc[0], sc[1], False, 1, "#00000000"))
		self.picload.startDecode(jpg_file)

	def textNo(self, text):
		try:
			if text == None or text == "0":
				return ''
			else:
				return _("/ Duration: ") + text + _(" min.")
		except:
			return ''

	def paintPosterPixmapCB(self, picInfo=None):
		ptr = self.picload.getData()
		if ptr != None and self.curResult:
			self["poster"].instance.setPixmap(ptr.__deref__())
			self["poster"].show()
		else:
			self["poster"].hide()

	def createSummary(self):
		#return TMBDLCDScreen
		pass


class TMBDSettings(Screen, ConfigListScreen):
	skin = """<screen position="center,center" size="740,485" title="TMBDSettings" backgroundColor="#31000000" >
		<widget name="config" position="10,10" size="725,430" zPosition="1" transparent="0" backgroundColor="#31000000" scrollbarMode="showOnDemand" />
		<widget name="key_red" position="10,460" zPosition="2" size="235,25" halign="center" font="Regular;22" transparent="1" foregroundColor="red"  />
		<widget name="key_green" position="485,460" zPosition="2" size="235,25" halign="center" font="Regular;22" transparent="1" foregroundColor="green" />
		<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/TMBD/ig/red25.png" position="10,450" size="235,44" zPosition="1" alphatest="on" />
		<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/TMBD/ig/green25.png" position="485,450" size="235,44" zPosition="1" alphatest="on" />
		</screen>"""

	def __init__(self, session, args = None):
		Screen.__init__(self, session)
		self.setTitle(_("Settings TMBD Details Plugin..."))
		self['key_red'] = Button(_('Cancel'))
		self['key_green'] = Button(_('Save'))
		self['actions'] = ActionMap(['SetupActions',
		    'ColorActions'], {'green': self.save,
	            'ok': self.save,
	            'red': self.exit,
	            'cancel': self.exit}, -2)

		ConfigListScreen.__init__(self, [])
		self.prev_ext_menu = config.plugins.tmbd.add_ext_menu.value
		self.initConfig()
		self.createSetup()
		
	def initConfig(self):
		def getPrevValues(section):
			res = { }
			for (key,val) in section.content.items.items():
				if isinstance(val, ConfigSubsection):
					res[key] = getPrevValues(val)
				else:
					res[key] = val.value
			return res
		self.TM_BD = config.plugins.tmbd
		self.prev_values = getPrevValues(self.TM_BD)
		self.cfg_addmenu = getConfigListEntry(_('Show \"TMBD Details: current event\" in extensions menu'), config.plugins.tmbd.add_ext_menu)
		self.cfg_Event = getConfigListEntry(_("Event mode for search"), config.plugins.tmbd.ext_menu_event)
		self.cfg_noevent = getConfigListEntry(_("Open plugin if there is no event"), config.plugins.tmbd.no_event)
		self.cfg_locale = getConfigListEntry(_('Select the search language'), config.plugins.tmbd.locale)
		self.cfg_hotkey = getConfigListEntry(_('\"TMBD Details: current event\" quick button'), config.plugins.tmbd.hotkey)
		self.cfg_menu_profile = getConfigListEntry(_('Choice profile in search'), config.plugins.tmbd.menu_profile)
		self.cfg_movielist_profile = getConfigListEntry(_('Profile movielist context menu'), config.plugins.tmbd.movielist_profile)
		self.cfg_add_tmbd_to_nstreamvod = getConfigListEntry(_('Add \"search in TMBD\" Info/EPG Button to nStreamVOD'), config.plugins.tmbd.add_tmbd_to_nstreamvod)
		self.cfg_add_vcs_to_nstreamvod = getConfigListEntry(_('Add \"open plugin VCS\" Info/EPG Button to nStreamVOD'), config.plugins.tmbd.add_vcs_to_nstreamvod)

	def createSetup(self):
		list = []
		list.append(getConfigListEntry(_('Choice database to search'), config.plugins.tmbd.profile))
		if config.plugins.tmbd.profile.value == "0":
			list.append(self.cfg_locale)
		list.append(getConfigListEntry(_('Select your skins'), config.plugins.tmbd.skins))
		list.append(getConfigListEntry(_('Select the type of save the description'), config.plugins.tmbd.eit))
		list.append(getConfigListEntry(_('Select your kinopoisk menu'), config.plugins.tmbd.kinoprofil))
		list.append(getConfigListEntry(_('Position posters in the full menu'), config.plugins.tmbd.kinoprofilfull))
                list.append(getConfigListEntry(_('Storage of icons for the full menu'), config.plugins.tmbd.kinoprofilparts))
                list.append(getConfigListEntry(_('Save location descriptions'), config.plugins.tmbd.movieselectionparts))
                list.append(getConfigListEntry(_('The frame around the posters in the full menu'), config.plugins.tmbd.kinoprofilramka))
		list.append(getConfigListEntry(_('Select colors for name in simple menu'), config.plugins.tmbd.kinoprofilcolor))
		list.append(getConfigListEntry(_('Hide the names of the items in movieInfo'), config.plugins.tmbd.movieInfo))
                list.append(getConfigListEntry(_('Select size poster'), config.plugins.tmbd.kinoprofilposter)) 
		list.append(getConfigListEntry(_('Add \"Lookup in TMBD\" Info Button to single-EPG'), config.plugins.tmbd.add_tmbd_to_epg))
		list.append(getConfigListEntry(_('Add \"Lookup in TMBD\" Info Button to multi-EPG'), config.plugins.tmbd.add_tmbd_to_multi))
		list.append(getConfigListEntry(_('Add \"Lookup in TMBD\" Info Button to GraphMultiEpg'), config.plugins.tmbd.add_tmbd_to_graph))
		list.append(getConfigListEntry(_('Open VirtualKeyBoard'), config.plugins.tmbd.virtual_text))
		list.append(getConfigListEntry(_('Show plugin in channel selection context menu'), config.plugins.tmbd.menu))
		if config.plugins.tmbd.menu.value:
			list.append(self.cfg_menu_profile)
		list.append(self.cfg_hotkey)
		list.append(self.cfg_addmenu)
		if config.plugins.tmbd.add_ext_menu.value or config.plugins.tmbd.hotkey.value != "none":
			list.append(self.cfg_Event)
			list.append(self.cfg_noevent)
		list.append(self.cfg_movielist_profile)
		list.append(getConfigListEntry(_('Check status Internet'), config.plugins.tmbd.test_connect))
		list.append(getConfigListEntry(_('Close plugin EXIT Button'), config.plugins.tmbd.exit_key))
		if fileExists("/usr/lib/enigma2/python/Plugins/Extensions/nStreamVOD/plugin.pyo") or fileExists("/usr/lib/enigma2/python/Plugins/Extensions/nStreamVOD/plugin.pyc"):
			list.append(self.cfg_add_tmbd_to_nstreamvod)
			if fileExists("/usr/lib/enigma2/python/Plugins/Extensions/VCS/plugin.pyo") and fileExists("/usr/lib/enigma2/python/Plugins/Extensions/VCS/VCS.pyo"):
				list.append(self.cfg_add_vcs_to_nstreamvod)
			else:
				config.plugins.tmbd.add_vcs_to_nstreamvod.value = False
		self["config"].list = list
		self["config"].l.setList(list)

	def keyLeft(self):
		ConfigListScreen.keyLeft(self)
		self.createSetup()

	def keyRight(self):
		ConfigListScreen.keyRight(self)
		self.createSetup()

	def save(self):
		if self.prev_ext_menu != config.plugins.tmbd.add_ext_menu.value:
			plugins.readPluginList(resolveFilename(SCOPE_PLUGINS))
		self.TM_BD.save()
		self.close()

	def exit(self):
		def setPrevValues(section, values):
			for (key,val) in section.content.items.items():
				value = values.get(key, None)
				if value is not None:
					if isinstance(val, ConfigSubsection):
						setPrevValues(val, value)
					else:
						val.value = value
		setPrevValues(self.TM_BD, self.prev_values)
		self.save()
		
class KinoRu(Screen):

	skin_hd1 = """
		<screen name="KinoRu" position="90,90" size="1100,570" title="TMBD Details Plugin">
		<eLabel backgroundColor="#00bbbbbb" position="0,0" size="1100,2" />
		<widget font="Regular;22" name="title" position="20,20" size="740,28" transparent="1" valign="center" />
		<widget alphatest="blend" name="starsbg" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/TMBD/starsbar_empty.png" position="770,10" size="210,21" zPosition="2" />
		<widget name="stars" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/TMBD/starsbar_filled.png" position="770,10"  size="210,21" transparent="1" zPosition="3" />
		<widget font="Regular;20" halign="left" name="ratinglabel" foregroundColor="#00f0b400" position="770,34" size="210,23" transparent="1" />
		<widget font="Regular;20" name="voteslabel" halign="left" position="770,57" size="330,23" foregroundColor="#00f0b400" transparent="1" />
		<widget alphatest="blend" name="poster" position="30,60" size="285,398" />
		<widget name="menu" position="321,86" foregroundColor="#00f0b400" scrollbarMode="showOnDemand" size="760,390" zPosition="1" />
		<widget name="detailslabel" position="325,57" size="570,23" font="Regular;20" transparent="1" />  
		<widget font="Regular;20" name="castlabel" position="320,350" size="760,160" transparent="1" />
		<widget font="Regular;20" name="extralabel" position="320,80" size="760,285" transparent="1" />
		<widget font="Regular;22" name="titlelabel" position="380,85" foregroundColor="#00f0b400" size="700,340" transparent="1" />
		<widget font="Regular;18" name="statusbar" position="10,490" size="1080,20" transparent="1" />
		<widget name="kino" alphatest="blend" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/TMBD/kino_ru.png" transparent="1" position="30,90" size="350,300" zPosition="1" />
		<eLabel backgroundColor="#00bbbbbb" position="0,518" size="1100,2" />
		<ePixmap alphatest="on" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/TMBD/ig/red25.png" position=" 20,532" size="250,38" zPosition="1" />
		<ePixmap alphatest="on" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/TMBD/ig/green25.png" position="290,532" size="250,38" zPosition="1" />
		<ePixmap alphatest="on" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/TMBD/ig/yellow25.png" position="560,532" size="250,38" zPosition="1" />
		<ePixmap alphatest="on" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/TMBD/ig/blue25.png" position="830,532" size="250,38" zPosition="1" />
		<ePixmap pixmap="skin_default/buttons/key_menu.png" position="1048,5" zPosition="1" size="35,25" alphatest="on" />
		<ePixmap pixmap="skin_default/buttons/key_info.png" position="1048,35" zPosition="1" size="35,25" alphatest="on" />
		<widget backgroundColor="#9f1313" font="Regular;20" foregroundColor="#00ff2525" halign="center" name="key_red" position=" 20,536" size="250,38" transparent="1" valign="center" zPosition="2" />
		<widget backgroundColor="#1f771f" font="Regular;20" foregroundColor="#00389416" halign="center" name="key_green" position="290,536" size="250,38" transparent="1" valign="center" zPosition="2" />
		<widget backgroundColor="#a08500" font="Regular;20" foregroundColor="#00bab329" halign="center" name="key_yellow" position="560,536" size="250,38" transparent="1" valign="center" zPosition="2" />
		<widget backgroundColor="#18188b" font="Regular;20" foregroundColor="#006565ff" halign="center" name="key_blue" position="830,536" size="250,38" transparent="1" valign="center" zPosition="2" />
	</screen>"""

	skin_hd = """
		<screen name="KinoRu" position="90,90" size="1100,570" title="TMBD Details Plugin">
		<eLabel backgroundColor="#00bbbbbb" position="0,0" size="1100,2" />
		<widget font="Regular;22" name="title" position="20,20" size="740,28" transparent="1" valign="center" />
		<widget alphatest="blend" name="starsbg" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/TMBD/starsbar_empty.png" position="770,10" size="210,21" zPosition="2" />
		<widget name="stars" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/TMBD/starsbar_filled.png" position="770,10"  size="210,21" transparent="1" zPosition="3" />
		<widget font="Regular;20" halign="left" name="ratinglabel" foregroundColor="#00f0b400" position="770,34" size="210,23" transparent="1" />
		<widget font="Regular;20" name="voteslabel" halign="left" position="770,57" size="330,23" foregroundColor="#00f0b400" transparent="1" />
		<widget alphatest="blend" name="poster" position="30,80" size="110,170" />
		<widget name="menu" position="321,86" foregroundColor="#00f0b400" scrollbarMode="showOnDemand" size="760,390" zPosition="1" />
		<widget name="detailslabel" position="325,57" size="570,23" font="Regular;20" transparent="1" />  
		<widget font="Regular;20" name="castlabel" position="20,295" size="1064,195" transparent="1" />
		<widget font="Regular;20" name="extralabel" position="164,77" size="920,220" transparent="1" />
		<widget font="Regular;22" name="titlelabel" position="380,85" foregroundColor="#00f0b400" size="700,340" transparent="1" />
		<widget font="Regular;18" name="statusbar" position="10,490" size="1080,20" transparent="1" />
		<widget name="kino" alphatest="blend" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/TMBD/kino_ru.png" transparent="1" position="30,90" size="350,300" zPosition="1" />
		<eLabel backgroundColor="#00bbbbbb" position="0,518" size="1100,2" />
		<ePixmap alphatest="on" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/TMBD/ig/red25.png" position=" 20,532" size="250,38" zPosition="1" />
		<ePixmap alphatest="on" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/TMBD/ig/green25.png" position="290,532" size="250,38" zPosition="1" />
		<ePixmap alphatest="on" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/TMBD/ig/yellow25.png" position="560,532" size="250,38" zPosition="1" />
		<ePixmap alphatest="on" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/TMBD/ig/blue25.png" position="830,532" size="250,38" zPosition="1" />
		<ePixmap pixmap="skin_default/buttons/key_menu.png" position="1048,5" zPosition="1" size="35,25" alphatest="on" />
		<ePixmap pixmap="skin_default/buttons/key_info.png" position="1048,35" zPosition="1" size="35,25" alphatest="on" />
		<widget backgroundColor="#9f1313" font="Regular;20" foregroundColor="#00ff2525" halign="center" name="key_red" position=" 20,536" size="250,38" transparent="1" valign="center" zPosition="2" />
		<widget backgroundColor="#1f771f" font="Regular;20" foregroundColor="#00389416" halign="center" name="key_green" position="290,536" size="250,38" transparent="1" valign="center" zPosition="2" />
		<widget backgroundColor="#a08500" font="Regular;20" foregroundColor="#00bab329" halign="center" name="key_yellow" position="560,536" size="250,38" transparent="1" valign="center" zPosition="2" />
		<widget backgroundColor="#18188b" font="Regular;20" foregroundColor="#006565ff" halign="center" name="key_blue" position="830,536" size="250,38" transparent="1" valign="center" zPosition="2" />
	</screen>"""

	skin_sd = """
		<screen name="TMBD" position="center,center" size="600,420" title="TMBD Details Plugin" >
		<ePixmap pixmap="skin_default/buttons/red.png" position="0,0" zPosition="0" size="140,40" transparent="1" alphatest="on" />
		<ePixmap pixmap="skin_default/buttons/green.png" position="140,0" zPosition="0" size="140,40" transparent="1" alphatest="on" />
		<ePixmap pixmap="skin_default/buttons/yellow.png" position="280,0" zPosition="0" size="140,40" transparent="1" alphatest="on" />
		<ePixmap pixmap="skin_default/buttons/blue.png" position="420,0" zPosition="0" size="140,40" transparent="1" alphatest="on" />
		<ePixmap pixmap="skin_default/buttons/key_menu.png" position="565,5" zPosition="0" size="35,25" alphatest="on" />
		<ePixmap pixmap="skin_default/buttons/key_info.png" position="565,33" zPosition="1" size="35,25" alphatest="on" />
		<widget name="key_red" position="0,0" zPosition="1" size="140,40" font="Regular;18" valign="center" halign="center" backgroundColor="#9f1313" transparent="1" />
		<widget name="key_green" position="140,0" zPosition="1" size="140,40" font="Regular;18" valign="center" halign="center" backgroundColor="#1f771f" transparent="1" />
		<widget name="key_yellow" position="280,0" zPosition="1" size="140,40" font="Regular;18" valign="center" halign="center" backgroundColor="#a08500" transparent="1" />
		<widget name="key_blue" position="420,0" zPosition="1" size="140,40" font="Regular;18" valign="center" halign="center" backgroundColor="#18188b" transparent="1" />
		<widget name="title" position="10,40" size="330,45" valign="center" font="Regular;19"/>
		<widget name="kino" alphatest="blend" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/TMBD/kino_smail.png" transparent="1" position="10,110" size="110,170" zPosition="1" />
		<widget font="Regular;20" name="titlelabel" position="140,90" size="440,140" transparent="1" />
		<widget name="extralabel" position="105,90" size="485,140" font="Regular;18" />
		<widget name="castlabel" position="10,235" size="580,155" font="Regular;18"  zPosition="3"/>
		<widget name="ratinglabel" position="340,62" size="250,20" halign="center" font="Regular;18" foregroundColor="#f0b400"/>
		<widget name="statusbar" position="10,404" size="580,16" font="Regular;16" foregroundColor="#cccccc" />
		<widget font="Regular;16" halign="center" name="voteslabel" foregroundColor="#00f0b400" position="380,404" size="210,16" transparent="1" />
		<widget name="poster" position="4,90" size="96,140" alphatest="on" />
		<widget name="menu"  position="10,235" size="580,155" zPosition="2" scrollbarMode="showOnDemand" />
		<widget name="starsbg" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/TMBD/starsbar_empty.png" position="340,40" zPosition="0" size="210,21" transparent="1" alphatest="on" />
	<widget name="stars" position="340,40" size="210,21" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/TMBD/starsbar_filled.png" transparent="1" />
	</screen>"""  

        def __chooseSkin(self):
	      try:
	        screenWidth = getDesktop(0).size().width()
	      except:
	        screenWidth = 720
	      print "Screen width=%d" % (screenWidth)

	      if (screenWidth == 1280):
                      if config.plugins.tmbd.skins.value == "0":
	                      return KinoRu.skin_hd
	              if config.plugins.tmbd.skins.value == "1":
                              return KinoRu.skin_hd1
	      else:
	        return KinoRu.skin_sd

	def __init__(self, session, eventName, callbackNeeded=False, movielist = False):
		Screen.__init__(self, session)
		self.skin=self.__chooseSkin()
		self.eventName = eventName
		self.curResult = False
		self.noExit = False
		self.curPoster = False
		self.curInfos = False
		self.curPoster = False
		self.rating = None
		self.votes = None
		self.countrie = None
		self.year = None
		self.runtimes = None
		self.genres = None
		self.director = None
		self.cast = None
		self.age = None
		self.duplicated = None
		self.plot = None
		self.onShow.append(self.selectionChanged)
		self.movielist = movielist
		self.callbackNeeded = callbackNeeded
		self.callbackData = ""
		self.callbackGenre = ""
		self["kino"] = Pixmap()
		self["kino"].show()
		self["poster"] = Pixmap()
		self.picload = ePicLoad()
		self.picload.PictureData.get().append(self.paintPosterPixmapCB)
		self["stars"] = ProgressBar()
		self["starsbg"] = Pixmap()
		self["stars"].hide()
		self["starsbg"].hide()
		self.ratingstars = -1
		self.working = False
		self["title"] = Label("")
		self["title"].setText(_("Search in kinopoisk.ru ,please wait ..."))
		self["detailslabel"] = Label("")
		self["castlabel"] = ScrollLabel("")
		self["extralabel"] = ScrollLabel("")
		self["statusbar"] = Label("")
		self["ratinglabel"] = Label("")
		self["titlelabel"] = ScrollLabel("")
		self["titlelabel"].hide()
		self["voteslabel"] = Label("")
		self.resultlist = []
                self['menu'] = ItemList([]) 
		self["menu"].hide()
		self["key_red"] = Button(_("Exit"))
		self["key_green"] = Button("")
		self["key_yellow"] = Button("")
		self["key_blue"] = Button(_("Manual input"))
		self.Page = 0
		self.working = False
		self.refreshTimer = eTimer()
		self.refreshTimer.callback.append(self.KinoRuPoster)
		
		self["actions"] = ActionMap(["OkCancelActions", "ColorActions", "MovieSelectionActions", "DirectionActions"],
		{
			"ok": self.showExtras,
			"cancel": self.exit2,
			"down": self.pageDown,
			"up": self.pageUp,
			"left": self.scrollLabelPageUp,
			"right": self.scrollLabelPageDown,
			"red": self.exit,
			"green": self.searchYttrailer2,
			"yellow": self.showExtras,
			"blue": self.openVirtualKeyBoard,
			"contextMenu": self.contextMenuPressed,
			"showEventInfo": self.searchcomets
		}, -1)

		self.setTitle(_("Profile: kinopoisk.ru"))
		self.removCovers()
		self.testThread = None
		self.testTime = 2.0		# 1 seconds
		self.testHost = "www.kinopoisk.ru"
		self.testPort = 80		# www port
		if config.plugins.tmbd.test_connect.value:
			self.TestConnection()
		else:
			self.getKinoRu()

	def searchcomets(self):
                self.Page = 2
		if self.resultlist:
                        cont = '%s' % (self["menu"].getCurrent())
                        sel = '%s' % (cont.replace("['", "").replace("]", "").replace(", None", ""))  
			if sel:
				try:
                                        id = sel.split('id:')[1]
                                        id = '%s' % (id.split("end")[0])
				except:
					id = None
				if id is not None and id != 'n\a':
					if id != 'n\x07':
						try:
							comets = kinopoisk.search_comets(id)
						except:
							self.Page = 0
							self.noExit = False
							self.showMenu()
							return -1
						if comets != "":
                                                    text = ','.join(comets)
                                                    #text = '%s' % (comets)
				                    self.Page = 2
				                    self.noExit = True
				                    self["menu"].hide()
				                    self["detailslabel"].hide()
				                    self["extralabel"].hide()
				                    self["voteslabel"].show()
				                    self["castlabel"].hide()
				                    self["statusbar"].hide()
				                    self["titlelabel"].show()
				                    self["titlelabel"].setText(text)                                                    



	def selectionChanged(self):
		pass			

	def TestConnection(self):
		self.testThread = Thread(target=self.test)
		self.testThread.start()

	def get_iface_list(self):
		names = array.array('B', '\0' * BYTES)
		sck = socket(AF_INET, SOCK_DGRAM)
		bytelen = struct.unpack('iL', fcntl.ioctl(sck.fileno(), SIOCGIFCONF, struct.pack('iL', BYTES, names.buffer_info()[0])))[0]
		sck.close()
		namestr = names.tostring()
		return [namestr[i:i+32].split('\0', 1)[0] for i in range(0, bytelen, 32)]

	def test(self):
		global testOK
		link = "down"
		for iface in self.get_iface_list():
			if "lo" in iface: continue
			if os_path.exists("/sys/class/net/%s/operstate"%(iface)):
				fd = open("/sys/class/net/%s/operstate"%(iface), "r")
				link = fd.read().strip()
				fd.close()
			if link != "down": break
		if link != "down":
			s = socket(AF_INET, SOCK_STREAM)
			s.settimeout(self.testTime)
			try:
				testOK = not bool(s.connect_ex((self.testHost, self.testPort)))
			except:
				testOK = None
			if not testOK:
				print 'Conection failed'
				self.resetLabels()
				self["statusbar"].setText(_("No connect to kinopoisk.ru..."))
				s.close()
				self["title"].setText("")
				return
			else:
				s.shutdown(SHUT_RDWR)
				s.close()
				self.pauseTimer = eTimer()
				self.pauseTimer.callback.append(self.getKinoRu)
				self.pauseTimer.start(1500, True)
		else:
			testOK = None
			self.resetLabels()
			self["statusbar"].setText(_("Not found network connection..."))
			self["title"].setText("")
			return

	def exit(self):
            pluginpath = config.plugins.tmbd.kinoprofilparts.value
            if fileExists(pluginpath):
		try:
			os_system("rm -rf %s" % pluginpath)
		except:
			pass  	            
	    self.close()

	def exit2(self):
		if config.plugins.tmbd.exit_key.value == "1":
			self.session.openWithCallback(self.exitConfirmed, MessageBox, _("Close plugin?"), MessageBox.TYPE_YESNO)
		else:
			self.exit()

	def exitConfirmed(self, answer):
		if answer:
                       pluginpath = config.plugins.tmbd.kinoprofilparts.value
                       if fileExists(pluginpath):
		            try:
			            os_system("rm -rf %s" % pluginpath)
		            except:
			            pass  	            
	               self.close()

	def aboutAutor(self):
		self.session.open(MessageBox, _("Kinopoisk.ru\nDeveloper: Dima73 (c)2012\n\nDonate:\nWMZ  Z305015597712"), MessageBox.TYPE_INFO)

	def removCovers(self):
		if os.path.exists('/tmp/preview.jpg'):
				try:
					os.remove('/tmp/preview.jpg')
				except:
					pass

	def resetLabels(self):
		self["detailslabel"].setText("")
		self["ratinglabel"].setText("")
		self["title"].setText(_("Search in kinopoisk.ru ,please wait ..."))
		self["castlabel"].setText("")
		self["titlelabel"].setText("")
		self["extralabel"].setText("")
		self["voteslabel"].setText("")
		self["key_green"].setText("")
		self.ratingstars = -1
		self.curPoster = False
		self.rating = None
		self.votes = None
		self.countrie = None
		self.year = None
		self.runtimes = None
		self.genres = None
		self.director = None
		self.cast = None
		self.age = None
		self.duplicated = None
		self.plot = None
		self.curInfos = False

	def pageUp(self):
		if self.Page == 0:
			self["menu"].instance.moveSelection(self["menu"].instance.moveUp)
		if self.Page == 1:
			self["castlabel"].pageUp()
		if self.Page == 2:
                        self["titlelabel"].pageUp()

	def pageDown(self):
		if self.Page == 0:
			self["menu"].instance.moveSelection(self["menu"].instance.moveDown)
		if self.Page == 1:
			self["castlabel"].pageDown()
		if self.Page == 2:
                        self["titlelabel"].pageDown()
					
	def scrollLabelPageUp(self):
		self["extralabel"].pageUp()

	def scrollLabelPageDown(self):
		self["extralabel"].pageDown()

	def showMenu(self):
		global eventname, total
		self.noExit = False
		if self.curResult:
			self["menu"].show()
			self["kino"].show()
			self["titlelabel"].hide()
			self["extralabel"].hide()
			self["voteslabel"].hide()
			self["poster"].hide()
			self["stars"].hide()
			self["starsbg"].hide()
			self["castlabel"].hide()
			self["ratinglabel"].setText("")
			self["extralabel"].setText("")
			self["voteslabel"].setText("")
			self.ratingstars = -1
			self.curPoster = False
			self.curInfos = False
			self.rating = None
			self.votes = None
			self.countrie = None
			self.namedetals = None
			self.year = None
			self.runtimes = None
			self.genres = None
			self.director = None
			self.cast = None
			self.age = None
			self.duplicated = None
			self.plot = None
			self["castlabel"].setText("")
			self["extralabel"].setText("")
			self["titlelabel"].setText("")
			self["title"].setText(_("Search results for: %s") % (eventname))
			if total > 1:
			        self["detailslabel"].setText(_("Please select the matching entry:"))
			        self["detailslabel"].show()
			self["key_blue"].setText(_("Manual input"))
			if self.movielist:
				self["key_green"].setText("")
			else:
				self["key_green"].setText(_("Search Trailer"))
			self["key_yellow"].setText(_("Show movie details"))
			self.working = True

	def showExtras(self):
		if self.curResult:
			if not self.noExit:
				self.Page = 1
				self.noExit = True
				self["menu"].hide()
				self["detailslabel"].hide()
				self["extralabel"].show()
				self["voteslabel"].show()
				self["castlabel"].show()
				self["titlelabel"].hide()
				self["key_yellow"].setText("")
				self.showExtras2()
			else:
				self.Page = 0
				self.noExit = False
				self.showMenu()

	def showExtras2(self):
		if self.resultlist:
                        cont = '%s' % (self["menu"].getCurrent())
                        sel = '%s' % (cont.replace("['", "").replace("]", "").replace(", None", ""))  
			if sel:
				try:
                                        id = sel.split('id:')[1]
                                        id = '%s' % (id.split("end")[0])
				except:
					id = None
				if id is not None and id != 'n\a':
					if id != 'n\x07':
						try:
							film_data = kinopoisk.search_data(id)
						except:
							self.Page = 0
							self.noExit = False
							self.showMenu()
							return -1
						try:
							namedetals = film_data['title']
							self.namedetals = namedetals
						except:
							namedetals = ''                                                        
						self["key_yellow"].setText(_("Show search results"))
						self["title"].setText(_("Details for: %s") % (namedetals))
						self.removCovers()
						self.refreshTimer.start(100, True)
						try:
							rating = film_data['user_rating']
						except:
							rating = ''
						Ratingtext = ''
						if rating != '':
							Ratingtext = _("User Rating") + ": " + rating + " / 10"
							self.ratingstars = int(10*round(float(rating.replace(',','.')),1))
							self["stars"].show()
							self["stars"].setValue(self.ratingstars)
							self["starsbg"].show()
							self.rating = rating
						self["ratinglabel"].setText(Ratingtext)
						try:
							votes = film_data['rating_count']
						except:
							votes = ''
						Votestext = ''
						if votes != '':
							Votestext = _("Votes") + ": " + votes + _(" times")
							self.votes = votes
						self["voteslabel"].setText(Votestext)
						Extratext = ""
						Extratext2 = ""
						try:
							countrie = film_data['countries']
						except:
							countrie = ''
						if countrie != '':
							Extratext2 = "%s: %s\n" % (_("Country"), countrie)
							self.countrie = countrie
						try:
							year = film_data['year']
						except:
							year = ''
						if year != '':
							Extratext2 += "%s: %s\n" % (_("Appeared"), year)
							self.year = year
						try:
							runtime = film_data['runtime']
						except:
							runtime = ''
						if runtime != '' and runtime != '-':
							runtimes = runtime + _(" min.")
							Extratext2 += "%s: %s\n" % (_("Duration"), runtimes)
							self.runtimes = runtimes
						try:
							genres = film_data['genre']
						except:
							genres = ''
						if genres != '':
							Extratext2 += "%s: %s\n" % (_("Genre"), genres)
							self.genres = genres
						try:
							director = film_data['directors']
						except:
							director = ''
						if director != '':
							Extratext2 += "%s: %s\n" % (_("Director"), director)
							self.director = director
						try:
							cast = film_data['cast']
						except:
							cast = ''
						if cast != '':
							Extratext = "%s: %s\n" % (_("Actors"), cast)
							self.cast = cast
						try:
							age = film_data['movie_rating']
						except:
							age = ''
						if age != '':
							Extratext += "%s: %s\n" % (_("Age"), age)
							self.age = age
						try:
							duplicated = film_data['duplicate']
						except:
							duplicated = ''
						if duplicated != '':
							#duplicated = duplicated[:-1]
							Extratext += "%s: %s\n" % (_("Roles duplicated"), duplicated)
							self.duplicated = duplicated
						self["extralabel"].setText("%s%s" % (Extratext2, Extratext))
						try:
							plot = film_data['plot']
						except:
							plot = ''
						if plot != '':
							self["castlabel"].setText("%s" % (plot))
							self.plot = plot
						elif plot == '':
							self["castlabel"].setText("Описание отсутсвует")
							self.plot = plot							
						if Extratext2 != '' or Extratext != '':
							self.search_poster(id)
							if self.movielist:
								self["key_green"].setText(_("Save info / poster"))
								self.curInfos = True

	def search_poster(self, id):
                comets = ""
		if id:
                        if config.plugins.tmbd.kinoprofilposter.value == '1':
                             comets = kinopoisk.search_poster(id)
			     url = comets
			else:
                             url = 'http://st.kinopoisk.ru/images/film/%s.jpg' % (id)
			user_agent = 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_7_3) AppleWebKit/534.53.11 (KHTML, like Gecko) Version/5.1.3 Safari/534.53.10'
			req = urllib2.Request(url, headers = {'User-agent': user_agent, 'Accept': 'text/html'})
			#req = urllib2.Request(url, headers={"Accept" : "text/html"})
			#req.add_header('User-agent',user_agent)
			try:
				res = urllib2.urlopen(req)
			except:
				print 'The server couldn\'t fulfill the request.'
				res = None
			if res != None:
                            try:
				page = res.read()
				file = open('/tmp/preview.jpg','w')
				file.write(page)
				file.close()
				self["kino"].hide()
				self.curPoster = True
				self["poster"].show()
			    except socket.error:
                                self.session.open(MessageBox, _("socket.error!"), MessageBox.TYPE_INFO, timeout=2)
			
			
	def removmenu(self):
		list = [
			(_("Current poster and info"), self.removcurrent),
			(_("Only current poster"), self.removcurrentposter),
			(_("Only current info"), self.removcurrentinfo),
			(_("All posters for movie"), self.removresult),
		]
		self.session.openWithCallback(
			self.menuCallback,
			ChoiceBox,
			list = list,
			title= _("What exactly do you want to delete?"),
		)	

	def contextMenuPressed(self):
		if self.movielist:
			list = [
				(_("Text editing"), self.openKeyBoard),
				(_("Select from Favourites"), self.openChannelSelection),
				(_("Search Trailer"), self.searchYttrailer3),
				(_("Remove poster / info"), self.removmenu),
				(_("Settings"), self.Menu2),
                                (_("Installing components"), self.components),
                                (_("Selecting poster"), self.posterselect),
                                (_("Selecting poster TMBD"), self.posterselectTMBD),                                 
			]
		else:
			list = [
				(_("Text editing"), self.openKeyBoard),
				(_("Select from Favourites"), self.openChannelSelection),
				(_("Settings"), self.Menu2),
                                (_("Installing components"), self.components),                                
			]
		self.session.openWithCallback(
			self.menuCallback,
			ChoiceBox,
			list = list,
			title= _("Select action:"),
		)

	def components(self):
		if fileExists("/usr/lib/enigma2/python/Plugins/Extensions/TMBD/Components"):
                    os.system("cp -f /usr/lib/enigma2/python/Plugins/Extensions/TMBD/Components/MovieInfo.py /usr/lib/enigma2/python/Components/Converter/MovieInfo.py")
                    os.system("cp -f /usr/lib/enigma2/python/Plugins/Extensions/TMBD/Components/RatingTmbd.py /usr/lib/enigma2/python/Components/Renderer/RatingTmbd.py")
                    os.system("cp -f /usr/lib/enigma2/python/Plugins/Extensions/TMBD/Components/CoverTmbd.py /usr/lib/enigma2/python/Components/Renderer/CoverTmbd.py")
                    os.system("cp -f /usr/lib/enigma2/python/Plugins/Extensions/TMBD/Components/CoverTmbdBig.py /usr/lib/enigma2/python/Components/Renderer/CoverTmbdBig.py")
                else:
                    pass		

	def Menu2(self):
		self.session.openWithCallback(self.workingFinished, TMBDSettings)

	def posterselect(self):
		if self.resultlist:
                        event = self.eventName
                        cont = '%s' % (self["menu"].getCurrent())
                        sel = '%s' % (cont.replace("['", "").replace("]", "").replace(", None", ""))  
			if sel:
				try:
                                        id = sel.split('id:')[1]
                                        id = '%s' % (id.split("end")[0])
				except:
					id = None
				if id is not None and id != 'n\a':
		                      self.session.openWithCallback(self.workingFinished, Posterviem, id, event)
		                else:
                                    pass

	def posterselectTMBD(self):
                if self.eventName:
                        id = self.eventName.split("(")[0].strip()
			id = id.replace('"', '').replace('Х/Ф', '').replace('М/Ф', '').replace('Х/ф', '').replace('.', '')
			#title = title.replace('"', '').replace('\xd0\xa5/\xd0\xa4', '').replace('\xd0\x9c/\xd0\xa4', '').replace('\xd0\xa5/\xd1\x84', '').replace('.', '')
			id = id.replace('(18+)', '').replace('18+', '').replace('(16+)', '').replace('16+', '').replace('(12+)', '').replace('12+', '').replace('(7+)', '').replace('7+', '').replace('(6+)', '').replace('6+', '').replace('(0+)', '').replace('0+', '')                
                        self.session.openWithCallback(self.workingFinished, PosterviemTMBD, id)
                else:
                     pass
                        

	def saveresult(self):
		global name
		list = [
			(_("Yes"), self.savePosterInfo),
			(_("Yes,but write new meta-file"), self.writeMeta),
			(_("Only poster"), self.savePoster),
			(_("No"), self.exitChoice),
		]
		self.session.openWithCallback(
			self.menuCallback,
			ChoiceBox,
			title= _("Save poster and info for:\n %s ?") % (name),
			list = list,
		)

	def exitChoice(self):
		self.close()
		
	def savePoster(self):
		global name
		import os
		import shutil
		if self.curResult and self.curInfos and self.curPoster:
			if not fileExists("/media/hdd/covers"):
				try:
					os.makedirs("/media/hdd/covers")
				except OSError:
					pass
			if fileExists("/media/hdd/covers"):
				try:
					if fileExists("/tmp/preview.jpg"):
						shutil.copy2("/tmp/preview.jpg", "/media/hdd/covers/" + name + ".jpg")
						self.session.open(MessageBox, _("Poster %s saved!") % (name), MessageBox.TYPE_INFO, timeout=2)
				except OSError:
					pass

	def savePosterInfo(self):
		global name
		import os
		import shutil
		if self.curResult and self.curInfos:
			self.savedescrip()
		if not fileExists("/media/hdd/covers"):
			try:
				os.makedirs("/media/hdd/covers")
			except OSError:
				pass
		if fileExists("/media/hdd/covers"):
			try:
				if fileExists("/tmp/preview.jpg") and self.curPoster:
					shutil.copy2("/tmp/preview.jpg", "/media/hdd/covers/" + name + ".jpg")
					self.session.open(MessageBox, _("Poster %s saved!") % (name), MessageBox.TYPE_INFO, timeout=2)
			except OSError:
				pass

	def writeMeta(self):
		if self.curResult and self.curInfos:
			global name, movie2, eventname
			Extratext2 = ""
			namedetals2 = ""
			if len(movie2):
					TSFILE = movie2
			else:
				return
			current = self["menu"].l.getCurrentSelection()
			if current:
                                namedetals2 = self.namedetals
				namedetals2 = namedetals2.replace('\n','')
				if movie2.endswith(".ts"):
					name = namedetals2
				else:
					Extratext2 = "%s" % ( namedetals2)
				if self.genres:
					genre = self.genres
					genre = genre.replace('...', '')
					Extratext2 += " %s /" % (genre)
				if self.countrie:
					Extratext2 += " %s /" % (self.countrie)
				if self.cast:
					Extratext2 += " %s" % (self.cast)
				metaParser = MetaParser();
				metaParser.name = namedetals2
				metaParser.description = Extratext2;
				if os.path.exists(TSFILE + '.meta') and movie2.endswith(".ts"):
					readmetafile = open("%s.meta"%(movie2), "r")
					linecnt = 0
					line = readmetafile.readline()
					if line:
						line = line.strip()
						if linecnt == 0:
							metaParser.ref = eServiceReference(line)
					else:
						metaParser.ref = eServiceReference('1:0:0:0:0:0:0:0:0:0:')
					readmetafile.close()
				else:
					metaParser.ref = eServiceReference('1:0:0:0:0:0:0:0:0:0:')
				metaParser.time_create = getctime(TSFILE);
				metaParser.tags = '';
				metaParser.length = 0;
				metaParser.filesize = fileSize(TSFILE);
				metaParser.service_data = '';
				metaParser.data_ok = 1;
				metaParser.updateMeta(TSFILE);
				self.session.open(MessageBox, _("Write to new meta-file for:\n") + "%s" % (TSFILE), MessageBox.TYPE_INFO, timeout=3)
				self.timer = eTimer()
				self.timer.callback.append(self.savePosterInfo)
				self.timer.start(1500, True)

	def savedescrip(self):
		global name, movie2, dircontrol, number
		descrip = ""
		Extratext = ""
		namedetals = ""
		EITFILE2 = ""
		EITFILE3 = ""		
		filename = ""
		if config.plugins.tmbd.eit.value == "0":
		     if dircontrol:
                         if config.plugins.tmbd.movieselectionparts.value == "none":
                               EITFILE = number + '.eit'
                         else:
                               filename = os.path.split(number)[1]
                               EITFILE = config.plugins.tmbd.movieselectionparts.value + "/" + filename + '.eit'
                     else:        
		            if len(movie2):
                                if config.plugins.tmbd.movieselectionparts.value == "none":
			                EITFILE = movie2[:-2] + 'eit'
                                else:
                                        filename = os.path.split(movie2)[1]
                                        EITFILE = config.plugins.tmbd.movieselectionparts.value + "/" + filename[:-2] + 'eit'			                
		            else:
			            return
		else:
		     if dircontrol:
                         if config.plugins.tmbd.movieselectionparts.value == "none":
                               EITFILE = number + '.txt'
                               EITFILE2 = number + '.eit'
                         else:
                               filename = os.path.split(number)[1]
                               EITFILE = config.plugins.tmbd.movieselectionparts.value + "/" + filename + '.txt'
                               EITFILE2 = config.plugins.tmbd.movieselectionparts.value + "/" + filename + '.eit'
                     else:        
		            if len(movie2):
                                if config.plugins.tmbd.movieselectionparts.value == "none":
			               EITFILE = movie2[:-2] + 'txt'
			               EITFILE2 = movie2[:-2] + 'eit'
                                else:
                                        filename = os.path.split(movie2)[1]
                                        EITFILE = config.plugins.tmbd.movieselectionparts.value + "/" + filename[:-2] + 'txt'
                                        EITFILE2 = config.plugins.tmbd.movieselectionparts.value + "/" + filename[:-2] + 'eit'
                                        EITFILE3 = movie2[:-2] + 'eit'
		            else:
			            return
		current = self["menu"].l.getCurrentSelection()
		if current:
                        if config.plugins.tmbd.movieselectionparts.value != "none":
		             if not fileExists(config.plugins.tmbd.movieselectionparts.value):
			            try:
				            os.makedirs(config.plugins.tmbd.movieselectionparts.value)
			            except OSError:
				            pass                    
                        namedetals = self.namedetals
			if self.countrie:
				Extratext = "%s %s\n" % (_("Country:"), self.countrie)
			if self.genres:
				Extratext += "%s %s\n" % (_("Genre:"), self.genres)
			if self.plot:
				descrip = "%s\n" % (self.plot)
			if self.runtimes:
				descrip += "%s /" % (self.runtimes)
			if self.age:
				descrip += " %s %s /" % (_("Age:"), self.age)
			if self.rating and self.votes:
				descrip += _(" User Rating: ") + self.rating + _(" (%s votes)\n") % (self.votes)
			if self.cast:
				descrip += "%s %s\n" % (_("Actors:"), self.cast)
			if self.director:
				descrip += "%s %s\n" % (_("Director:"), self.director)
			if self.year:
				descrip += "%s %s\n" % (_("Appeared:"), self.year)
			if self.namedetals:
				descrip += "%s %s\n" % (_("Origname:"), self.namedetals)				
			Extratext = Extratext.replace('\xc2\xab', '"').replace('\xc2\xbb', '"').replace('\xe2\x80\xa6', '...').replace('\xe2\x80\x94', '-');
			Extratext = self.Cutext(Extratext)
			descrip = descrip.replace('\xc2\xab', '"').replace('\xc2\xbb', '"').replace('\xe2\x80\xa6', '...').replace('\xe2\x80\x94', '-');
			namedetals = namedetals.replace('\xc2\xab', '"').replace('\xc2\xbb', '"').replace('\xe2\x80\xa6', '...').replace('\xe2\x80\x94', '-');
                        if config.plugins.tmbd.eit.value == "0":
			      sed = ShortEventDescriptor([]);
			      sed.setIso639LanguageCode('rus');
			      sed.setEventName(namedetals);
			      sed.setText(Extratext);
			      eed = ExtendedEventDescriptor([]);
			      eed.setIso639LanguageCode('rus');
			      eed.setText(descrip);
			      newEvent = Event();
			      newEvent.setShortEventDescriptor(sed);
			      newEvent.setExtendedEventDescriptor(eed);
			      ret = newEvent.saveToFile(EITFILE);
			      self.session.open(MessageBox, _("Write event to new eit-file:\n") + "%s\n" % (EITFILE) + _("%d bytes") % (ret), MessageBox.TYPE_INFO, timeout=3)
                        else:
		              if fileExists(EITFILE2):
                                   os.remove(EITFILE2)
		              elif fileExists(EITFILE3):
                                   os.remove(EITFILE3)                                   
                              fetchurl = "%s%s" % (Extratext, descrip)
                              temp_file = open(EITFILE, "w")
                              temp_file.write(fetchurl)
                              temp_file.close()
                              filesize = int(os.stat(EITFILE).st_size)
                              self.session.open(MessageBox, _("Write event to new txt-file:\n") + "%s\n" % (EITFILE) + _("%d bytes") % (filesize), MessageBox.TYPE_INFO, timeout=3)

	def Cutext(self, text):
		if text > 0:
			return text[:179]
		else:
			return text

	def removcurrent(self):
		global name
		self.session.openWithCallback(self.removcurrentConfirmed, MessageBox, _("Remove current poster and info for:\n%s ?") % (name), MessageBox.TYPE_YESNO)

	def removcurrentposter(self):
		global movie2, name
		if len(movie2):
			dir_cover = '/media/hdd/covers/'
			if movie2.endswith(".ts"):
				if os.path.exists(movie2 + '.meta'):
					try:
						readmetafile = open("%s.meta"%(movie2), "r")
						name_cur = readmetafile.readline()[0:-1]
						name_cover = name_cur + '.jpg'
					except:
						name_cover = ""
					readmetafile.close()
				else:
					name_cover = name + '.jpg'
			else:
					name_cover = name + '.jpg'
			remove_jpg = dir_cover + name_cover
			if os.path.exists(remove_jpg):
				try:
					os.remove(remove_jpg)
					self.session.open(MessageBox, _("%s poster removed!") % (remove_jpg), MessageBox.TYPE_INFO, timeout=3)
				except:
					pass
		else:
			return

	def removcurrentinfo(self):
		global movie2, name
		if len(movie2):
			remove_eit = movie2[:-2] + 'eit'
			if os.path.exists(remove_eit):
				try:
					os.remove(remove_eit)
					self.session.open(MessageBox, _("%s eit-file removed!") % (remove_eit), MessageBox.TYPE_INFO, timeout=3)
				except:
					pass
			remove_meta = movie2 + '.meta'
			if os.path.exists(remove_meta):
				try:
					os.remove(remove_meta)
					self.session.open(MessageBox, _("%s meta-file removed!") % (remove_meta), MessageBox.TYPE_INFO, timeout=3)
				except:
					pass
		else:
			return

	def removcurrentConfirmed(self, confirmed):
		if not confirmed:
			return
		else:
			global movie2, name
			if len(movie2):
				dir_cover = '/media/hdd/covers/'
				remove_eit = movie2[:-2] + 'eit'
				if os.path.exists(remove_eit):
					try:
						os.remove(remove_eit)
						self.session.open(MessageBox, _("%s eit-file removed!") % (remove_eit), MessageBox.TYPE_INFO, timeout=3)
					except:
						pass
				if movie2.endswith(".ts"):
					if os.path.exists(movie2 + '.meta'):
						try:
							readmetafile = open("%s.meta"%(movie2), "r")
							name_cur = readmetafile.readline()[0:-1]
							name_cover = name_cur + '.jpg'
						except:
							name_cover = ""
						readmetafile.close()
					else:
						name_cover = name + '.jpg'
				else:
					name_cover = name + '.jpg'
				remove_jpg = dir_cover + name_cover
				if os.path.exists(remove_jpg):
					try:
						os.remove(remove_jpg)
						self.session.open(MessageBox, _("%s poster removed!") % (remove_jpg), MessageBox.TYPE_INFO, timeout=3)
					except:
						pass
				remove_meta = movie2 + '.meta'
				if os.path.exists(remove_meta):
					try:
						os.remove(remove_meta)
						self.session.open(MessageBox, _("%s meta-file removed!") % (remove_meta), MessageBox.TYPE_INFO, timeout=3)
					except:
						pass
			else:
				return

	def removresult(self):
		self.session.openWithCallback(self.removresultConfirmed, MessageBox, _("Remove all posters?"), MessageBox.TYPE_YESNO)

	def removresultConfirmed(self, confirmed):
		import os
		import shutil
		if not confirmed:
			return
		else:
			if fileExists("/media/hdd/covers"):
				try:
					shutil.rmtree("/media/hdd/covers")
					self.session.open(MessageBox, _("All posters removed!"), MessageBox.TYPE_INFO, timeout=3)
				except OSError:
					pass

	def menuCallback(self, ret = None):
		ret and ret[1]()

	def searchYttrailer3(self):
		if fileExists(resolveFilename(SCOPE_PLUGINS, "Extensions/YTTrailer/plugin.pyc")) or fileExists(resolveFilename(SCOPE_PLUGINS, "Extensions/YTTrailer/plugin.pyo")):
			self.searchYttrailer()
		else:
			if fileExists(resolveFilename(SCOPE_PLUGINS, "Extensions/TMBD/enigma2-plugin-extensions-yttrailer_2.0_all.ipk")):
				self.session.openWithCallback(self.yesNo, MessageBox, _("YTTrailer is not installed.\nInstall YTTrailer now?"), MessageBox.TYPE_YESNO, default = False)
			else:
				self.session.openWithCallback(self.workingFinished, MessageBox, ("YTTrailer is not installed. Please install YTTrailer."), MessageBox.TYPE_INFO, timeout=5)		

	def searchYttrailer2(self):
		if self.movielist and self.curResult and self.curInfos:
			self.saveresult()
		else:
			if fileExists(resolveFilename(SCOPE_PLUGINS, "Extensions/YTTrailer/plugin.pyc")) or fileExists(resolveFilename(SCOPE_PLUGINS, "Extensions/YTTrailer/plugin.pyo")):
				self.searchYttrailer()
			else:
				if fileExists(resolveFilename(SCOPE_PLUGINS, "Extensions/TMBD/enigma2-plugin-extensions-yttrailer_2.0_all.ipk")):
					self.session.openWithCallback(self.yesNo, MessageBox, _("YTTrailer is not installed.\nInstall YTTrailer now?"), MessageBox.TYPE_YESNO, default = False)
				else:
					self.session.openWithCallback(self.workingFinished, MessageBox, ("YTTrailer is not installed. Please install YTTrailer."), MessageBox.TYPE_INFO, timeout=5)

	def yesNo(self, answer):
		if answer is True:
			self.yesInstall()

	def yesInstall(self):
		if fileExists(resolveFilename(SCOPE_PLUGINS, "Extensions/TMBD/enigma2-plugin-extensions-yttrailer_2.0_all.ipk")):
			cmd = "opkg install -force-overwrite -force-downgrade /usr/lib/enigma2/python/Plugins/Extensions/TMBD/enigma2-plugin-extensions-yttrailer_2.0_all.ipk"
			self.session.open(Console, _("Install YTTrailer..."), [cmd])

	def searchYttrailer(self):
		try:
			from Plugins.Extensions.YTTrailer.plugin import YTTrailerList, baseEPGSelection__init__
		except ImportError as ie:
			pass
		if baseEPGSelection__init__ is None:
			return
		if self.curResult:
			current = self.eventName.replace(' ', '+')
			eventname = current
			if eventname:
				self.session.open(YTTrailerList, eventname)

	def workingFinished(self, callback=None):
		self.working = False

	def openKeyBoard(self):
		global eventname
		self.session.openWithCallback(
			self.gotSearchString,
			InputBox,
			title = _("Edit text to search for"), text=eventname, visible_width = 40, maxSize=False, type=Input.TEXT)

	def openVirtualKeyBoard(self):
		if config.plugins.tmbd.virtual_text.value == "0":
			self.session.openWithCallback(
				self.gotSearchString,
				VirtualKeyBoard,
				title = _("Enter text to search for")
			)
		else:
			global eventname
			self.session.openWithCallback(
				self.gotSearchString,
				VirtualKeyBoard,
				title = _("Edit text to search for"),
				text=eventname
			)

	def openChannelSelection(self):
		self.session.openWithCallback(
			self.gotSearchString,
			TMBDChannelSelection
		)

	def gotSearchString(self, ret = None):
		if ret:
			global total
			self.eventName = ret
			self.Page = 0
			self.resultlist = []
			self["menu"].hide()
			self.resetLabels()
			self["castlabel"].setText("")
			self["ratinglabel"].setText("")
			self["castlabel"].hide()
			self["extralabel"].setText("")
			self["voteslabel"].setText("")
			self["titlelabel"].setText("")
			self["detailslabel"].hide()
			self["poster"].hide()
			self["stars"].hide()
			self["starsbg"].hide()
			self.removCovers()
			total = 0
			self["detailslabel"].setText("")
			self["statusbar"].setText("")
			self.noExit = False
			self.curResult = False
			self.curPoster = False
			self.curInfos = False
			self.rating = None
			self.votes = None
			self.countrie = None
			self.year = None
			self.runtimes = None
			self.genres = None
			self.director = None
			self.cast = None
			self.age = None
			self.duplicated = None
			self.plot = None
			self["key_yellow"].setText("")
			self["key_green"].setText("")
			self["kino"].show()
			self["title"].setText(_("Search in kinopoisk.ru ,please wait ..."))
			if config.plugins.tmbd.test_connect.value:
				self.TestConnection()
			else:
				self.getKinoRu()

	def getKinoRu(self):
		global eventname, total
		total = ""
		self.resetLabels()
		if not self.eventName:
			s = self.session.nav.getCurrentService()
			info = s and s.info()
			event = info and info.getEvent(0) # 0 = now, 1 = next
			if event:
				self.eventName = event.getEventName()
		if self.eventName:
                        
			title = self.eventName.split("(")[0].strip()
			title = title.replace('"', '').replace('Х/Ф', '').replace('М/Ф', '').replace('Х/ф', '').replace('.', '')
			#title = title.replace('"', '').replace('\xd0\xa5/\xd0\xa4', '').replace('\xd0\x9c/\xd0\xa4', '').replace('\xd0\xa5/\xd1\x84', '').replace('.', '')
			title = title.replace('(18+)', '').replace('18+', '').replace('(16+)', '').replace('16+', '').replace('(12+)', '').replace('12+', '').replace('(7+)', '').replace('7+', '').replace('(6+)', '').replace('6+', '').replace('(0+)', '').replace('0+', '')
			try:
                                if config.plugins.tmbd.kinoprofil.value == "0":
                                     results = kinopoisk.search_title2(title)   
                                else:        
				     results = kinopoisk.search_title(title)
			except:
				results = []
			if results is None:
				self["statusbar"].setText("")
				self["title"].setText("")
				eventname = self.eventName
				self.curResult = False
				#self.session.open(MessageBox, _("Library lmxl is not installed!\nTry to install the library again or change the method of processing data in the settings menu."), MessageBox.TYPE_ERROR)
				return
			if len(results) == 0:
				self["statusbar"].setText(_("Nothing found for: %s or no answer in kinopoisk.ru") % (self.eventName))
				self["title"].setText("")
				eventname = self.eventName
				self.curResult = False
				return False
			self.resultlist = []
			for result in results:
                            if config.plugins.tmbd.kinoprofil.value == "0":
                                    name = '%s' % (result)
				    try:
                                        if "rating:" in name:
                                            id = name.split("rating:")[1]
			                    id1 = id.split("ends")[0]
			                    id2 = id1.split(".")[0]
			                else:
                                            id2 = "0"
                                        if "id:" in name:
                                            id3 = name.split("id:")[1]
			                    idicon = id3.split("end")[0]
			                else:			                    
			                    idicon = "none"
                                        starss = resolveFilename(SCOPE_PLUGINS, "Extensions/TMBD/starsbar/%s.png") % (id2)
                                        name3 = MenuBild(name, idicon, starss)
					self.resultlist.append(name3)
					total = len(results)
					if len(results) > 0:
						self["statusbar"].setText(_("Total results: %s") % (total))
					eventname = self.eventName
					self.curResult = True
				    except:
					pass
			            self.showMenu()
			            self['menu'].l.setItemHeight(102)
			            self["menu"].l.setList(self.resultlist)                                    
                            else:
                                    name = '%s' % (result)
                                    names = name.split(',')[0]
                                    id = name.split("id:")[1]
                                    genres = name.split('genres:')[1]
                                    gen = genres.split('end')[0]
          		            if gen =="":			                    
			                 gen = "Описание жанра отсутствует"                                       
                                    genr = '%s \n\n id:%s end' % (gen, id)   
                                    res = [(names, genr)]
                                    colors = int(config.plugins.tmbd.kinoprofilcolor.value)
				    try:
                                        res.append(MultiContentEntryText(pos=(5, 2), size=(560, 22), font=1, text=names, color=colors))
                                        res.append(MultiContentEntryText(pos=(5, 26), size=(560, 22), font=1, text=genr))
					self.resultlist.append(res)
					total = len(results)
					if len(results) > 0:
						self["statusbar"].setText(_("Total results: %s") % (total))
					eventname = self.eventName
					self.curResult = True
				    except:
					pass
			            self.showMenu()
			            self['menu'].l.setItemHeight(55)
			            self["menu"].l.setList(self.resultlist)
		else:
			self["title"].setText(_("Enter or choose event for search ..."))

	def KinoRuPoster(self):
		if not self.curResult:
			self.removCovers()
		if fileExists("/tmp/preview.jpg"):
			jpg_file = "/tmp/preview.jpg"
		else:
			jpg_file = resolveFilename(SCOPE_PLUGINS, "Extensions/TMBD/picon_default.png")
		sc = AVSwitch().getFramebufferScale()
		self.picload.setPara((self["poster"].instance.size().width(), self["poster"].instance.size().height(), sc[0], sc[1], False, 1, "#00000000"))
		self.picload.startDecode(jpg_file)

	def textNo(self, text):
		if text == None or text == "0":
			return ''
		else:
			return _("/ Duration: ") + text + _(" min.")

	def paintPosterPixmapCB(self, picInfo=None):
		ptr = self.picload.getData()
		if ptr != None and self.curResult and self.curPoster:
			self["poster"].instance.setPixmap(ptr.__deref__())
			self["poster"].show()
		else:
			self["poster"].hide()

	def createSummary(self):
		#return KinoRuLCDScreen
		pass

#class KinoRuLCDScreen(Screen):
#	skin = """
#	<screen position="0,0" size="132,64" title="TMBD Details">
#		<widget name="headline" position="4,0" size="128,22" font="Regular;20"/>
#		<widget source="parent.title" render="Label" position="6,26" size="120,34" font="Regular;14"/>
#
#	def __init__(self, session, parent):
#		Screen.__init__(self, session, parent)
#		self["headline"] = Label(_("Search in kinopoisk.ru"))




SelectionChanged = MovieList.selectionChanged

class Instalcomponents(Screen):
	skin = """
           <screen position="center,center" size="460,400" title="Instal Tmbd components Settings">
			<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/TMBD/header.png" position="10,5" size="442,64" zPosition="1" alphatest="on" transparent="1" />
			<widget name="list" position="10,95" size="440,195" scrollbarMode="showOnDemand" transparent="1"  zPosition="1" />
			<widget name="info" position="10,330" size="370,50" font="Regular;20" transparent="1"  foregroundColor="#00bab329" />
        </screen>"""

	def __init__(self, session):
		self.skin = Instalcomponents.skin
		Screen.__init__(self, session)
		self.setup_title = (_("Instal Tmbd components Settings"))
		self["info"] = Label(_("Select the desired changed..."))
		self.resultlist = []
		self["list"] = MenuList([])
		self["actions"] = ActionMap(["OkCancelActions", "DirectionActions"],
		{
			"ok": self.okClicked,
			"cancel": self.close,
			"down": self.pageDown,
			"up": self.pageUp,
		}, -1)
                self.onLayoutFinish.append(self.showMenu)
                
	def pageUp(self):
		self['list'].instance.moveSelection(self['list'].instance.moveUp)
	
	def pageDown(self):
		self['list'].instance.moveSelection(self['list'].instance.moveDown)

	def showMenu(self):
		list = []
		list.append(_("Installing components"))
		list.append(_("Installing alternative MovieSelection"))
		list.append(_("Installing alternative MovieSelection for old pli"))		
		list.append(_("Restoring a backup  MovieSelection"))
		list.append(_("Update plugin"))		
		self["list"].setList(list)

	def okClicked(self):
		sel = self["list"].getCurrent()
                if sel == _("Installing components"):
			self.components()
                elif sel == _("Installing alternative MovieSelection"):
			self.MovieSelection()
                elif sel == _("Installing alternative MovieSelection for old pli"):
			self.MovieSelection2()				
                elif sel == _("Restoring a backup  MovieSelection"):
                        self.backupMovieSelection()
                elif sel == _("Update plugin"):
                        self.session.open(Updateplugin)
                if sel == _("Installing components") or sel == _("Installing alternative MovieSelection") or sel == _("Installing alternative MovieSelection for old pli") or sel == _("Restoring a backup  MovieSelection"):
	      	    restart = self.session.openWithCallback(self.restart, MessageBox, "%s\n\n%s\n%s" %(_("The selected settings are installed"), _("GUI needs a reboot to apply the changes."), _("Do you want to restart the GUI now?")), MessageBox.TYPE_YESNO)
		    restart.setTitle("%s" %(_("Do you want to restart the GUI now?")))

	def components(self):
		if fileExists("/usr/lib/enigma2/python/Plugins/Extensions/TMBD/Components"):
                    os.system("cp -f /usr/lib/enigma2/python/Plugins/Extensions/TMBD/Components/MovieInfo.py /usr/lib/enigma2/python/Components/Converter/MovieInfo.py")
                    os.system("cp -f /usr/lib/enigma2/python/Plugins/Extensions/TMBD/Components/RatingTmbd.py /usr/lib/enigma2/python/Components/Renderer/RatingTmbd.py")
                    os.system("cp -f /usr/lib/enigma2/python/Plugins/Extensions/TMBD/Components/CoverTmbd.py /usr/lib/enigma2/python/Components/Renderer/CoverTmbd.py")
                    os.system("cp -f /usr/lib/enigma2/python/Plugins/Extensions/TMBD/Components/CoverTmbdBig.py /usr/lib/enigma2/python/Components/Renderer/CoverTmbdBig.py")
                else:
                    pass

	def MovieSelection(self):
                bac = False
                bac2 = False
                if not fileExists("/usr/lib/enigma2/python/Components/MovieList.pybac") or not fileExists("/usr/lib/enigma2/python/Components/MovieList.pyobac"):
                    bac = False
                    if fileExists("/usr/lib/enigma2/python/Components/MovieList.py") and fileExists("/usr/lib/enigma2/python/Components/MovieList.pyobac"):
                        bac = True
                        pass
                    elif fileExists("/usr/lib/enigma2/python/Components/MovieList.py") and not fileExists("/usr/lib/enigma2/python/Components/MovieList.pyobac"):
                        bac = True
                        os.system("mv /usr/lib/enigma2/python/Components/MovieList.py /usr/lib/enigma2/python/Components/MovieList.pybac")
                    else:
                        bac = True
                        os.system("mv /usr/lib/enigma2/python/Components/MovieList.pyo /usr/lib/enigma2/python/Components/MovieList.pyobac")
                else:
                    bac = True
		if not fileExists("/usr/lib/enigma2/python/Screens/MovieSelection.pybac") or not fileExists("/usr/lib/enigma2/python/Screens/MovieSelection.pyobac"):
                    bac2 = False
                    if fileExists("/usr/lib/enigma2/python/Screens/MovieSelection.py") and fileExists("/usr/lib/enigma2/python/Screens/MovieSelection.pyobac"):
                        bac2 = True
                        pass
                    elif fileExists("/usr/lib/enigma2/python/Screens/MovieSelection.py") and not fileExists("/usr/lib/enigma2/python/Screens/MovieSelection.pyobac"):
                        bac2 = True
                        os.system("mv /usr/lib/enigma2/python/Screens/MovieSelection.py /usr/lib/enigma2/python/Screens/MovieSelection.pybac")
                    else:
                        bac2 = True
                        os.system("mv /usr/lib/enigma2/python/Screens/MovieSelection.pyo /usr/lib/enigma2/python/Screens/MovieSelection.pyobac")
                else:
                    bac2 = True
                if bac2 and bac:
                    os.system("cp -f /usr/lib/enigma2/python/Plugins/Extensions/TMBD/MovieSelection/MovieList.py /usr/lib/enigma2/python/Components/MovieList.py")
                    os.system("cp -f /usr/lib/enigma2/python/Plugins/Extensions/TMBD/MovieSelection/MovieSelection.py /usr/lib/enigma2/python/Screens/MovieSelection.py")

	def MovieSelection2(self):
                bac = False
                bac2 = False
                if not fileExists("/usr/lib/enigma2/python/Components/MovieList.pybac") or not fileExists("/usr/lib/enigma2/python/Components/MovieList.pyobac"):
                    bac = False
                    if fileExists("/usr/lib/enigma2/python/Components/MovieList.py") and fileExists("/usr/lib/enigma2/python/Components/MovieList.pyobac"):
                        bac = True
                        pass
                    elif fileExists("/usr/lib/enigma2/python/Components/MovieList.py") and not fileExists("/usr/lib/enigma2/python/Components/MovieList.pyobac"):
                        bac = True
                        os.system("mv /usr/lib/enigma2/python/Components/MovieList.py /usr/lib/enigma2/python/Components/MovieList.pybac")
                    else:
                        bac = True
                        os.system("mv /usr/lib/enigma2/python/Components/MovieList.pyo /usr/lib/enigma2/python/Components/MovieList.pyobac")
                else:
                    bac = True
		if not fileExists("/usr/lib/enigma2/python/Screens/MovieSelection.pybac") or not fileExists("/usr/lib/enigma2/python/Screens/MovieSelection.pyobac"):
                    bac2 = False
                    if fileExists("/usr/lib/enigma2/python/Screens/MovieSelection.py") and fileExists("/usr/lib/enigma2/python/Screens/MovieSelection.pyobac"):
                        bac2 = True
                        pass
                    elif fileExists("/usr/lib/enigma2/python/Screens/MovieSelection.py") and not fileExists("/usr/lib/enigma2/python/Screens/MovieSelection.pyobac"):
                        bac2 = True
                        os.system("mv /usr/lib/enigma2/python/Screens/MovieSelection.py /usr/lib/enigma2/python/Screens/MovieSelection.pybac")
                    else:
                        bac2 = True
                        os.system("mv /usr/lib/enigma2/python/Screens/MovieSelection.pyo /usr/lib/enigma2/python/Screens/MovieSelection.pyobac")
                else:
                    bac2 = True
                if bac2 and bac:
                    os.system("cp -f /usr/lib/enigma2/python/Plugins/Extensions/TMBD/MovieSelection/MovieList.py /usr/lib/enigma2/python/Components/MovieList.py")
                    os.system("cp -f /usr/lib/enigma2/python/Plugins/Extensions/TMBD/MovieSelection/MovieSelection-old.py /usr/lib/enigma2/python/Screens/MovieSelection.py")

	def backupMovieSelection(self):
		if fileExists("/usr/lib/enigma2/python/Components/MovieList.pybac"):
                    os.system("mv /usr/lib/enigma2/python/Components/MovieList.pybac /usr/lib/enigma2/python/Components/MovieList.py")
                else:
                    if fileExists("/usr/lib/enigma2/python/Components/MovieList.py"):
                        os.system("rm /usr/lib/enigma2/python/Components/MovieList.py")                    
                    if fileExists("/usr/lib/enigma2/python/Components/MovieList.pyobac"):
	                os.system("mv /usr/lib/enigma2/python/Components/MovieList.pyobac /usr/lib/enigma2/python/Components/MovieList.pyo")
                if fileExists("/usr/lib/enigma2/python/Screens/MovieSelection.pybac"):
                    os.system("mv /usr/lib/enigma2/python/Screens/MovieSelection.pybac /usr/lib/enigma2/python/Screens/MovieSelection.py")
                else:
                    if fileExists("/usr/lib/enigma2/python/Screens/MovieSelection.py"):
                        os.system("rm /usr/lib/enigma2/python/Screens/MovieSelection.py")
                    if fileExists("/usr/lib/enigma2/python/Screens/MovieSelection.pyobac"):
                        os.system("mv /usr/lib/enigma2/python/Screens/MovieSelection.pyobac /usr/lib/enigma2/python/Screens/MovieSelection.pyo")
                    

	def restart(self, confirmed):
		if confirmed:
                    from Screens.Standby import TryQuitMainloop
		    self.session.open(TryQuitMainloop, 3)
		else:
		    self["info"].setText("%s" %(_("GUI needs a reboot to apply the changes!")))

			
class EventChoiseList:
	def __init__(self, session):
		self.session = session
		global eventname, eventname_now, eventname_next
		cur_name = ""
		eventname = ""
		eventname_now = ""
		eventname_next = ""
		profile = ""
		cur_ref = self.session.nav.getCurrentlyPlayingServiceReference()
		if cur_ref:
			refstr = cur_ref.toString()
			cur_name = ServiceReference(eServiceReference(refstr)).getServiceName()
		s = self.session.nav.getCurrentService()
		info = s and s.info()
		event_now = info and info.getEvent(0)	# 0 = now
		if event_now:
			eventName = event_now.getEventName().split("(")[0].strip()
			eventname_now = eventName.replace('"', '').replace('Х/Ф', '').replace('М/Ф', '').replace('Х/ф', '').replace('.', '').replace('18+', '').replace('(16+)', '').replace('16+', '').replace('(12+)', '').replace('12+', '').replace('(7+)', '').replace('7+', '').replace('(6+)', '').replace('6+', '').replace('(0+)', '').replace('0+', '')
		event_next = info and info.getEvent(1)	# 1 = next
		if event_next:
			eventName = event_next.getEventName().split("(")[0].strip()
			eventname_next = eventName.replace('"', '').replace('Х/Ф', '').replace('М/Ф', '').replace('Х/ф', '').replace('.', '').replace('18+', '').replace('(16+)', '').replace('16+', '').replace('(12+)', '').replace('12+', '').replace('(7+)', '').replace('7+', '').replace('(6+)', '').replace('6+', '').replace('(0+)', '').replace('0+', '')
		if event_now and event_next:
			keyslist = [ ]
			eventlist = [
			(_("Now: %s") % (eventname_now), self.Nowevent),
			(_("Next: %s") % (eventname_next), self.Nextevent),
			]
			if config.plugins.tmbd.profile.value == "0":
				profile = "themoviedb.org"
			else:
				profile = "kinopoisk.ru"
			keyslist.extend( [ "1", "2" ] )
			eventlist.append((_('Change profile'), self.ChangeProfile))
			keyslist.append('blue')
			dlg = self.session.openWithCallback(self.menuCallback,ChoiceBox,list = eventlist,keys = keyslist,title= _("%s\nProfile: %s\nSelect event for search:") % (cur_name, profile))
			dlg.setTitle(_("TMBD Details"))
		elif event_now and not event_next:
			self.Nowevent()
		else:
			if config.plugins.tmbd.no_event.value:
				if config.plugins.tmbd.profile.value == "0":
					self.session.open(TMBD, eventname, False)
				else:
					self.session.open(KinoRu, eventname, False)

	def ChangeProfile(self):
		if config.plugins.tmbd.profile.value == "0":
			config.plugins.tmbd.profile.value = "1"
		else:
			config.plugins.tmbd.profile.value = "0"
		config.plugins.tmbd.profile.save()

		
	def Nowevent(self):
		global eventname, eventname_now, eventname_next
		eventname = eventname_now
		if config.plugins.tmbd.profile.value == "0":
			self.session.open(TMBD, eventname, False)
		else:
			self.session.open(KinoRu, eventname, False)
	
	def Nextevent(self):
		global eventname, eventname_now, eventname_next
		eventname = eventname_next
		if config.plugins.tmbd.profile.value == "0":
			self.session.open(TMBD, eventname, False)
		else:
			self.session.open(KinoRu, eventname, False)
			
	def menuCallback(self, ret = None):
		ret and ret[1]()

		
class Posterviem(Screen):
	skin = """
		<screen name="Posterviem" position="90,90" size="1100,570" title="Kinopoisk Posterviem">
		<eLabel backgroundColor="#00bbbbbb" position="0,0" size="1100,2" />
		<widget font="Regular;22" name="title" position="20,20" size="740,28" transparent="1" valign="center" />
		<widget alphatest="blend" name="poster" position="30,60" size="285,398" />
		<widget name="menu" position="331,86" foregroundColor="#00f0b400" scrollbarMode="showOnDemand" size="760,390" zPosition="1" transparent="1" />
		<widget font="Regular;18" name="statusbar" position="10,490" size="1080,20" transparent="1" />
		<eLabel backgroundColor="#00bbbbbb" position="0,518" size="1100,2" />
		<ePixmap alphatest="on" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/TMBD/ig/red25.png" position=" 20,532" size="250,38" zPosition="1" />
		<ePixmap alphatest="on" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/TMBD/ig/green25.png" position="290,532" size="250,38" zPosition="1" />
		<ePixmap alphatest="on" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/TMBD/ig/yellow25.png" position="560,532" size="250,38" zPosition="1" />
		<ePixmap alphatest="on" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/TMBD/ig/blue25.png" position="830,532" size="250,38" zPosition="1" />
		<widget backgroundColor="#9f1313" font="Regular;20" foregroundColor="#00ff2525" halign="center" name="key_red" position=" 20,536" size="250,38" transparent="1" valign="center" zPosition="2" />
		<widget backgroundColor="#1f771f" font="Regular;20" foregroundColor="#00389416" halign="center" name="key_green" position="290,536" size="250,38" transparent="1" valign="center" zPosition="2" />
		<widget backgroundColor="#a08500" font="Regular;20" foregroundColor="#00bab329" halign="center" name="key_yellow" position="560,536" size="250,38" transparent="1" valign="center" zPosition="2" />
		<widget backgroundColor="#18188b" font="Regular;20" foregroundColor="#006565ff" halign="center" name="key_blue" position="830,536" size="250,38" transparent="1" valign="center" zPosition="2" />
	</screen>"""

	def __init__(self, session, id, event):
		self.skin = Posterviem.skin
		Screen.__init__(self, session)
		self["poster"] = Pixmap()
		self.id = id
		self.event = event
		self.picload = ePicLoad()
		self.picload.PictureData.get().append(self.paintPosterPixmapCB)
		self.onShow.append(self.getMenu)  
		self.resultlist = []
		self["title"] = Label("")
		self["statusbar"] = Label("")
		self["menu"] = MenuList(self.resultlist)
		self["key_red"] = Button(_("Exit"))
		self["key_green"] = Button(_("Save as background"))
		self["key_yellow"] = Button(_("Save as poster"))
		self["key_blue"] = Button("")
		self["actions"] = ActionMap(["OkCancelActions", "ColorActions", "DirectionActions"],
		{
			"ok": self.showExtras,
			"cancel": self.exit,
			"down": self.pageDown,
			"up": self.pageUp,
			"red": self.exit,
			"green": self.background,
			"yellow": self.saweposter,
			"blue": self.showExtras,
		}, -1)

	def exit(self):
            image = '/tmp/poster.jpg'
            if fileExists(image):
		try:
			os_system("rm -rf %s" % image)
		except:
			pass  	            
	    self.close()		

	def pageUp(self):
                id2 = ""
		self["menu"].instance.moveSelection(self["menu"].instance.moveUp)
		id2 = '%s' % (self["menu"].getCurrent())
                if "link:" in id2:
                    id = id2.split("link:")[1]
		    idposter = id.split("end")[0]
		    if idposter != "":
                        self.search_poster(idposter)		
	
	def pageDown(self):
                id2 = ""            
		self["menu"].instance.moveSelection(self["menu"].instance.moveDown)
		id2 = '%s' % (self["menu"].getCurrent())
                if "link:" in id2:
                    id = id2.split("link:")[1]
		    idposter = id.split("end")[0]
		    if idposter != "":
                        self.search_poster(idposter)

	def saweposter(self):
                global name
                results = ""
                id2 = ""            
		id2 = '%s' % (self["menu"].getCurrent())
                if "(" in id2:
                    id = id2.split("(")[1]
		    idposter = id.split(")")[0]
		    if idposter != "":
                        results = kinopoisk.poster_save(idposter)
                        if results != "":
			     user_agent = 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_7_3) AppleWebKit/534.53.11 (KHTML, like Gecko) Version/5.1.3 Safari/534.53.10'
			     req = urllib2.Request(results, headers = {'User-agent': user_agent, 'Accept': 'text/html'})
			     try:
				res = urllib2.urlopen(req)
			     except:
				print 'The server couldn\'t fulfill the request.'
				res = None
			     if res != None:
                                 try:
				    page = res.read()
				    filename = "/media/hdd/covers/%s.jpg" % (name)
				    file = open(filename,'w')
				    file.write(page)
				    file.close()
				    self.session.open(MessageBox, _("Poster %s saved!") % (name), MessageBox.TYPE_INFO, timeout=2)
                                 except socket.error:
                                     self.session.open(MessageBox, _("socket.error!"), MessageBox.TYPE_INFO, timeout=2)
                        else:
                            self.session.open(MessageBox, _("Cannot poster %s saved - data error!") % (name), MessageBox.TYPE_INFO, timeout=2)
                        

	def background(self):
                global name
                results = ""
                id2 = ""            
		id2 = '%s' % (self["menu"].getCurrent())
                if "(" in id2:
                    id = id2.split("(")[1]
		    idposter = id.split(")")[0]
		    if idposter != "":
                        results = kinopoisk.poster_save(idposter)
                        if results != "":
			     user_agent = 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_7_3) AppleWebKit/534.53.11 (KHTML, like Gecko) Version/5.1.3 Safari/534.53.10'
			     req = urllib2.Request(results, headers = {'User-agent': user_agent, 'Accept': 'text/html'})
			     try:
				res = urllib2.urlopen(req)
			     except:
				print 'The server couldn\'t fulfill the request.'
				res = None
			     if res != None:
                                 try:
				    page = res.read()
				    filename = "/media/hdd/covers/%s_big.jpg" % (name)
				    file = open(filename,'w')
				    file.write(page)
				    file.close()
				    self.session.open(MessageBox, _("Poster %s saved as background!") % (name), MessageBox.TYPE_INFO, timeout=2)
                                 except socket.error:
                                     self.session.open(MessageBox, _("socket.error!"), MessageBox.TYPE_INFO, timeout=2)
                        else:
                            self.session.open(MessageBox, _("Cannot poster %s saved as background - data error!") % (name), MessageBox.TYPE_INFO, timeout=2)

	def search_poster(self, idposter):
		if idposter:
			user_agent = 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_7_3) AppleWebKit/534.53.11 (KHTML, like Gecko) Version/5.1.3 Safari/534.53.10'
			req = urllib2.Request(idposter, headers = {'User-agent': user_agent, 'Accept': 'text/html'})
			try:
				res = urllib2.urlopen(req)
			except:
				print 'The server couldn\'t fulfill the request.'
				res = None
			if res != None:
                                 try:                            
				    page = res.read()
				    file = open('/tmp/poster.jpg','w')
				    file.write(page)
				    file.close()
				    self.ShowPoster()
                                 except socket.error:
                                     self.session.open(MessageBox, _("socket.error!"), MessageBox.TYPE_INFO, timeout=2)
		        else:
                                self.ShowPoster(noPoster = True)
				
	def showExtras(self):
		pass

	def getMenu(self):
                total = ""
                id2 = ""
		if self.id != "":
			try:
				results = kinopoisk.poster_viem(self.id)
			except:
				results = []			
			if len(results) == 0:
				self["statusbar"].setText(_("No posters found for: %s") % (self.event))
				self["title"].setText("")                            
				return False
			self.resultlist = []
			for result in results:
				try:
				    self.resultlist.append(result)                                    
				    total = len(results)
				    if len(results) > 0:
					self["statusbar"].setText(_("Total posters found: %s") % (total))
					self["title"].setText(_("Posters for: %s") % (self.event))
				except:
					pass
			self["menu"].l.setList(self.resultlist)
			id2 = '%s' % (self["menu"].getCurrent())
                        if "link:" in id2:
                            id = id2.split("link:")[1]
			    idposter = id.split("end")[0]
			    if idposter != "":
                                self.search_poster(idposter)
		else:
			pass

	def ShowPoster(self, noPoster = False):
		if not noPoster:
			filename = "/tmp/poster.jpg"
		else:
			filename = resolveFilename(SCOPE_PLUGINS, "Extensions/TMBD/picon_default.png")
		sc = AVSwitch().getFramebufferScale()
		self.picload.setPara((self["poster"].instance.size().width(), self["poster"].instance.size().height(), sc[0], sc[1], False, 1, "#00000000"))
		self.picload.startDecode(filename)

	def paintPosterPixmapCB(self, picInfo=None):
		ptr = self.picload.getData()
		if ptr != None:
			self["poster"].instance.setPixmap(ptr.__deref__())
			self["poster"].show()

class PosterviemTMBD(Screen):
	skin = """
		<screen name="PosterviemTMBD" position="90,90" size="1100,570" title="TMBD Posterviem">
		<eLabel backgroundColor="#00bbbbbb" position="0,0" size="1100,2" />
		<widget font="Regular;22" name="title" position="20,20" size="740,28" transparent="1" valign="center" />
		<widget alphatest="blend" name="poster" position="30,60" size="285,398" />
		<widget alphatest="blend" name="tmbdlogo" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/TMBD/tmbdposters.png" position="30,60" size="285,398" />
		<widget name="menu" position="331,86" foregroundColor="#00f0b400" scrollbarMode="showOnDemand" size="760,390" zPosition="1" transparent="1" />
		<widget name="menu2" position="331,86" foregroundColor="#00f0b400" scrollbarMode="showOnDemand" size="760,390" zPosition="1" transparent="1" />
		<widget font="Regular;18" name="statusbar" position="10,490" size="1080,20" transparent="1" />
		<eLabel backgroundColor="#00bbbbbb" position="0,518" size="1100,2" />
		<ePixmap alphatest="on" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/TMBD/ig/red25.png" position=" 20,532" size="250,38" zPosition="1" />
		<ePixmap alphatest="on" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/TMBD/ig/green25.png" position="290,532" size="250,38" zPosition="1" />
		<ePixmap alphatest="on" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/TMBD/ig/yellow25.png" position="560,532" size="250,38" zPosition="1" />
		<ePixmap alphatest="on" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/TMBD/ig/blue25.png" position="830,532" size="250,38" zPosition="1" />
		<widget backgroundColor="#9f1313" font="Regular;20" foregroundColor="#00ff2525" halign="center" name="key_red" position=" 20,536" size="250,38" transparent="1" valign="center" zPosition="2" />
		<widget backgroundColor="#1f771f" font="Regular;20" foregroundColor="#00389416" halign="center" name="key_green" position="290,536" size="250,38" transparent="1" valign="center" zPosition="2" />
		<widget backgroundColor="#a08500" font="Regular;20" foregroundColor="#00bab329" halign="center" name="key_yellow" position="560,536" size="250,38" transparent="1" valign="center" zPosition="2" />
		<widget backgroundColor="#18188b" font="Regular;20" foregroundColor="#006565ff" halign="center" name="key_blue" position="830,536" size="250,38" transparent="1" valign="center" zPosition="2" />
                <ePixmap pixmap="skin_default/buttons/key_menu.png" position="1038,20" zPosition="0" size="35,25" alphatest="on" />
	</screen>"""

	def __init__(self, session, id):
		self.skin = PosterviemTMBD.skin
		Screen.__init__(self, session)
		self["poster"] = Pixmap()
		self["tmbdlogo"] = Pixmap()
		self.id = id
		self.curResult = False
		self.picload = ePicLoad()
		self.picload.PictureData.get().append(self.paintPosterPixmapCB)
		self.onShow.append(self.getMenu)
		self.Page = 0
		self["title"] = Label("")
		self["statusbar"] = Label("")		
		self.resultlist = []
		self.resultlist2 = []
		self['menu'] = ItemList([])
		self["menu"].show()
		self["menu2"] = MenuList(self.resultlist2)
		self["menu2"].hide()
		self["key_red"] = Button(_("Exit"))
		self["key_green"] = Button(_("Save as background"))
		self["key_yellow"] = Button(_("Save as poster"))
		self["key_blue"] = Button(_("Return"))
		self["actions"] = ActionMap(["OkCancelActions", "ColorActions", "DirectionActions", "MovieSelectionActions"],
		{
			"ok": self.okclick,
			"cancel": self.exit,
			"down": self.pageDown,
			"up": self.pageUp,
			"red": self.exit,
			"green": self.background,
			"yellow": self.saweposter,
			"blue": self.returns,
                        "contextMenu": self.manualinput,
		}, -1)
		self.click = False

	def exit(self):
            image = '/tmp/poster.jpg'
            if fileExists(image):
		try:
			os_system("rm -rf %s" % image)
		except:
			pass  	            
	    self.close()

	def returns(self):
            global totals
            self.click = True
            self.Page = 0
            self["menu2"].hide()
            self["menu"].show()
            self["key_yellow"].hide()
            self["key_green"].hide()
            self["key_blue"].hide()
            self["poster"].hide()
            self["tmbdlogo"].show()
            self["key_red"].show()
            self["title"].setText(_("Search results for: %s") % (self.id))
            self["statusbar"].setText(_("Total results: %s") % (totals))

	def pageUp(self):
                id2 = ""
                if self.Page == 0:
		     self["menu"].instance.moveSelection(self["menu"].instance.moveUp)
		if self.Page == 1:		     
		    self["menu2"].instance.moveSelection(self["menu"].instance.moveUp)
		    id2 = '%s' % (self["menu2"].getCurrent())
                    if "link:" in id2:
                        id = id2.split("link:")[1]
		        idposter = id.split("end")[0]
		        if idposter != "":
                            self.search_poster(idposter)		
	
	def pageDown(self):
                id2 = ""
                if self.Page == 0:
		     self["menu"].instance.moveSelection(self["menu"].instance.moveDown)
		if self.Page == 1:
                    self["menu2"].instance.moveSelection(self["menu"].instance.moveDown)
		    id2 = '%s' % (self["menu2"].getCurrent())
                    if "link:" in id2:
                        id = id2.split("link:")[1]
		        idposter = id.split("end")[0]
		        if idposter != "":
                            self.search_poster(idposter)

	def manualinput(self):
	    self.session.openWithCallback(
		self.manualinputString,
		InputBox,
		title = _("Edit text to search for"), text=self.id, visible_width = 40, maxSize=False, type=Input.TEXT)                            

	def manualinputString(self, ret = None):
	    if ret:
		self.id = ret
		self.getMenu()
			
	def saweposter(self):
            global name
            results = ""
            idposter = ""
            id2 = ""            
	    id2 = '%s' % (self["menu2"].getCurrent())
            if "link:" in id2:
                id = id2.split("link:")[1]
		idposter = id.split("end")[0]
		if idposter != "":
                    if "/w300/" in idposter:
                        results = idposter.split("/w300/")[1]
                        if results != "":
                             url = 'http://image.tmdb.org/t/p/original/%s' % (results)
			     user_agent = 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_7_3) AppleWebKit/534.53.11 (KHTML, like Gecko) Version/5.1.3 Safari/534.53.10'
			     req = urllib2.Request(url, headers = {'User-agent': user_agent, 'Accept': 'text/html'})
			     try:
				res = urllib2.urlopen(req)
			     except:
				print 'The server couldn\'t fulfill the request.'
				res = None
			     if res != None:
                                 try:
				    page = res.read()
				    filename = "/media/hdd/covers/%s.jpg" % (name)
				    file = open(filename,'w')
				    file.write(page)
				    file.close()
				    self.session.open(MessageBox, _("Poster %s saved!") % (name), MessageBox.TYPE_INFO, timeout=3)
                                    self.returns()
                                 except socket.error:
                                     self.session.open(MessageBox, _("socket.error!"), MessageBox.TYPE_INFO, timeout=3)
                        else:
                            self.session.open(MessageBox, _("Cannot poster %s saved - data error!") % (name), MessageBox.TYPE_INFO, timeout=2)
                        

	def background(self):
            global name
            results = ""
            idposter = ""            
            id2 = ""            
	    id2 = '%s' % (self["menu2"].getCurrent())
            if "link:" in id2:
                id = id2.split("link:")[1]
		idposter = id.split("end")[0]
		if idposter != "":
                    if "/w300/" in idposter:
                        results = idposter.split("/w300/")[1]
                        if results != "":
                             url = 'http://image.tmdb.org/t/p/original/%s' % (results)
			     user_agent = 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_7_3) AppleWebKit/534.53.11 (KHTML, like Gecko) Version/5.1.3 Safari/534.53.10'
			     req = urllib2.Request(url, headers = {'User-agent': user_agent, 'Accept': 'text/html'})
			     try:
				res = urllib2.urlopen(req)
			     except:
				print 'The server couldn\'t fulfill the request.'
				res = None
			     if res != None:
                                 try:
				    page = res.read()
				    filename = "/media/hdd/covers/%s_big.jpg" % (name)
				    file = open(filename,'w')
				    file.write(page)
				    file.close()
				    self.session.open(MessageBox, _("Poster %s saved as background!") % (name), MessageBox.TYPE_INFO, timeout=3)
                                    self.returns()
                                 except socket.error:
                                     self.session.open(MessageBox, _("socket.error!"), MessageBox.TYPE_INFO, timeout=3)
                        else:
                            self.session.open(MessageBox, _("Cannot poster %s saved as background - data error!") % (name), MessageBox.TYPE_INFO, timeout=2)

	def search_poster(self, idposter):
		if idposter:
			user_agent = 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_7_3) AppleWebKit/534.53.11 (KHTML, like Gecko) Version/5.1.3 Safari/534.53.10'
			req = urllib2.Request(idposter, headers = {'User-agent': user_agent, 'Accept': 'text/html'})
			try:
				res = urllib2.urlopen(req)
			except:
				print 'The server couldn\'t fulfill the request.'
				res = None
			if res != None:
                                 try:                            
				    page = res.read()
				    file = open('/tmp/poster.jpg','w')
				    file.write(page)
				    file.close()
				    self.ShowPoster()
                                 except socket.error:
                                     self.session.open(MessageBox, _("socket.error!"), MessageBox.TYPE_INFO, timeout=3)
		        else:
                                self.ShowPoster(noPoster = True)
				
	def showExtras(self):
		pass

	def getMenu(self):
                self.click = True
                global totals
                self.Page = 0
                total = ""
                id2 = ""
                curent = ""
                self["key_yellow"].hide()
                self["key_green"].hide()
                self["key_blue"].hide()
                self["tmbdlogo"].show()
               # .replace(' ', '%20')
                curent = self.id.replace(' ', '+')
		if curent != "":
			try:
				results = kinopoisk.search_tmbd(curent)
			except:
				results = []			
			if len(results) == 0:
				self["statusbar"].setText(_("Nothing found for: %s") % (self.id))
				self["title"].setText("")
				return False
			self.resultlist = []
			for result in results:
                            name = '%s' % (result)
			    try:
                                if "image:" in name:
                                    idi = name.split("image:")[1]
			            idicon = idi.split("ends")[0]
			        else:
                                    idicon = "None"
                                name3 = MenuBildTMBD(name, idicon)
				self.resultlist.append(name3)
				totals = len(results)
				if len(results) > 0:
				      self["statusbar"].setText(_("Total results: %s") % (totals))
				      self["title"].setText(_("Search results for: %s") % (self.id))                                    
				      self.curResult = True
			    except:
				pass
			self['menu'].l.setItemHeight(102)    
			self["menu"].l.setList(self.resultlist)
			id2 = '%s' % (self["menu"].getCurrent())
                        if "link:" in id2:
                            ids = id2.split("link:")[1]
			    idposters = ids.split("end")[0]
			    if idposters != "":
                                self.search_poster(idposters)                
		else:
			pass

        def okclick(self):
            if self.click:
                self.getMenu2()
            else:
                pass

            
	def getMenu2(self):
            self.click = False
            self["menu"].hide()
            self["key_blue"].show()
            self["key_red"].hide()
            self["tmbdlogo"].hide()
            idposter = ""
            self.Page = 1
            total = ""
            id2 = ""
            if self.curResult:
		id2 = '%s' % (self["menu"].getCurrent())
                if "id:" in id2:
                    id = id2.split("id:")[1]
		    idposter = id.split("end")[0]
		    if idposter != "":
			try:
				results = kinopoisk.poster_viemtmbd(idposter)
			except:
				results = []			
			if len(results) == 0:
                                self["menu2"].hide()
                                self["key_yellow"].hide()
                                self["key_green"].hide()                                
				self["statusbar"].setText(_("No posters found for: %s") % (self.id))
				self["title"].setText("")                               
				return False
			self.resultlist2 = []
			for result in results:
				try:
				    self.resultlist2.append(result)                                    
				    total = len(results)
				    if len(results) > 0:
                                        self["menu2"].show()
                                        self["key_yellow"].show()
                                        self["key_green"].show()                                        
					self["statusbar"].setText(_("Total posters found: %s") % (total))
					self["title"].setText(_("Posters for: %s") % (self.id))				    
				except:
					pass
			self["menu2"].l.setList(self.resultlist2)
			id2 = '%s' % (self["menu2"].getCurrent())
                        if "link:" in id2:
                            ids = id2.split("link:")[1]
			    idposters = ids.split("end")[0]
			    if idposters != "":
                                self.search_poster(idposters)
		else:
			pass		    

	def ShowPoster(self, noPoster = False):
		if not noPoster:
			filename = "/tmp/poster.jpg"
		else:
			filename = resolveFilename(SCOPE_PLUGINS, "Extensions/TMBD/picon_default.png")
		sc = AVSwitch().getFramebufferScale()
		self.picload.setPara((self["poster"].instance.size().width(), self["poster"].instance.size().height(), sc[0], sc[1], False, 1, "#00000000"))
		self.picload.startDecode(filename)

	def paintPosterPixmapCB(self, picInfo=None):
		ptr = self.picload.getData()
		if ptr != None:
			self["poster"].instance.setPixmap(ptr.__deref__())
			self["poster"].show()			

class Updateplugin(Screen):
    skin = """
            <screen name="Updateplugin" position="125,120" size="1030,420" title="TMBD Update plugin">
            <ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/TMBD/logo.png" position="804,0" zPosition="1" size="208, 46" transparent="1" alphatest="blend" />
            <widget name="menu" position="10,57" size="440,40" scrollbarMode="showOnDemand" transparent="1" zPosition="1" />
            <widget name="poster" position="22,160" zPosition="1" size="420,236" alphatest="on"/>
            <eLabel backgroundColor="#00999999" position="19,156" size="427,2" zPosition="2" />
            <eLabel backgroundColor="#00999999" position="19,398" size="427,2" zPosition="2" />
            <eLabel backgroundColor="#00999999" position="18,156" size="2,243" zPosition="2" />
            <eLabel backgroundColor="#00999999" position="445,156" size="2,243" zPosition="2" />
            <widget name="info" position="10,100" size="440,52" font="Regular;20" halign="center" transparent="1"  foregroundColor="#00bab329" />
	    <widget name="version" position="10,5" size="470,22" font="Regular;20" halign="left" noWrap="1" transparent="1" foregroundColor="#00bab329" />
	    <widget name="text" position="10,32" size="440,22" font="Regular;20" halign="left" transparent="1" foregroundColor="#00999999" />
	    <widget name="text2" position="492,5" size="440,22" font="Regular;20" halign="left" transparent="1" foregroundColor="#00bab329" />
	    <widget name="description" position="492,35" size="520,370" font="Regular;20" halign="left" transparent="1" foregroundColor="#00999999" />
            </screen>"""

    def __init__(self, session):
        self.skin = Updateplugin.skin
        Screen.__init__(self, session)
        self.resultlist = []
        self['menu'] = MenuList(self.resultlist)
        self['info'] = Label('')
        self['text'] = Label('')
        self['text2'] = Label('')        
        self['version'] = Label('')
        self['description'] = ScrollLabel('')
        self["poster"] = Pixmap()
        self['actions'] = ActionMap(['OkCancelActions', 'DirectionActions'], {'ok': self.okclicken,
         'cancel': self.exit,
         'down': self.pageDown,
         'up': self.pageUp,
         'left': self.pageUp,
         'right': self.pageDown}, -1)
        self.picon = ePicLoad()
        self.onShow.append(self.getPanelmenu)
        self.control = False

    def exit(self):
        os.system('rm /tmp/previem.jpg')
        os.system('rm /tmp/version')
        self.close()

    def pageUp(self):
        self['menu'].instance.moveSelection(self['menu'].instance.moveUp)
        self["description"].pageUp()

    def pageDown(self):
        self['menu'].instance.moveSelection(self['menu'].instance.moveDown)
        self["description"].pageDown()

    def search_poster(self):
        id = '/tmp/previem.jpg'
        if fileExists(id):
            self.picon.setPara((self["poster"].instance.size().width(), self["poster"].instance.size().height(), 1, 1, False, 1, '#00000000'))
            self.picon.startDecode(id, 0, 0, False)               
            png = self.picon.getData()				
	    self["poster"].instance.setPixmap(png)

    def okclicken(self):
        curversion2 = ""
        id = '%s' % (self['menu'].getCurrent())
        if self.control:    
            try:
                ftp = ftplib.FTP('81.222.215.241')
                ftp.login(login, decodeName(passwd))
                data = []
                ftp.retrbinary('RETR ' + id, open('/tmp/TMBD.tar.gz', 'wb').write)
                ftp.quit()
            except ftplib.all_errors as msg:
                pass
        if fileExists('/tmp/TMBD.tar.gz'):
            os.system('rm -rf /usr/lib/enigma2/python/Plugins/Extensions/TMBD')
            os.system('tar xzvpf /tmp/TMBD.tar.gz -C /')
            if fileExists("/usr/lib/enigma2/python/Plugins/Extensions/TMBD/version"):
                handler = open("/usr/lib/enigma2/python/Plugins/Extensions/TMBD/version")
                curversion2 = handler.read()
                handler.close()
            if id == curversion2:    
                os.system('rm /tmp/TMBD.tar.gz')
                os.system('rm /tmp/previem.jpg')
                os.system('rm /tmp/version')
                from Screens.Standby import TryQuitMainloop
                self.session.open(TryQuitMainloop, 3)
            else:
                error = "Update failed! Manually download the archive from the site and install it yourself!"
                self.session.open(MessageBox, error, MessageBox.TYPE_ERROR, 6)
        else:
                error = "Failed to download the update from the site! Manually download the archive from the site and install it yourself!"
                self.session.open(MessageBox, error, MessageBox.TYPE_ERROR, 6)            

    def getPanelmenu(self):
        controll = ''
        controll = controlFtp()
        if controll == '':
            self.control = True
            try:
                results = self.search_title()
            except:
                results = []
            if len(results) == 0:
                return False
            self.resultlist = []
            for searchResult in results:
                try:
                    self.resultlist.append(searchResult)
                except:
                    pass
            self['menu'].l.setList(self.resultlist)
            self['text'].setText(_("Available version:"))
            self.search_poster()
            self.description()
        else:
            self.control = False
            self['info'].setText(_("No ftplib instaled!"))

    def description(self):
        title = ''
        id = '/tmp/version'
        self['text2'].setText(_("Available in this version:"))
        if fileExists(id):
            temp = open(id)
            title = temp.read()
            temp.close()
            self['description'].setText(title)
        else:
            self['description'].setText(_("No description available"))

    def search_title(self):
        file = ""
        curversion = "" 
        search_results = []    
        if self.control:
            try:
                if fileExists("/usr/lib/enigma2/python/Plugins/Extensions/TMBD/version"):
                    handler = open("/usr/lib/enigma2/python/Plugins/Extensions/TMBD/version")
                    curversion = handler.read()
                    handler.close()
                    self['version'].setText(_("Your current version: %s") % (curversion.replace('.tar.gz', '')))
                else:
                    curversion = ""
                    self['version'].setText(_("Unable to determine the current version"))
                ftp = ftplib.FTP('81.222.215.241')
                ftp.login(login, decodeName(passwd))
                data = []
                ftp.retrbinary('RETR version', open('/tmp/version', 'wb').write)
                ftp.retrbinary('RETR previem.jpg', open('/tmp/previem.jpg', 'wb').write)
                ftp.dir(data.append)
                for line in data:
                    tmp = re.sub('\\s+', '*', line)
                    tmp = tmp.strip().split('*')
                    if len(tmp) > 8:
                        if "pli" in curversion:
                            if 'pli' in line and tmp[8] != '.' and tmp[8] != '..' and ':' in line:
                                id = line.index(':')
                                file = line[id + 4:]
                                search_results.append(file)
                        elif "BlackHole" in curversion:
                            if 'BlackHole' in line and tmp[8] != '.' and tmp[8] != '..' and ':' in line:
                                id = line.index(':')
                                file = line[id + 4:]
                                search_results.append(file)
                        elif curversion == "":
                            if '.tar.gz' in line and tmp[8] != '.' and tmp[8] != '..' and ':' in line:
                                id = line.index(':')
                                file = line[id + 4:]
                                search_results.append(file)                            
                ftp.quit()
            except ftplib.all_errors as msg:
                pass
            if curversion == file:
                self['info'].setText(_("Do you have the latest version of the plugin. No update needed. Click exit"))
            else:
                self['info'].setText(_("A new version of the plugin. recommend that you upgrade. Click OK to update"))
        return search_results


		
class MP3(Screen):
	skin = """
		<screen name="MP3" position="90,90" size="1100,570" title="TMBD MP3">
		<eLabel backgroundColor="#00bbbbbb" position="0,0" size="1100,2" />
		<widget font="Regular;22" name="titellabel" position="20,20" size="740,28" transparent="1" valign="center" />
		<widget alphatest="blend" name="poster" position="30,60" size="285,398" />
		<widget font="Regular;22" name="detailslabel" position="334,120" size="400,360" transparent="1" />
		<widget font="Regular;18" name="statusbar" position="10,490" size="1080,20" transparent="1" />
		<widget name="menu" position="750,89" foregroundColor="#00f0b400" scrollbarMode="showOnDemand" size="340,390" zPosition="1" transparent="1" />
		<eLabel backgroundColor="#00bbbbbb" position="0,518" size="1100,2" />
		<ePixmap alphatest="on" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/TMBD/ig/red25.png" position=" 20,532" size="250,38" zPosition="1" />
		<ePixmap alphatest="on" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/TMBD/ig/green25.png" position="290,532" size="250,38" zPosition="1" />
		<ePixmap alphatest="on" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/TMBD/ig/yellow25.png" position="560,532" size="250,38" zPosition="1" />
		<ePixmap alphatest="on" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/TMBD/ig/blue25.png" position="830,532" size="250,38" zPosition="1" />
		<widget backgroundColor="#9f1313" font="Regular;20" foregroundColor="#00ff2525" halign="center" name="key_red" position=" 20,536" size="250,38" transparent="1" valign="center" zPosition="2" />
		<widget backgroundColor="#1f771f" font="Regular;20" foregroundColor="#00389416" halign="center" name="key_green" position="290,536" size="250,38" transparent="1" valign="center" zPosition="2" />
		<widget backgroundColor="#a08500" font="Regular;20" foregroundColor="#00bab329" halign="center" name="key_yellow" position="560,536" size="250,38" transparent="1" valign="center" zPosition="2" />
		<widget backgroundColor="#18188b" font="Regular;20" foregroundColor="#006565ff" halign="center" name="key_blue" position="830,536" size="250,38" transparent="1" valign="center" zPosition="2" />
                <ePixmap pixmap="skin_default/buttons/key_menu.png" position="1038,20" zPosition="0" size="35,25" alphatest="on" />
	</screen>"""
	def __init__(self, session, eventName, args = None):
		self.skin = MP3.skin
		Screen.__init__(self, session)
		self.eventName = eventName
		self["poster"] = Pixmap()
		self.picload = ePicLoad()
		self.picload.PictureData.get().append(self.paintPosterPixmapCB)
		self.ratingstars = -1
		self["titellabel"] = Label("")
		self["detailslabel"] = Label("")
		self["key_red"] = Button(_("Exit"))
		self["key_green"] = Button("")
		self["statusbar"] = Label("")
		self["key_yellow"] = Button("")
		self["key_blue"] = Button("")
		self.resultlist = []
		self["menu"] = MenuList(self.resultlist)
		self.title = None
		self.artist = None
		self.genre = None
		self.date = None
		self.album = None
		self.tracknr = None
		self.track = None
		self.length = None
		self.bitrate = None
		self.curResult = False
		self.curPoster = False
		self["actions"] = ActionMap(["OkCancelActions", "ColorActions", "DirectionActions"],
		{
			"ok": self.showDetails,
			"cancel": self.exit,
			"red": self.exit,
			"green": self.saveresult,
			"down": self.pageDown,
			"up": self.pageUp,                        
			"yellow": self.openVirtualKeyBoard,
			"blue": self.openVirtualKeyBoard
		}, -1)
		self.currentFilename = eventName
		self.onShow.append(self.showDetails)

	def openVirtualKeyBoard(self):
		pass

	def pageUp(self):
                id2 = ""
		self["menu"].instance.moveSelection(self["menu"].instance.moveUp)
		id2 = '%s' % (self["menu"].getCurrent())
                if "link:" in id2:
                    id = id2.split("link:")[1]
		    idposter = id.split("end")[0]
		    if idposter != "":
                        self.search_poster(idposter)		
	
	def pageDown(self):
                id2 = ""            
		self["menu"].instance.moveSelection(self["menu"].instance.moveDown)
		id2 = '%s' % (self["menu"].getCurrent())
                if "link:" in id2:
                    id = id2.split("link:")[1]
		    idposter = id.split("end")[0]
		    if idposter != "":
                        self.search_poster(idposter)
                        
	def showDetails(self):
		self["detailslabel"].show()
		self["poster"].show()
		self["key_green"].setText(_("Save info / poster"))
		if self.currentFilename:
			   self.Page = 1
                           title2 = (_("unknown"))
			   Extratext = ""
                           from os import path as os_path
	                   if self.currentFilename.lower().startswith("http://"):
		                   Extratext = "%s\n" % (self.currentFilename)
	                   else:
		                   path,filename = os_path.split(self.currentFilename)
		                   self["titellabel"].setText("%s" % (filename)) 
		                   audio, isAudio, title, genre,artist,album,tracknr,track,date,length,bitrate = getID3Tags(path,filename)
		                   if audio:
			                   Extratext = "%s\n" % (title)
			                   self.title = title
			                   if artist:
				                   Extratext += "%s: %s\n" % (_("Actors"), artist)
				                   self.artist = artist
			                   else:
				                   Extratext += "%s: %s\n" % (_("Actors"), title2)
			                   if genre:
                                                   Extratext += "%s: %s\n" % (_("Genre"), genre)
                                                   self.genre = genre
			                   else:
				                   Extratext += "%s: %s\n" % (_("Genre"), title2)
			                   if date:
			                           Extratext += "%s %s\n" % (_("Appeared:"), date)
			                           self.date = date
			                   else:
				                   Extratext += "%s %s\n" % (_("Appeared:"), title2)
			                   if album:
			                           Extratext += "%s %s\n" % (_("Album:"), album)
			                           self.album = album
			                   else:
				                   Extratext += "%s %s\n" % (_("Album:"), title2)
			                   if tracknr:
			                           Extratext += "%s %s\n" % (_("Tracknr:"), tracknr)
			                           self.tracknr = tracknr
			                   else:
				                   Extratext += "%s %s\n" % (_("Tracknr:"), title2)
			                   if track:
			                           Extratext += "%s %s\n" % (_("Track:"), track)
			                           self.track = track
			                   else:
				                   Extratext += "%s %s\n" % (_("Track:"), title2)
			                   if length:
			                           Extratext += "%s %s\n" % (_("Length:"), length)
			                           self.length = length
			                   else:
				                   Extratext += "%s %s\n" % (_("Length:"), title2)
			                   if bitrate:
			                           Extratext += "%s %s\n" % (_("Bitrate:"), bitrate)
			                           self.bitrate = bitrate
			                   else:
				                   Extratext += "%s %s\n" % (_("Bitrate:"), title2)
				           self.curResult = True        
		                   else:
			                   Extratext = "%s\n" % ( title)
			                   self.curResult = False 
			           self["detailslabel"].setText("%s" % (Extratext))        
		                   #audio = None
		                   self.updateCover(artist, album)

	def updateCover(self, artist, album):
		hasCover = False
		audio = None
		audiotype = 0
		if self.currentFilename.lower().endswith(".mp3"):
			try:
                                from mutagen.id3 import ID3, USLT
				audio = ID3(self.currentFilename)
				audiotype = 1
			except: audio = None
		elif self.currentFilename.lower().endswith(".flac"):
			try: 
				audio = FLAC(self.currentFilename)
				audiotype = 2
			except: audio = None
		elif self.currentFilename.lower().endswith(".m4a"):
			try: 
				audio = MP4(self.currentFilename)
				audiotype = 3
			except: audio = None
		elif self.currentFilename.lower().endswith(".ogg"):
			try:
				audio = OggVorbis(self.currentFilename)
				audiotype = 4
			except: audio = None
		if audio:
			if audiotype == 1:
				apicframes = audio.getall("APIC")
				if len(apicframes) >= 1:
					hasCover = True
					coverArtFile = file("/tmp/preview.jpg", 'wb')
                    			coverArtFile.write(apicframes[0].data)
				        coverArtFile.close()
				        self.curPoster = True
				        self.ShowPoster()
			elif audiotype == 2:
				if len(audio.pictures) >= 1:
					hasCover = True
			elif audiotype == 3:
				if 'covr' in audio.tags:
					hasCover = True
			elif audiotype == 4:
				if 'METADATA_BLOCK_PICTURE' in audio.tags:
					hasCover = True
			audio = None
		if not hasCover:
			self.getMenu(artist, album)

	def getMenu(self, artist,album):
                count = 0
                total = ""
                all = ""
                id2 = ""
                name = ""
		if artist != "" and album != "":
			try:
                                url = "http://images.google.ru/images?q=%s+%s&tbm=isch" % (quote(album),quote(artist))
				results = kinopoisk.search_postermp3(url)
			except:
				results = []			
			if len(results) == 0:
				self["statusbar"].setText(_("No posters found for: %s") % (self.currentFilename))
				return False
			self.resultlist = []
			for result in results:
				try:
                                    count = count +1
                                    name = "- %i -" % (count)
                                    url = "link:" + result + "end"
                                    all = "%s\n\n%s" % (name, url)
				    self.resultlist.append(all)                                    
				    total = len(results)
				    if len(results) > 0:
					self["statusbar"].setText(_("Total posters found: %s") % (total))
				except:
					pass
			self["menu"].l.setList(self.resultlist)
			id2 = '%s' % (self["menu"].getCurrent())
                        if "link:" in id2:
                            id = id2.split("link:")[1]
			    idposter = id.split("end")[0]
			    if idposter != "":
                                self.search_poster(idposter)
		else:
			pass			

	def search_poster(self, idposter):
		if idposter != "" and idposter != "None":
			    user_agent = 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_7_3) AppleWebKit/534.53.11 (KHTML, like Gecko) Version/5.1.3 Safari/534.53.10'
			    req = urllib2.Request(idposter, headers = {'User-agent': user_agent, 'Accept': 'text/html'})
			    try:
				    res = urllib2.urlopen(req)
			    except:
				    print 'The server couldn\'t fulfill the request.'
				    res = None
			    if res != None:
                                 try:                            
				    page = res.read()
				    file = open('/tmp/preview.jpg','w')
				    file.write(page)
				    file.close()
				    self.ShowPoster()
				    self.curPoster = True
                                 except socket.error:
                                     self.session.open(MessageBox, _("socket.error!"), MessageBox.TYPE_INFO, timeout=3)
		            else:
                                    self.ShowPoster(noPoster = True)
                                    self.curPoster = False
		else:
			self.ShowPoster(noPoster = True)

	def ShowPoster(self, noPoster = False):
		if not noPoster:
			filename = "/tmp/preview.jpg"
		else:
			filename = resolveFilename(SCOPE_PLUGINS, "Extensions/TMBD/no_poster2.jpg")
		sc = AVSwitch().getFramebufferScale()
		self.picload.setPara((self["poster"].instance.size().width(), self["poster"].instance.size().height(), sc[0], sc[1], False, 1, "#00000000"))
		self.picload.startDecode(filename)

	def name(self):
		name = os_path.split(self.currentFilename)[1]
	        counttochra = int(name.count("."))
	        if "_" in name:
                    name = name.replace("_", " ")
	        if counttochra > 1:
                    cont = counttochra - 1
                    name = name.replace(".", " ", cont)
                return  name    
       
	def saveresult(self):
		name = self.name()
		list = [
			(_("Yes"), self.savePosterInfo),
			(_("Only poster"), self.savePoster),
			(_("No"), self.exitChoice),
		]
		self.session.openWithCallback(
			self.menuCallback,
			ChoiceBox,
			title= _("Save poster and info for:\n %s ?") % (name),
			list = list,
		)

	def menuCallback(self, ret = None):
		ret and ret[1]()
		
	def exitChoice(self):
		self.close()
		
	def savePoster(self):
		import os
		import shutil
                name = self.name()		
		if self.curResult and self.curPoster:
			if not fileExists("/media/hdd/covers"):
				try:
					os.makedirs("/media/hdd/covers")
				except OSError:
					pass
			if fileExists("/media/hdd/covers"):
				try:
					if fileExists("/tmp/preview.jpg"):
						shutil.copy2("/tmp/preview.jpg", "/media/hdd/covers/" + name + ".jpg")
						self.session.open(MessageBox, _("Poster %s saved!") % (name), MessageBox.TYPE_INFO, timeout=2)
				except OSError:
					pass

	def savePosterInfo(self):
		import os
		import shutil
                name = self.name()			
		if self.curResult:
			self.savedescrip()
		if not fileExists("/media/hdd/covers"):
			try:
				os.makedirs("/media/hdd/covers")
			except OSError:
				pass
		if fileExists("/media/hdd/covers"):
			try:
				if fileExists("/tmp/preview.jpg") and self.curPoster:
					shutil.copy2("/tmp/preview.jpg", "/media/hdd/covers/" + name + ".jpg")
					self.session.open(MessageBox, _("Poster %s saved!") % (name), MessageBox.TYPE_INFO, timeout=2)
			except OSError:
				pass

	def savedescrip(self):
		global movie2
		descrip = ""
		Extratext = ""
		namedetals = ""
		EITFILE2 = ""
		EITFILE3 = ""		
		filename = ""
		if config.plugins.tmbd.eit.value == "0":
		        if len(movie2):
                                if config.plugins.tmbd.movieselectionparts.value == "none":
			                EITFILE = movie2[:-2] + 'eit'
                                else:
                                        filename = os.path.split(movie2)[1]
                                        EITFILE = config.plugins.tmbd.movieselectionparts.value + "/" + filename[:-2] + 'eit'			                
		        else:
			        return
		else:
		        if len(movie2):
                                if config.plugins.tmbd.movieselectionparts.value == "none":
			               EITFILE = movie2[:-2] + 'txt'
			               EITFILE2 = movie2[:-2] + 'eit'
                                else:
                                        filename = os.path.split(movie2)[1]
                                        EITFILE = config.plugins.tmbd.movieselectionparts.value + "/" + filename[:-2] + 'txt'
                                        EITFILE2 = config.plugins.tmbd.movieselectionparts.value + "/" + filename[:-2] + 'eit'
                                        EITFILE3 = movie2[:-2] + 'eit'
		        else:
			        return
		if self.curResult:
                        if config.plugins.tmbd.movieselectionparts.value != "none":
		             if not fileExists(config.plugins.tmbd.movieselectionparts.value):
			            try:
				            os.makedirs(config.plugins.tmbd.movieselectionparts.value)
			            except OSError:
				            pass                    
			Extratext = "%s %s\n" % (_("Country:"), _("unknown"))
			if self.genre:
				Extratext += "%s %s\n" % (_("Genre:"), self.genre)
			if self.track and self.tracknr:	
			        descrip =  _("Tracknr: %s Track: %s\n") % (self.tracknr, self.track)
			if self.length:
				descrip += "%s /" % (self.length)
			if self.bitrate:
				descrip += "%s %s\n" % (_("Bitrate:"), self.bitrate)
			if self.artist:
				descrip += "%s %s\n" % (_("Actors:"), self.artist)
			if self.album:
				descrip += "%s %s\n" % (_("Album:"), self.album)
			if self.date:
				descrip += "%s %s\n" % (_("Appeared:"), self.date)
			if self.title:
				descrip += "%s %s\n" % (_("Origname:"), self.title)				
			Extratext = Extratext.replace('\xc2\xab', '"').replace('\xc2\xbb', '"').replace('\xe2\x80\xa6', '...').replace('\xe2\x80\x94', '-');
			Extratext = self.Cutext(Extratext)
			descrip = descrip.replace('\xc2\xab', '"').replace('\xc2\xbb', '"').replace('\xe2\x80\xa6', '...').replace('\xe2\x80\x94', '-');
			namedetals = self.title.replace('\xc2\xab', '"').replace('\xc2\xbb', '"').replace('\xe2\x80\xa6', '...').replace('\xe2\x80\x94', '-');
                        if config.plugins.tmbd.eit.value == "0":
			      sed = ShortEventDescriptor([]);
			      sed.setIso639LanguageCode('rus');
			      sed.setEventName(namedetals);
			      sed.setText(Extratext);
			      eed = ExtendedEventDescriptor([]);
			      eed.setIso639LanguageCode('rus');
			      eed.setText(descrip);
			      newEvent = Event();
			      newEvent.setShortEventDescriptor(sed);
			      newEvent.setExtendedEventDescriptor(eed);
			      ret = newEvent.saveToFile(EITFILE);
			      self.session.open(MessageBox, _("Write event to new eit-file:\n") + "%s\n" % (EITFILE) + _("%d bytes") % (ret), MessageBox.TYPE_INFO, timeout=3)
                        else:
		              if fileExists(EITFILE2):
                                   os.remove(EITFILE2)
		              elif fileExists(EITFILE3):
                                   os.remove(EITFILE3)                                   
                              fetchurl = "%s%s" % (Extratext, descrip)
                              temp_file = open(EITFILE, "w")
                              temp_file.write(fetchurl)
                              temp_file.close()
                              filesize = int(os.stat(EITFILE).st_size)
                              self.session.open(MessageBox, _("Write event to new txt-file:\n") + "%s\n" % (EITFILE) + _("%d bytes") % (filesize), MessageBox.TYPE_INFO, timeout=3)

	def Cutext(self, text):
		if text > 0:
			return text[:179]
		else:
			return text		

	def paintPosterPixmapCB(self, picInfo=None):
		ptr = self.picload.getData()
		if ptr != None:
			self["poster"].instance.setPixmap(ptr.__deref__())
			self["poster"].show()

	def exit(self):
            image = '/tmp/preview.jpg'
            if fileExists(image):
		try:
			os_system("rm -rf %s" % image)
		except:
			pass  	            
	    self.close()    
    
class MovielistProfileList(Screen):
	skin = """
		<screen position="center,center" size="380,80" title="%s">
			<widget name="list" position="5,5" size="370,75" />
		</screen>""" % _("Select Profile")

	def __init__(self, session, eventname):
		Screen.__init__(self, session)
		self.session = session
		self.eventname = eventname
		self["list"] = MenuList([])
		self["actions"] = ActionMap(["OkCancelActions"], {"ok": self.okClicked, "cancel": self.close}, -1)
		self.onLayoutFinish.append(self.showMenu)

	def showMenu(self):
		list = []
		if config.plugins.tmbd.movielist_profile.value == "2":
			list.append(_("kinopoisk.ru"))
			list.append(_("themoviedb.org"))
		if config.plugins.tmbd.movielist_profile.value == "1":
			list.append(_("themoviedb.org"))
			list.append(_("kinopoisk.ru"))
		self["list"].setList(list)

	def okClicked(self):
		sel = self["list"].getCurrent()
		if sel == _("kinopoisk.ru"):
			self.session.open(KinoRu, self.eventname, movielist = True)
		if sel == _("themoviedb.org"):
			self.session.open(TMBD, self.eventname, movielist = True)

def eventinfo(session, eventName="", **kwargs):
	if eventName != "":
		eventName = eventName.replace('"', '').replace('Х/Ф', '').replace('М/Ф', '').replace('Х/ф', '').replace('.', '')
		eventName = eventName.replace('(18+)', '').replace('18+', '').replace('(16+)', '').replace('16+', '').replace('(12+)', '').replace('12+', '').replace('(7+)', '').replace('7+', '').replace('(6+)', '').replace('6+', '').replace('(0+)', '').replace('0+', '')
		if config.plugins.tmbd.profile.value == "0":
			session.open(TMBD, eventName)
		else:
			session.open(KinoRu, eventName)
	else:
		ref = session.nav.getCurrentlyPlayingServiceReference()
		session.open(TMBDEPGSelection, ref)

from Screens import MovieSelection as myMovieSelection
myMovieSelection.defMovieContextMenu = myMovieSelection.MovieContextMenu

class newMovieContextMenu(myMovieSelection.defMovieContextMenu):
	try:
		def __init__(self, session, csel, service):
			myMovieSelection.defMovieContextMenu.__init__(self, session, csel,service)
			self.skinName = "MovieContextMenu"
			idx = 0
			if service:
				if (service.flags & eServiceReference.mustDescent):
					self["menu"].list.insert(idx, (_("TMBD Details"),boundFunction(movielist, session, service)))					
	except:
		pass

myMovieSelection.MovieContextMenu = newMovieContextMenu


def main(session, **kwargs):
	session.open(TMBDSettings)

def main3(session, eventName="", **kwargs):
	global eventname
	eventname = ""
	s = session.nav.getCurrentService()
	info = s and s.info()
	event = info and info.getEvent(0)	# 0 = now
	if config.plugins.tmbd.ext_menu_event.value == "0":
		if event:
			eventName = event.getEventName().split("(")[0].strip()
			eventname = eventName.replace('"', '').replace('Х/Ф', '').replace('М/Ф', '').replace('Х/ф', '').replace('.', '')
			eventname = eventname.replace('(18+)', '').replace('18+', '').replace('(16+)', '').replace('16+', '').replace('(12+)', '').replace('12+', '').replace('(7+)', '').replace('7+', '').replace('(6+)', '').replace('6+', '').replace('(0+)', '').replace('0+', '')
			if config.plugins.tmbd.profile.value == "0":
				session.open(TMBD, eventname)
			else:
				session.open(KinoRu, eventname)
		else:
			if config.plugins.tmbd.no_event.value:
				if config.plugins.tmbd.profile.value == "0":
					session.open(TMBD, eventname)
				else:
					session.open(KinoRu, eventname)
	else:
		EventChoiseList(session)

from keyids import KEYIDS
from enigma import eActionMap

class TMBDInfoBar:
	def __init__(self, session, infobar):
		self.session = session
		self.infobar = infobar
		self.lastKey = None
		self.hotkeys = { }
		for x in TMBDInfoBarKeys:
			self.hotkeys[x[0]] = [KEYIDS[key] for key in x[2]]
		eActionMap.getInstance().bindAction('', -10, self.keyPressed)

	def keyPressed(self, key, flag):
		for k in self.hotkeys[config.plugins.tmbd.hotkey.value]:
			if key == k and self.session.current_dialog == self.infobar:
				if flag == 0:
					self.lastKey = key
				elif self.lastKey != key or flag == 4:
					self.lastKey = None
					continue
				elif flag == 3:
					self.lastKey = None
					self.execute()
				elif flag == 1:
					self.lastKey = None
					self.showChoiceEvent()
				return 1
		return 0
		
	def execute(self):
		self.session.open(TMBDSettings)

	def showChoiceEvent(self):
		global eventname
		eventname = ""
		s = self.session.nav.getCurrentService()
		info = s and s.info()
		event = info and info.getEvent(0)	# 0 = now
		if config.plugins.tmbd.ext_menu_event.value == "0":
			if event:
				eventName = event.getEventName().split("(")[0].strip()
				eventname = eventName.replace('"', '').replace('Х/Ф', '').replace('М/Ф', '').replace('Х/ф', '').replace('.', '')
				eventname = eventname.replace('(18+)', '').replace('18+', '').replace('(16+)', '').replace('16+', '').replace('(12+)', '').replace('12+', '').replace('(7+)', '').replace('7+', '').replace('(6+)', '').replace('6+', '').replace('(0+)', '').replace('0+', '')
				if config.plugins.tmbd.profile.value == "0":
					self.session.open(TMBD, eventname)
				else:
					self.session.open(KinoRu, eventname)
			else:
				if config.plugins.tmbd.no_event.value:
					if config.plugins.tmbd.profile.value == "0":
						self.session.open(TMBD, eventname)
					else:
						self.session.open(KinoRu, eventname)
		else:
			self.EventChoiselist()

	def EventChoiselist(self):
		global eventname, eventname_now, eventname_next
		cur_name = ""
		eventname = ""
		eventname_now = ""
		eventname_next = ""
		profile = ""
		cur_ref = self.session.nav.getCurrentlyPlayingServiceReference()
		if cur_ref:
			refstr = cur_ref.toString()
			cur_name = ServiceReference(eServiceReference(refstr)).getServiceName()
		s = self.session.nav.getCurrentService()
		info = s and s.info()
		event_now = info and info.getEvent(0)	# 0 = now
		if event_now:
			eventName = event_now.getEventName().split("(")[0].strip()
			eventname_now = eventName.replace('"', '').replace('Х/Ф', '').replace('М/Ф', '').replace('Х/ф', '').replace('.', '').replace('18+', '').replace('(16+)', '').replace('16+', '').replace('(12+)', '').replace('12+', '').replace('(7+)', '').replace('7+', '').replace('(6+)', '').replace('6+', '').replace('(0+)', '').replace('0+', '')
		event_next = info and info.getEvent(1)	# 1 = next
		if event_next:
			eventName = event_next.getEventName().split("(")[0].strip()
			eventname_next = eventName.replace('"', '').replace('Х/Ф', '').replace('М/Ф', '').replace('Х/ф', '').replace('.', '').replace('18+', '').replace('(16+)', '').replace('16+', '').replace('(12+)', '').replace('12+', '').replace('(7+)', '').replace('7+', '').replace('(6+)', '').replace('6+', '').replace('(0+)', '').replace('0+', '')
		if event_now and event_next:
			keyslist = [ ]
			eventlist = [
			(_("Now: %s") % (eventname_now), self.Nowevent),
			(_("Next: %s") % (eventname_next), self.Nextevent),
			]
			if config.plugins.tmbd.profile.value == "0":
				profile = "themoviedb.org"
			else:
				profile = "kinopoisk.ru"
			keyslist.extend( [ "1", "2" ] )
			eventlist.append((_('Change profile'), self.ChangeProfile))
			keyslist.append('blue')
			dlg = self.session.openWithCallback(self.menuCallback,ChoiceBox,list = eventlist,keys = keyslist,title= _("%s\nProfile: %s\nSelect event for search:") % (cur_name, profile))
			dlg.setTitle(_("TMBD Details"))
		elif event_now and not event_next:
			self.Nowevent()
		else:
			if config.plugins.tmbd.no_event.value:
				if config.plugins.tmbd.profile.value == "0":
					self.session.open(TMBD, eventname, False)
				else:
					self.session.open(KinoRu, eventname, False)

	def ChangeProfile(self):
		if config.plugins.tmbd.profile.value == "0":
			config.plugins.tmbd.profile.value = "1"
		else:
			config.plugins.tmbd.profile.value = "0"
		config.plugins.tmbd.profile.save()

	def Nowevent(self):
		global eventname, eventname_now, eventname_next
		eventname = eventname_now
		if config.plugins.tmbd.profile.value == "0":
			self.session.open(TMBD, eventname, False)
		else:
			self.session.open(KinoRu, eventname, False)
	
	def Nextevent(self):
		global eventname, eventname_now, eventname_next
		eventname = eventname_next
		if config.plugins.tmbd.profile.value == "0":
			self.session.open(TMBD, eventname, False)
		else:
			self.session.open(KinoRu, eventname, False)
			
	def menuCallback(self, ret = None):
		ret and ret[1]()


def movielist(session, service, **kwargs):
	global name, movie2
	global eventname, dircontrol, number
	eventName = ""
	filename = ""
	serviceHandler = eServiceCenter.getInstance()
	info = serviceHandler.info(service)
	name2 = info and info.getName(service) or ''
	extension = service.getPath()
	filename = os.path.realpath(service.getPath())
	if ".iso" in extension:
             dircontrol = False
             mp3ntrol = False
             name = os.path.split(extension)[1]
             eventName = name.split(".")[0].strip()
             eventname = eventName
	elif ".mp3" in extension:
             dircontrol = False
             mp3ntrol = True
             eventname = filename
	else:
	    counttochra = int(name2.count("."))
	    if "_" in name2:
                name2 = name2.replace("_", " ")
	    if counttochra > 1:
                cont = counttochra - 1
                name2 = name2.replace(".", " ", cont)
	    if service and (service.flags & eServiceReference.isDirectory):
	         from os import path
	         number = '%s' % (os.path.dirname(extension))
	         if number != "":
                     dircontrol = True
                     mp3ntrol = False
	             p = os.path.split(number)
	             if not p[1]:
		         p = os.path.split(p[0])            
                     name = '%s' % (p[1])
                     eventName = name
            else:
                dircontrol = False
                mp3ntrol = False
                name = name2
                eventName = name.split(".")[0].strip()
	    eventname = eventName
        if dircontrol:
            movie2 = extension
        else:
            movie2 = filename
        if mp3ntrol:
            session.open(MP3, eventname)
        else:    
	    if config.plugins.tmbd.movielist_profile.value == "0":
		if config.plugins.tmbd.profile.value == "0":
			session.open(TMBD, eventname, movielist = True)
		else:
			session.open(KinoRu, eventname, movielist = True)
	    else:
		session.open(MovielistProfileList, eventname)
		
def autostart_ChannelContextMenu(session, **kwargs):
	TMBDChannelContextMenuInit()
	
baseInfoBar__init__ = None
def tmbdInfoBar__init__(self, session):
	baseInfoBar__init__(self, session)
	self.tmbdinfobar = TMBDInfoBar(session, self)

def autostart(reason, **kwargs):
	if reason == 0:
		global baseInfoBar__init__
		skinInit()
		from Screens.InfoBar import InfoBar
		if baseInfoBar__init__ is None:
			baseInfoBar__init__ = InfoBar.__init__
		InfoBar.__init__ = tmbdInfoBar__init__
		try:
			EPGSelectionInit()
		except Exception:
			pass
		if fileExists("/usr/lib/enigma2/python/Plugins/Extensions/GraphMultiEPG/plugin.pyo") or fileExists("/usr/lib/enigma2/python/Plugins/Extensions/GraphMultiEPG/plugin.pyc"):
			try:
				GraphMultiEPGInit()
			except Exception:
				pass
		if fileExists("/usr/lib/enigma2/python/Plugins/Extensions/nStreamVOD/plugin.pyo") or fileExists("/usr/lib/enigma2/python/Plugins/Extensions/nStreamVOD/plugin.pyc"):
			try:
				nStreamVODInit()
			except Exception:
				pass
                if fileExists("/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/plugin.pyo") or fileExists("/usr/lib/enigma2/python/Plugins/Extensions/CoolTVGuide/plugin.pyc"):
                        from Plugins.Extensions.CoolTVGuide.plugin import CoolTVGuide
                        from Plugins.Extensions.CoolTVGuide.CoolEasyGuide import CoolEasyGuide
                        from Plugins.Extensions.CoolTVGuide.CoolChannelGuide import CoolChannelGuide
                        from Plugins.Extensions.CoolTVGuide.CoolSingleGuide import CoolSingleGuide
                        from Plugins.Extensions.CoolTVGuide.CoolInfoGuide import CoolInfoGuide
		        global def_CoolTVGuide_iypxwy, def_CoolTVGuide_pyluqz, def_CoolEasyGuide_tutpnw, def_CoolEasyGuide_suxwuy, def_CoolChannelGuide_vnqvmy, def_CoolChannelGuide_zunyxk, def_CoolSingleGuide_wzwsvn, def_CoolSingleGuide_pwxiku
                        global def_CoolInfoGuide_yqlnqm, def_CoolInfoGuide_jzuswv
		        if def_CoolTVGuide_pyluqz is None:
			        def_CoolTVGuide_pyluqz = CoolTVGuide.pyluqz
			        CoolTVGuide.pyluqz = new_CoolTVGuide_pyluqz		        
		        if def_CoolTVGuide_iypxwy is None:
			        def_CoolTVGuide_iypxwy = CoolTVGuide.iypxwy
			        CoolTVGuide.iypxwy = new_CoolTVGuide_iypxwy
		        if def_CoolEasyGuide_suxwuy is None:
			        def_CoolEasyGuide_suxwuy = CoolEasyGuide.suxwuy
			        CoolEasyGuide.suxwuy = new_CoolEasyGuide_suxwuy		        
		        if def_CoolEasyGuide_tutpnw is None:
			        def_CoolEasyGuide_tutpnw = CoolEasyGuide.tutpnw
			        CoolEasyGuide.tutpnw = new_CoolEasyGuide_tutpnw
		        if def_CoolChannelGuide_zunyxk is None:
			        def_CoolChannelGuide_zunyxk = CoolChannelGuide.zunyxk
			        CoolChannelGuide.zunyxk = new_CoolChannelGuide_zunyxk		        
		        if def_CoolChannelGuide_vnqvmy is None:
			        def_CoolChannelGuide_vnqvmy = CoolChannelGuide.vnqvmy
			        CoolChannelGuide.vnqvmy = new_CoolChannelGuide_vnqvmy			        
		        if def_CoolSingleGuide_pwxiku is None:
			        def_CoolSingleGuide_pwxiku = CoolSingleGuide.pwxiku
			        CoolSingleGuide.pwxiku = new_CoolSingleGuide_pwxiku
		        if def_CoolSingleGuide_wzwsvn is None:
			        def_CoolSingleGuide_wzwsvn = CoolSingleGuide.wzwsvn
			        CoolSingleGuide.wzwsvn = new_CoolSingleGuide_wzwsvn			        
		        if def_CoolInfoGuide_yqlnqm is None:
			        def_CoolInfoGuide_yqlnqm = CoolInfoGuide.yqlnqm
			        CoolInfoGuide.yqlnqm = new_CoolInfoGuide_yqlnqm
		        if def_CoolInfoGuide_jzuswv is None:
			        def_CoolInfoGuide_jzuswv = CoolInfoGuide.jzuswv
			        CoolInfoGuide.jzuswv = new_CoolInfoGuide_jzuswv
		else:
                       pass

def maincomponents(session, **kwargs):
	session.open(Instalcomponents)

def Plugins(**kwargs):
	if config.plugins.tmbd.add_ext_menu.value:
		return [PluginDescriptor(name=_("TMBD Details"),
				description=_("Setup menu"),
				icon="tmdb.png",
				where=PluginDescriptor.WHERE_PLUGINMENU,
				fnc=main,
				),
				PluginDescriptor(name=_("Components for TMBD"),
				description = _("Installing components for TMBD"),
				icon="tmdb.png",
				where=PluginDescriptor.WHERE_PLUGINMENU,
				fnc=maincomponents,
				),
				PluginDescriptor(name=_("TMBD Details"),
				description=_("Query details from the Internet Movie Database"),
				where=PluginDescriptor.WHERE_EVENTINFO,
				fnc=eventinfo,
				),
				PluginDescriptor(
				description = _("TMBD Details"),
				where = PluginDescriptor.WHERE_MOVIELIST,
				fnc = movielist,
				),
				PluginDescriptor(
				where = PluginDescriptor.WHERE_SESSIONSTART,
				fnc = autostart_ChannelContextMenu,
				),
				PluginDescriptor(
				where = PluginDescriptor.WHERE_AUTOSTART,
				fnc = autostart,
				),
				PluginDescriptor(name=_("TMBD Details:current event"),
				description=_("Query details from the Internet Movie Database"),
				where=PluginDescriptor.WHERE_EXTENSIONSMENU,
				fnc=main3,
				),
		]
	else:
		return [PluginDescriptor(name=_("TMBD Details"),
				description=_("Setup menu"),
				icon="tmdb.png",
				where=PluginDescriptor.WHERE_PLUGINMENU,
				fnc=main,
				),
				PluginDescriptor(name=_("TMBD Details"),
				description=_("Query details from the Internet Movie Database"),
				where=PluginDescriptor.WHERE_EVENTINFO,
				fnc=eventinfo,
				),
				PluginDescriptor(name=_("Components for TMBD"),
				description = _("Installing components for TMBD"),
				icon="tmdb.png",
				where=PluginDescriptor.WHERE_PLUGINMENU,
				fnc=maincomponents,
				),
				PluginDescriptor(
				description = _("TMBD Details"),
				where = PluginDescriptor.WHERE_MOVIELIST,
				fnc = movielist,
				),
				PluginDescriptor(
				where = PluginDescriptor.WHERE_SESSIONSTART,
				fnc = autostart_ChannelContextMenu,
				),
				PluginDescriptor(
				where = PluginDescriptor.WHERE_AUTOSTART,
				fnc = autostart,
				),
       
			]
